      SUBROUTINE DIPOLSUM(P,X,PSWGT,SUBTRACT)
C  
C Generated by MadGraph II                                              
C RETURNS SUM OVER ALL DIPOLS
C FOR THE POINT IN PHASE SPACE P(0:3,NEXTERNAL)
C  
C FOR PROCESS : d d~ -> a a s s~  
C  
      IMPLICIT NONE
      include "nexternal.inc" 
      include "dipole.inc" 
      include "coupl.inc"
C  
C ARGUMENTS 
C  
      REAL*8 P(0:3,NEXTERNAL),X(2),PSWGT,SUBTRACT
C  
C GLOBAL 
C  
      REAL*8 dot
      LOGICAL PASSCUTSDIP
      EXTERNAL dot, PASSCUTSDIP
C  
C LOCAL
C  
      REAL*8 sij,sik,sjk,q(0:3),qsq,yp,P1(0:3,NEXTERNAL),pdfwgt
      REAL*8 y_ijk,omx_ija,u_i,vtilde_i
      REAL*8 mass_i,mass_j,mass_k,mass_ij
      REAL*8 msq_i,msq_j,msq_k,msq_ij,mu_i,mu_j,mu_k
      REAL*8 one,two,three,four
      parameter (one=1d0,two=2d0,three=3d0,four=4d0)
      REAL*8 ANS(   2)
      REAL*8 ZERO
      INTEGER NU
      PARAMETER (ZERO=0D0)
C  
C BEGIN CODE
C  
      INTDIPOLE=.FALSE.
      SUBTRACT=0d0
       
      sij=dot(p(0, 5),p(0, 6))
      sjk=dot(p(0, 6),p(0, 1))
      sik=dot(p(0, 5),p(0, 1))
      omx_ija=sij/(sjk+sik)
      CALL TRANSFORM(P,P1, 5, 6, 1, 5, 1,ZERO    ,ZERO    ,ZERO    )
      IF(PASSCUTSDIP(P1, 6)) THEN
      IF (alpha_fi .gt.omx_ija) THEN
      CALL DIPOLEPDF(x(1),x(2),  1, -1,pdfwgt)
       CALL SDIPOL001(P,ANS(   1))
       SUBTRACT = SUBTRACT - ANS(   1)*PDFWGT
       CALL WRITEHIST(P1,ANS(   1)*PSWGT*PDFWGT)
      ENDIF
      ENDIF
       
      sij=dot(p(0, 5),p(0, 6))
      sjk=dot(p(0, 6),p(0, 2))
      sik=dot(p(0, 5),p(0, 2))
      omx_ija=sij/(sjk+sik)
      CALL TRANSFORM(P,P1, 5, 6, 2, 5, 2,ZERO    ,ZERO    ,ZERO    )
      IF(PASSCUTSDIP(P1, 6)) THEN
      IF (alpha_fi .gt.omx_ija) THEN
      CALL DIPOLEPDF(x(1),x(2),  1, -1,pdfwgt)
       CALL SDIPOL002(P,ANS(   2))
       SUBTRACT = SUBTRACT - ANS(   2)*PDFWGT
       CALL WRITEHIST(P1,ANS(   2)*PSWGT*PDFWGT)
      ENDIF
      ENDIF
      RETURN
      END
C  
C  
C  
C  
C  
      SUBROUTINE DIPOLSUMFINITE(P,X,PSWGT,SUBTRACT)
C  
C Generated by MadGraph II                                              
C RETURNS SUM OVER "NON-DIVERGENT" DIPOLS,
C I.E. DIPOLES FOR WHICH THE UNRESOLVED IS
C MASSIVE (IN particles.dat MASS IS NOT
C EQUAL TO "ZERO")
C FOR THE POINT IN PHASE SPACE P(0:3,NEXTERNAL)
C  
C FOR PROCESS : d d~ -> a a s s~  
C  
      IMPLICIT NONE
      include "nexternal.inc" 
      include "dipole.inc" 
      include "coupl.inc"
C  
C ARGUMENTS 
C  
      REAL*8 P(0:3,NEXTERNAL),X(2),PSWGT,SUBTRACT
C  
C GLOBAL 
C  
      REAL*8 dot
      LOGICAL PASSCUTSDIP
      EXTERNAL dot, PASSCUTSDIP
C  
C LOCAL
C  
      REAL*8 sij,sik,sjk,q(0:3),qsq,yp,P1(0:3,NEXTERNAL),pdfwgt
      REAL*8 y_ijk,omx_ija,u_i,vtilde_i
      REAL*8 mass_i,mass_j,mass_k,mass_ij
      REAL*8 msq_i,msq_j,msq_k,msq_ij,mu_i,mu_j,mu_k
      REAL*8 one,two,three,four
      parameter (one=1d0,two=2d0,three=3d0,four=4d0)
      REAL*8 ANS(   2)
      REAL*8 ZERO
      INTEGER NU
      PARAMETER (ZERO=0D0)
C  
C BEGIN CODE
C  
      INTDIPOLE=.FALSE.
      SUBTRACT=0d0
      RETURN
      END
C  
C  
C  
C  
C  
      SUBROUTINE DIPOLEPDF(x1,x2,leg1,leg2,WGT)
      IMPLICIT NONE
      include "nexternal.inc"
      include "dipole.inc"
      include "run.inc"
      include "genps.inc"
      double precision X1,X2,WGT
      integer leg1,leg2
      integer iproc,icross,lp
      DOUBLE PRECISION PD(0:MAXPROC)
      COMMON /SubProc/ PD, IPROC
      double precision pdfarray1(-5:5), pdfarray2(-5:5)
      common /pdfarray/ pdfarray1,pdfarray2
      DOUBLE PRECISION u1,ub1,d1,db1,c1,cb1,s1,sb1,b1,bb1
      DOUBLE PRECISION u2,ub2,d2,db2,c2,cb2,s2,sb2,b2,bb2
      DOUBLE PRECISION g1,g2
      DOUBLE PRECISION a1,a2,pdg2pdf
      DATA u1,ub1,d1,db1,c1,cb1,s1,sb1,b1,bb1/10*1d0/
      DATA u2,ub2,d2,db2,c2,cb2,s2,sb2,b2,bb2/10*1d0/
      DATA a1,g1/2*1d0/
      DATA a2,g2/2*1d0/

      IF (x1.gt.1d0 .or. x2.gt.1d0) THEN
         WGT=0d0
         RETURN
      ENDIF

         IF (ABS(LPP(1)) .GE. 1) THEN
            LP=SIGN(1,LPP(1))
             d1= PDG2PDF(ABS(LPP(1)), 1*LP,x1,DSQRT(Q2FACT(1)))
             s1= PDG2PDF(ABS(LPP(1)), 3*LP,x1,DSQRT(Q2FACT(1)))  
             c1= PDG2PDF(ABS(LPP(1)), 4*LP,x1,DSQRT(Q2FACT(1))) 
             u1= PDG2PDF(ABS(LPP(1)), 2*LP,x1,DSQRT(Q2FACT(1)))
             b1= PDG2PDF(ABS(LPP(1)), 5*LP,x1,DSQRT(Q2FACT(1)))
             db1= PDG2PDF(ABS(LPP(1)),-1*LP,x1,DSQRT(Q2FACT(1)))
             sb1= PDG2PDF(ABS(LPP(1)),-3*LP,x1,DSQRT(Q2FACT(1)))
             cb1= PDG2PDF(ABS(LPP(1)),-4*LP,x1,DSQRT(Q2FACT(1)))              
             ub1= PDG2PDF(ABS(LPP(1)),-2*LP,x1,DSQRT(Q2FACT(1)))
             bb1= PDG2PDF(ABS(LPP(1)),-5*LP,x1,DSQRT(Q2FACT(1)))
             pdfarray1(-5)=bb1
             pdfarray1(-4)=cb1
             pdfarray1(-3)=sb1
             pdfarray1(-2)=ub1
             pdfarray1(-1)=db1
             pdfarray1(0)=0d0
             pdfarray1(1)=d1
             pdfarray1(2)=u1
             pdfarray1(3)=s1
             pdfarray1(4)=c1
             pdfarray1(5)=b1
         ENDIF
         IF (ABS(LPP(2)) .GE. 1) THEN
            LP=SIGN(1,LPP(2))
             d2= PDG2PDF(ABS(LPP(2)), 1*LP,x2,DSQRT(Q2FACT(2)))               
             u2= PDG2PDF(ABS(LPP(2)), 2*LP,x2,DSQRT(Q2FACT(2)))
             s2= PDG2PDF(ABS(LPP(2)), 3*LP,x2,DSQRT(Q2FACT(2)))               
             c2= PDG2PDF(ABS(LPP(2)), 4*LP,x2,DSQRT(Q2FACT(2)))
             b2= PDG2PDF(ABS(LPP(2)), 5*LP,x2,DSQRT(Q2FACT(2)))
             db2= PDG2PDF(ABS(LPP(2)),-1*LP,x2,DSQRT(Q2FACT(2)))               
             ub2= PDG2PDF(ABS(LPP(2)), -2*LP,x2,DSQRT(Q2FACT(2)))
             sb2= PDG2PDF(ABS(LPP(2)),-3*LP,x2,DSQRT(Q2FACT(2)))               
             cb2= PDG2PDF(ABS(LPP(2)),-4*LP,x2,DSQRT(Q2FACT(2)))
             bb2= PDG2PDF(ABS(LPP(2)),-5*LP,x2,DSQRT(Q2FACT(2)))
             pdfarray2(-5)=bb2
             pdfarray2(-4)=cb2
             pdfarray2(-3)=sb2
             pdfarray2(-2)=ub2
             pdfarray2(-1)=db2
             pdfarray2(0)=0d0
             pdfarray2(1)=d2
             pdfarray2(2)=u2
             pdfarray2(3)=s2
             pdfarray2(4)=c2
             pdfarray2(5)=b2
         ENDIF
         PD(0) = 0d0
         IPROC = 0
         IPROC=IPROC+1      ! d d~ -> a a s s~                           
         PD(IPROC)=2d0*(d1*db2+db1*d2 +s1*sb2+sb1*s2+b1*bb2+bb1*b2)+
     &	        16d0*(u1*ub2+ub1*u2+c1*cb2+cb1*c2)                         

                                                                                                                        


       WGT=PD(IPROC)
      END
       
       
       
      SUBROUTINE WRITEHIST(P,WGT)
      IMPLICIT NONE
      include "nexternal.inc"
      DOUBLE PRECISION P(0:3,NEXTERNAL),WGT
      double precision pres(0:3,nexternal)
      common/res_mom/pres

      call write_me_hist(P,WGT)
      END
       
      LOGICAL FUNCTION PASSCUTSDIP(P,j)
      IMPLICIT NONE
C This is a template for a routine that puts cuts on each
C individual dipole, e.g. a jet algorithm. The input variable
C is the phase space point P. If event passes the cut, this
C function has to be set TRUE.

      include "nexternal.inc"
      DOUBLE PRECISION P(0:3,NEXTERNAL)
      integer j


C Set to TRUE by default.
      PASSCUTSDIP=.TRUE.

      END
       
       
