      SUBROUTINE INTDIPOLES(P,X,Z,PSWGT,EPS,EPSSQ,FIN)
C  
C Generated by MadGraph II                                              
C RETURNS COEFFICIENTS OF 1/eps^2,1/eps AND FINITE TERMS
C FOR THE POINT IN PHASE SPACE P(0:3,NEXTERNAL) 
C  
C FOR PROCESS : d d~ -> a a s s~  
C WHERE Z IS THE MOMENTUM FRACTION OF THE INITAL EMITTER/SPECTATOR.
C  
      IMPLICIT NONE
      include "nexternal.inc" 
      include "dipole.inc" 
      include "coupl.inc"
C  
C ARGUMENTS 
C  
      REAL*8 P(0:3,NEXTERNAL),X(2),Z,PSWGT
      REAL*8 EPS,EPSSQ,FIN
C  
C GLOBAL 
C  
      REAL*8 dot,lambda_tr
      LOGICAL PASSCUTSDIP
      EXTERNAL dot,lambda_tr,PASSCUTSDIP
C  
C LOCAL
C  
      REAL*8 sij,sik,sjk,zp,e,esq,pdfwgt(3),FINITE(3)
      REAL*8 y_ijk,omx_ija,u_i,vtilde_i,zplus
      REAL*8 mass_i,mass_j,mass_k,mass_ij
      REAL*8 msq_i,msq_j,msq_k,msq_ij,sikzone
      REAL*8 musq_i,musq_j,musq_k,musq_ij
      REAL*8 vij,vtildeij,rho_i,rho_k,rho,qsq
      REAL*8 one,two,three,four,cf,ca,qtot(0:3),pi
      REAL*8 gsq,gammaE,ff,fi(9)
      parameter (one=1d0,two=2d0,three=3d0,four=4d0)
      parameter (cf=4d0/3d0,ca=3d0)
      REAL*8 ANS(   2)
      REAL*8 ZERO
      INTEGER NU
      PARAMETER (ZERO=0D0)
      PARAMETER (gammaE=0.57721566d0)
      PARAMETER (pi=3.1415926d0)
C  
C BEGIN CODE
C  
      INTDIPOLE=.TRUE.
      gsq=GG(1)**2
      eps=0d0
      epssq=0d0
      fin=0d0
      e=0d0
      esq=0d0
      DO NU=1,3
         finite(NU)=0d0
      ENDDO
      DO NU=1,   2
         ANS(NU)=0d0
      ENDDO
c      IF (PASSCUTSDIP(P,0)) THEN
       
      mass_i=ZERO 
      sik=two*dot(p(0,5),p(0,1))/z
      sikzone=two*dot(p(0,5),p(0,1))
      CALL DIPOLEPDF(x(1)/z,x(2),  1, -1,pdfwgt(1))
      CALL DIPOLEPDF(x(1),x(2),  1, -1,pdfwgt(2))
      CALL SDIPOL001(P,ANS(   1))
      CALL EPSFI(  0,  1,sikzone,mass_i,esq,e)
      epssq=epssq-esq*ANS(  1)*pdfwgt(2)
      eps=eps-e*ANS(  1)*pdfwgt(2)
      CALL FINITEFI(mass_i,sik,sikzone,z,  0,  1,fi)
      finite(1)=finite(1)-(fi(1)+fi(3))*ANS(  1)*pdfwgt(1)
      finite(2)=finite(2)-(fi(2)-fi(4))*ANS(  1)*pdfwgt(2)
       
      mass_i=ZERO 
      sik=two*dot(p(0,5),p(0,2))/z
      sikzone=two*dot(p(0,5),p(0,2))
      CALL DIPOLEPDF(x(1),x(2)/z,  1, -1,pdfwgt(1))
      CALL DIPOLEPDF(x(1),x(2),  1, -1,pdfwgt(2))
      CALL SDIPOL002(P,ANS(   2))
      CALL EPSFI(  0,  1,sikzone,mass_i,esq,e)
      epssq=epssq-esq*ANS(  2)*pdfwgt(2)
      eps=eps-e*ANS(  2)*pdfwgt(2)
      CALL FINITEFI(mass_i,sik,sikzone,z,  0,  1,fi)
      finite(1)=finite(1)-(fi(1)+fi(3))*ANS(  2)*pdfwgt(1)
      finite(2)=finite(2)-(fi(2)-fi(4))*ANS(  2)*pdfwgt(2)
       
c      ENDIF
      FIN=(FINITE(1)/z+FINITE(2))
c      CALL WRITEHIST(P,FIN)
      INTDIPOLE=.FALSE.
      RETURN
      END
       
       
       
       
       
      SUBROUTINE INTDIPOLESFINITE(P,X,Z,PSWGT,EPS,EPSSQ,FIN)
C  
C Generated by MadGraph II                                              
C RETURNS COEFFICIENTS OF 1/eps^2,1/eps AND FINITE TERMS
C FOR THE POINT IN PHASE SPACE P(0:3,NEXTERNAL) 
C  
C FOR PROCESS : d d~ -> a a s s~  
C WHERE Z IS THE MOMENTUM FRACTION OF THE INITAL EMITTER/SPECTATOR.
C  
      IMPLICIT NONE
      include "nexternal.inc" 
      include "dipole.inc" 
      include "coupl.inc"
C  
C ARGUMENTS 
C  
      REAL*8 P(0:3,NEXTERNAL),X(2),Z,PSWGT
      REAL*8 EPS,EPSSQ,FIN
C  
C GLOBAL 
C  
      REAL*8 dot,lambda_tr
      LOGICAL PASSCUTSDIP
      EXTERNAL dot,lambda_tr,PASSCUTSDIP
C  
C LOCAL
C  
      REAL*8 sij,sik,sjk,zp,e,esq,pdfwgt(3),FINITE(3)
      REAL*8 y_ijk,omx_ija,u_i,vtilde_i,zplus
      REAL*8 mass_i,mass_j,mass_k,mass_ij
      REAL*8 msq_i,msq_j,msq_k,msq_ij,sikzone
      REAL*8 musq_i,musq_j,musq_k,musq_ij
      REAL*8 vij,vtildeij,rho_i,rho_k,rho,qsq
      REAL*8 one,two,three,four,cf,ca,qtot(0:3),pi
      REAL*8 gsq,gammaE,ff,fi(9)
      parameter (one=1d0,two=2d0,three=3d0,four=4d0)
      parameter (cf=4d0/3d0,ca=3d0)
      REAL*8 ANS(   2)
      REAL*8 ZERO
      INTEGER NU
      PARAMETER (ZERO=0D0)
      PARAMETER (gammaE=0.57721566d0)
      PARAMETER (pi=3.1415926d0)
C  
C BEGIN CODE
C  
      INTDIPOLE=.TRUE.
      gsq=GG(1)**2
      eps=0d0
      epssq=0d0
      fin=0d0
      e=0d0
      esq=0d0
      zplus=1d0
      DO NU=1,3
         finite(NU)=0d0
      ENDDO
      DO NU=1,   2
         ANS(NU)=0d0
      ENDDO
c      IF (PASSCUTSDIP(P,0)) THEN
       
c      ENDIF
      INTDIPOLE=.FALSE.
      FIN=(FINITE(1)/z+FINITE(2)+FINITE(3))
      CALL WRITEHIST(P,FIN)
      RETURN
      END
