      DOUBLE PRECISION FUNCTION DSIG(PP,WGT)
C ****************************************************
C Generated by MadGraph II                                              
C     RETURNS DIFFERENTIAL CROSS SECTION
C     Input:
C             pp    4 momentum of external particles
C             wgt   weight from Monte Carlo
C     Output:
C             Amplitude squared and summed
C ****************************************************
      IMPLICIT NONE
C  
C CONSTANTS
C  
      include "genps.inc"
      include 'nexternal.inc'
      DOUBLE PRECISION       CONV
      PARAMETER (CONV=389379.66*1000)  !CONV TO PICOBARNS
      REAL*8     PI
      PARAMETER (PI=3.1415926d0)
C  
C ARGUMENTS 
C  
      DOUBLE PRECISION PP(0:3,NEXTERNAL), WGT
C  
C LOCAL VARIABLES 
C  
      INTEGER I, ICROSS,ITYPE,LP
      DOUBLE PRECISION P1(0:3,NEXTERNAL)
      DOUBLE PRECISION u1,ub1,d1,db1,c1,cb1,s1,sb1,b1,bb1
      DOUBLE PRECISION u2,ub2,d2,db2,c2,cb2,s2,sb2,b2,bb2
      DOUBLE PRECISION g1,g2
      DOUBLE PRECISION a1,a2
      DOUBLE PRECISION XPQ(-7:7)
      DOUBLE PRECISION DSIGUU,eps,epssq,finite,z,xz1,xz2,stot,pdf1z,pdf2z
      double precision epsqg, epssqqg, finiteqg(5), epsgg,epssqgg, finitegg(5)
      double precision u1z,ub1z,d1z,db1z,c1z,cb1z,s1z,sb1z,g1z
      double precision u2z,ub2z,d2z,db2z,c2z,cb2z,s2z,sb2z,g2z,ctq6pdf
      double precision rap,etamin,etamax,dot,mij,r2,pt
      double precision epsqed, epssqqed,finiteqed
C  
C EXTERNAL FUNCTIONS
C  
      LOGICAL PASSCUTS
      DOUBLE PRECISION ALPHAS2,REWGT,PDG2PDF
C  
C GLOBAL VARIABLES
C  
      INTEGER              IPROC
      DOUBLE PRECISION PD(0:MAXPROC)
      COMMON /SubProc/ PD, IPROC
      double precision pdfz,zi
      common /pdfz/ pdfz,zi
      include "coupl.inc"
      include "run.inc"
      include "dipole.inc"
      include "noncoll.inc"
C  
C DATA
C  
      DATA u1,ub1,d1,db1,c1,cb1,s1,sb1,b1,bb1/10*1d0/
      DATA u2,ub2,d2,db2,c2,cb2,s2,sb2,b2,bb2/10*1d0/
      DATA a1,g1/2*1d0/
      DATA a2,g2/2*1d0/
      DATA IPROC,ICROSS/1,1/
C ----------
C BEGIN CODE
C ----------
      DSIG = 0D0
      dsiguu=0d0
      finite=0d0
      finiteqed=0d0
       z=pdfz
        mu=dsqrt(q2fact(1)) 
       muf=dsqrt(q2fact(1))
       if(iso_type=='z_sep') then
         call intdipolesqed(pp,pp,pp,xbk,z,zi,wgt,epsqed,epssqqed,finiteqed,conv*wgt)
       endif
      IF(passcuts(pp)) then

c       if(fixed_ren_scale) then

       if (mu.eq.0d0) then
        write(*,*) 'Warning: Renormalization scale mu is zero ',
     &           'leading to singular terms. Set scale appropriately'
        stop
       endif
       if (muf.eq.0d0) then
	print*, 'Warning: Fatorization scale is zero ',
     &           'leading to singular terms. Set scale appropriately'
        stop
       endif
         z=pdfz
c       if(mij(pp(0,3),pp(0,4)).gt.159.2d0) then
c         print*, mij(pp(0,3),pp(0,4)), dsqrt(2d0*dot(pp(0,3),pp(0,4)))
c         print*, pp(:,1)
c         print*, pp(:,2)
c         print*, pp(:,3)
c         print*, pp(:,4)
c         print*, pp(:,5)
c         print*, ' ' 
c         print*, 'pt',pt(pp(0,3)),pt(pp(0,4)),pt(pp(0,5))
c         print*, 'rap', rap(pp(0,3)),rap(pp(0,4)),rap(pp(0,5))
c         print*, 'dr', dsqrt(r2(pp(0,3),pp(0,4))), dsqrt(r2(pp(0,3),pp(0,5))), dsqrt(r2(pp(0,4),pp(0,5)))
c         print*, ' ' 
c         print*, ' '
c        endif
       call intdipoles(pp,xbk,z,wgt,eps,epssq,finite)

      
        dsiguu=finite+finiteqed

         If (dsiguu .lt. 1d199) then
             dsig = conv * dsiguu
         else
             write(*,*) "Error in matrix element"
             dsiguu=0d0
             dsig = 0d0
         endif
c         call unwgt(pp,pd(iproc)*conv*dsiguu*wgt)
         call write_me_hist(pp,conv*finite*wgt)
      else
       dsig=conv*finiteqed
      ENDIF
      END
