#!/usr/bin/python
# -*- coding: utf-8 -*-
import os
import sys
import subprocess

cwd=os.getcwd()
srcdir=cwd+'/src'
sys.path.append(srcdir)

from proc_int import *

if __name__ == '__main__':
#  try:
#    procfile=file('../Cards/proc.dat')
#    procdir=procfile.readline()
#    procdir=procdir.split('\n')[0]
#  except IOError:
#    print 'File ../Cards/proc.dat not found. Enter process directory (full path):'
#    procdir=raw_input()
  procdir=os.getcwd()

  print ' '
  print 'This program starts and controls the integration routines'
  print ' '
  arch=subprocess.call('which qsub  >& /dev/null',shell=True)
  if arch==1:
    print ' '
    print 'No cluster environment detected, will use the PC version'
  if arch==0:
    print 'Found SGE, will use cluster version'
  print ' '
  print 'Choose one of the following options:'
  print ' (1) Integration of the tree-level contribution'
  print ' (2) Integration of the real emission contribution'
  print ' (3) Integration of the integrated subtraction terms'
  print ' (4) Integration of the virtual one-loop contribution'
  print ' (5) Full NLO calculation ( (1)-(4) )'
  print ' '
  nr=raw_input()
  if nr=='1':
    print 'Tree level integration'

    path=procdir+'/tree_level/SubProcesses'    

    newrun(path,arch,'proclist.txt')
    print 'Tree-level finished!'

  elif nr=='2':
    print 'Real emission integration'
    path=procdir+'/real_emission/SubProcesses'
    check_jetpt(path)
    compilesub(path,'proclist.txt')

    newrun(path,arch,'proclist.txt')
    print 'Real emission finished!'

  elif nr=='3':
    print 'Integration of integrated subtraction terms'

    path=procdir+'/int_sub/SubProcesses'    
    compilesub(path,'proclist.txt')

    newrun(path,arch,'proclist.txt')
    print 'Integrated subtraction terms finished!'

  elif nr=='4':
    print 'Integration of one-loop contribution'

    path=procdir+'/tree_level/SubProcesses'    


    newrun(path,arch,'proclist_virt.txt',sumfile='sumresults_virt.dat')
    print 'One-loop finished!'

  elif nr=='5':
    print '1. Tree level integration'

    path=procdir+'/tree_level/SubProcesses'    

    newrun(path,arch,'proclist.txt')
    print 'Tree-level finished!'

      
    print '2. Real emission integration'

    path=procdir+'/real_emission/SubProcesses'

    compilesub(path,'proclist.txt')

    newrun(path,arch,'proclist.txt')
    print 'Real emission finished!'


    print '3. Integration of integrated subtraction terms'
    path=procdir+'/int_sub/SubProcesses'    
    compilesub(path,'proclist.txt')

    newrun(path,arch,'proclist.txt')
    print 'Integrated subtraction terms finished!'


    print '4. Integration of one-loop contribution'

    path=procdir+'/tree_level/SubProcesses'    

    newrun(path,arch,'proclist_virt.txt',sumfile='sumresults_virt.dat')
    print 'One-loop finished!'

      
  else:
    print 'Not a valid option'
    sys.exit()

