      DOUBLE PRECISION FUNCTION DSIG(PP,WGT)                                                                            
C ****************************************************                                                                  
C Generated by MadGraph II                                                                                              
C     RETURNS DIFFERENTIAL CROSS SECTION                                                                                
C     Input:                                                                                                            
C             pp    4 momentum of external particles                                                                    
C             wgt   weight from Monte Carlo                                                                             
C     Output:                                                                                                           
C             Amplitude squared and summed                                                                              
C ****************************************************                                                                  
      IMPLICIT NONE                                                                                                     
C                                                                                                                       
C CONSTANTS                                                                                                             
C                                                                                                                       
      include "genps.inc"                                                                                               
      include "nexternal.inc" 
      include 'jets.inc'                            
      DOUBLE PRECISION       CONV                                                                                       
      PARAMETER (CONV=389379.66*1000)  !CONV TO PICOBARNS                                                               
      REAL*8     PI                                                                                                     
      PARAMETER (PI=3.1415926d0)                                                                                        
C                                                                                                                       
C ARGUMENTS                                                                                                             
C                                                                                                                       
      DOUBLE PRECISION PP(0:3,NEXTERNAL), WGT                                                                           
C                                                                                                                       
C LOCAL VARIABLES                                                                                                       
C                                                                                                                       
      INTEGER I, ICROSS,ITYPE,LP                                                                                        
      DOUBLE PRECISION P1(0:3,NEXTERNAL)                                                                                
      DOUBLE PRECISION u1,ub1,d1,db1,c1,cb1,s1,sb1,b1,bb1                                                               
      DOUBLE PRECISION u2,ub2,d2,db2,c2,cb2,s2,sb2,b2,bb2                                                               
      DOUBLE PRECISION g1,g2                                                                                            
      DOUBLE PRECISION a1,a2                                                                                            
      DOUBLE PRECISION XPQ(-7:7)                                                                                        
      DOUBLE PRECISION DSIGUU,dipsum,ctq6pdf,f,pjet(4,nexternal), jetp(4,nexternal),dipsumqed
      integer njets ,j                                                                                                  
      logical debug                                                                                                     
C                                                                                                                       
C EXTERNAL FUNCTIONS                                                                                                    
C                                                                                                                       
      LOGICAL PASSCUTS                                                                                                  
      DOUBLE PRECISION PDG2PDFERROR, PDFSET(40),pdfperror,pdfnerror                                                     
      DOUBLE PRECISION maxpdf,minpdf                                                                                    
      DOUBLE PRECISION ALPHAS2,REWGT,PDG2PDF                                                                            
C                                                                                                                       
C GLOBAL VARIABLES                                                                                                      
C                                                                                                                       
      INTEGER              IPROC                                                                                        
      logical checkp,jetcut,zcuts
      external checkp,jetcut,zcuts
      DOUBLE PRECISION PD(0:MAXPROC)                                                                                    
      COMMON /SubProc/ PD, IPROC                                                                                        
      include "coupl.inc"                                                                                               
      include "run.inc"                                                                                                 
      REAL*8 R2,DOT,ET,RAP,DJ,SumDot,pt,ALPHAS                                                                          
      logical cut_bw,setclscales                                                                                        
      external R2,DOT,ET,RAP,DJ,SumDot,pt,ALPHAS,cut_bw,setclscales  
      integer Ntot,Nnonzero,niter,nput(100)
      logical firstwrite
      real*8 checkxsec
      common /nmc/ Ntot,Nnonzero,checkxsec,niter
      common /nmc2/ nput,firstwrite                                                         
C                                                                                                                       
C DATA                                                                                                                  
C                                                                                                                       
      DATA u1,ub1,d1,db1,c1,cb1,s1,sb1,b1,bb1/10*1d0/                                                                   
      DATA u2,ub2,d2,db2,c2,cb2,s2,sb2,b2,bb2/10*1d0/                                                                   
      DATA a1,g1/2*1d0/                                                                                                 
      DATA a2,g2/2*1d0/                                                                                                 
      DATA IPROC,ICROSS/1,1/                                                                                            
C ----------                                                                                                            
C BEGIN CODE                                                                                                            
C ----------                                                                                                            
      DSIG = 0D0                                                                                                        
      dipsum=0d0                                                                                                        
      dipsumqed=0d0 
      debug=.false.
      firstwrite=.true.                                                                                                     
      IF (PASSCUTS(PP)) THEN                                                                                            
        do i=1,nexternal-1
         do j= 3,nexternal
          if(i.ne.j) then
           if(abs(dot(pp(0,i),pp(0,j)))/dot(pp(0,1),pp(0,2)).lt.1d-9) then
            dsig=0d0
c            print*, i,j, abs(dot(pp(0,i),pp(0,j)))/dot(pp(0,1),pp(0,2))
            return
           endif
          endif
         enddo
        enddo
                                                                                                                        

      call getjets(PP,jetp,njets,P1)

                                                                                                                        
                                                                                                                        
                                                                                                                        
c      if(njets.ge.(maxjets-1).and.jetcut(P1,njets,debug).eqv..true.) then 
      if(njets.ge.(maxjets-1).and.zcuts(PP,P1,njets).eqv..true.) then 


c #TAG PDF
         IF (ABS(LPP(1)) .GE. 1) THEN
            LP=SIGN(1,LPP(1))
             d1= PDG2PDF(ABS(LPP(1)), 1*LP,XBK(1),DSQRT(Q2FACT(1)))
             s1= PDG2PDF(ABS(LPP(1)), 3*LP,XBK(1),DSQRT(Q2FACT(1)))  
             c1= PDG2PDF(ABS(LPP(1)), 4*LP,XBK(1),DSQRT(Q2FACT(1))) 
             u1= PDG2PDF(ABS(LPP(1)), 2*LP,XBK(1),DSQRT(Q2FACT(1)))
             b1= PDG2PDF(ABS(LPP(1)), 5*LP,XBK(1),DSQRT(Q2FACT(1)))
             db1= PDG2PDF(ABS(LPP(1)),-1*LP,XBK(1),DSQRT(Q2FACT(1)))
             sb1= PDG2PDF(ABS(LPP(1)),-3*LP,XBK(1),DSQRT(Q2FACT(1)))
             cb1= PDG2PDF(ABS(LPP(1)),-4*LP,XBK(1),DSQRT(Q2FACT(1)))              
             ub1= PDG2PDF(ABS(LPP(1)),-2*LP,XBK(1),DSQRT(Q2FACT(1)))
             bb1= PDG2PDF(ABS(LPP(1)),-5*LP,XBK(1),DSQRT(Q2FACT(1)))
         ENDIF
         IF (ABS(LPP(2)) .GE. 1) THEN
            LP=SIGN(1,LPP(2))
             d2= PDG2PDF(ABS(LPP(2)), 1*LP,XBK(2),DSQRT(Q2FACT(2)))               
             u2= PDG2PDF(ABS(LPP(2)), 2*LP,XBK(2),DSQRT(Q2FACT(2)))
             s2= PDG2PDF(ABS(LPP(2)), 3*LP,XBK(2),DSQRT(Q2FACT(2)))               
             c2= PDG2PDF(ABS(LPP(2)), 4*LP,XBK(2),DSQRT(Q2FACT(2)))
             b2= PDG2PDF(ABS(LPP(2)), 5*LP,XBK(2),DSQRT(Q2FACT(2)))
             db2= PDG2PDF(ABS(LPP(2)),-1*LP,XBK(2),DSQRT(Q2FACT(2)))               
             ub2= PDG2PDF(ABS(LPP(2)), -2*LP,XBK(2),DSQRT(Q2FACT(2)))
             sb2= PDG2PDF(ABS(LPP(2)),-3*LP,XBK(2),DSQRT(Q2FACT(2)))               
             cb2= PDG2PDF(ABS(LPP(2)),-4*LP,XBK(2),DSQRT(Q2FACT(2)))
             bb2= PDG2PDF(ABS(LPP(2)),-5*LP,XBK(2),DSQRT(Q2FACT(2)))
         ENDIF
         PD(0) = 0d0
         IPROC = 0
         IPROC=IPROC+1      ! c u -> a a u c                             
         PD(IPROC)=PD(IPROC-1) +((c1+cb1)*(u2+ub2)+(u1+ub1)*(c2+cb2))+
     &             1d0/16d0*((d1+db1)*(s2+sb2+b2+bb2) +
     &                      (s1+sb1+b1+bb1)*(d2+db2)+
     *               (b1+bb1)*(s2+sb2)+(s1+sb1)*(b2+bb2))                                
                                                                                                                        


c #END TAG PDF
          CALL SMATRIX(PP,DSIGUU)  
          call write_me_hist(p1,pd(iproc)*conv*dsiguu*wgt)
      else                                                                                                              
       dsiguu=0d0                                                                                                       
      endif                                                                                                             
                                                                                                                        
                                                                                                                        
      ELSE                                                                                                              
       dsiguu =0d0                                                                                                      
                                                                                                                        
      ENDIF                                                                                                             
                                                                                                                        
         if(checkp(pp)) then                                                                                            
          CALL DIPOLSUM(PP,xbk,conv*wgt, dipsum)                                                                        
          CALL DIPOLSUMQED(PP,xbk,conv*wgt, dipsumqed) 
         endif                                                                                                          
                                                                                                                        
         dsiguu=(dsiguu*pd(iproc)-dipsum-dipsumqed)*rewgt(PP) 
                                                                                                                        
         If (abs(dsiguu) .lt. 1d20) then                                                                                
             dsig =  conv * dsiguu                                                                                      
         else                                                                                                           
             write(*,*) "Error in matrix element"                                                                       
             debug=.false.                                                                                              
         endif                                                                                                          
c         call unwgt(pp,pd(iproc)*conv*dsiguu*wgt)                                                                      
c      ENDIF                                                                                                            
      END                                                                                                               
