#!/usr/bin/python
# -*- coding: utf-8 -*-

import math

def getxsec(path):
  sumfile=open(path+'/sumresults.dat','r')
  xsec=0.0
  err=0.0
  while True:
    line=sumfile.readline()
    if len(line)==0:
      break
    xsec +=float(line.split()[0])
    err += float(line.split()[1])

  sumfile.close()
  return xsec, err
  
  
def getintegral(path,plot):
  plotfile=open(path+'/'+plot+'all.dat','r')
  firstbin=False
  secondbin=False
  line1=plotfile.readline()
  line2=plotfile.readline()
  binwidth=float(line2.split()[0])-float(line1.split()[0])
  plotfile.seek(0)
  integral=0.0
  while True:
    line=plotfile.readline()
    if len(line)==0:
      break
    integral += float(line.split()[1])*binwidth

  plotfile.close()
  return integral
  
  
def makebornplot(path,factor,plot):
  oldplot=open(path+'/'+plot+'all.dat','r')
  newplot=open('results/NLO/'+plot+'_LO.dat','w')
  while True:
    line=oldplot.readline()
    if len(line)==0:
      break
    nbin,dsig,err=line.split()
    newplot.write(nbin+'    '+str(float(dsig)*factor)+'    '+str(float(err)*factor)+'\n')
    
  oldplot.close()
  newplot.close()
  
  
def makenloplot(path,born_factor,real_factor,int_factor,virt_factor,plot,inclusive=False):
  oldbornplot=open(path+'/results/tree_level/'+plot+'all.dat','r')
  if inclusive:
    oldrealplot=open(path+'/results/real_emission/'+plot.replace('jet1','jet')+'all.dat','r')
    newplot=open('results/NLO/'+plot.replace('jet1','jet')+'_NLO.dat','w')
  else:
    oldrealplot=open(path+'/results/real_emission/'+plot+'all.dat','r')
    newplot=open('results/NLO/'+plot+'_NLO.dat','w')
  oldintplot=open(path+'/results/int_sub/'+plot+'all.dat','r')  
  oldvirtplot=open(path+'/results/virt/'+plot+'all.dat','r')
  print plot
  while True:
    line_born=oldbornplot.readline()
    if len(line_born)==0:
      break
    line_real=oldrealplot.readline()
    line_int=oldintplot.readline()
    line_virt=oldvirtplot.readline()
    nbin,dsig_born,err_born=line_born.split()
    nbin,dsig_real,err_real=line_real.split()
    nbin,dsig_int,err_int=line_int.split()
    nbin,dsig_virt,err_virt=line_virt.split()

    dsig_nlo=float(dsig_born)*born_factor+float(dsig_real)*real_factor \
             +float(dsig_int)*int_factor+ float(dsig_virt)*virt_factor
    err_nlo=math.sqrt((float(err_born)*born_factor)**2+(float(err_real)*real_factor)**2 \
             +(float(err_int)*int_factor)**2+ (float(err_virt)*virt_factor)**2)
    
    newplot.write(nbin+'    '+str(dsig_nlo)+'    '+str(err_nlo)+'\n')
    
  oldbornplot.close()
  oldrealplot.close()
  oldintplot.close()
  oldvirtplot.close()


def makenlo_inclusiveplot(path,born_factor,real_factor,int_factor,virt_factor,plot):
  plotfile1=open(path+'/results/real_emission/'+plot+'all.dat','r')
  plot2=plot.replace('jet1','jet2')
  plotfile2=open(path+'/results/real_emission/'+plot2+'all.dat','r')
  newplot=open(path+'/results/real_emission/'+plot.replace('jet1','jet')+'all.dat','w')
  while True:
    line1=plotfile1.readline()
    if len(line1)==0:
      break
    line2=plotfile2.readline()
    nbin,dsig1,err1=line1.split()
    nbin,dsig2,err2=line2.split()
    dsig_new=float(dsig1)+float(dsig2)
    err_new=math.sqrt(float(err1)**2+float(err2)**2)
    newplot.write(nbin+'    '+str(dsig_new)+'    '+str(err_new)+'\n')
    
  plotfile1.close()
  plotfile2.close()
  newplot.close()

  makenloplot(path,born_factor,real_factor,int_factor,virt_factor,plot,True)
