#!/usr/bin/python
# -*- coding: utf-8 -*-
import sys
import os
import random
import re
import os.path
import subprocess
import shutil

cwd=os.getcwd()
srcdir=cwd+'src'
sys.path.append(srcdir)

def getchannel(proc):
    mfile=open(proc+'/matrix.f',"r")
    while True:
      line=mfile.readline()
      if len(line)==0:
	break
      if line.find('NGRAPHS=')>0:
	part1=line.split(',')[0]
	pattern=re.compile('\d+')
	nrchannel=pattern.search(part1).group(0)
    r1=random.random()
    channel=int(r1*int(nrchannel))
    if channel==0:
      channel=1
    if channel>int(nrchannel):
      channel=int(nrchannel)
    return str(channel)


def newrun(path,arch,listfile,sumfile='sumresults.dat'):
  os.chdir(path)
  print 'Number of points per iteration (10 iterations will be done)'
  points=raw_input()
#  print 'Number of iterations (Note: Only 10 iterations will'\
#     'give a correct result for the bin error in the histograms at the moment)'
#  it=raw_input()
  print 'Should the integration channel be picked randomly (y/n)?'
  config=raw_input()
  print 'Should a random seed be used (y/n)?'
  seed=raw_input()
  print 'How many cores do you want to use?'
  cores=raw_input()
  proclist=file(listfile)
  while True:
    line=proclist.readline()
    if len(line)==0:
      break
    proc=line.split('\n')[0]
    os.chdir(path+'/'+proc)
    inputfile=open('inputfile1.in',"w")
    inputfile.write(points+'\n')
    inputfile.write('10\n')
    inputfile.write('0\n')
    inputfile.write('2\n')
    inputfile.write('0\n')
    inputfile.write('0\n')
    if config=='y':
      channel=getchannel(path+'/'+proc)
    else:
      print proc
      print 'Enter number of channel'
      channel=raw_input()
    inputfile.write(channel+'\n')
    inputfile.write('1\n')
    if seed=='y':
      r1=random.random()
      r1int=int(r1*10000)
      r2=random.random()
      r2int=int(r2*10000)
      inputfile.write(str(r1int)+' '+str(r2int)+'\n')
    else:
      print proc
      print 'Enter the seed (2 numbers between 0 and 9999)'
      seednumbers=raw_input()
      inputfile.write(seednumbers+'\n')
    inputfile.close()

#Finished preparation, getting started
# First, PC version
  os.chdir(path)
  if arch==1:
    if sumfile=='sumresults_virt.dat':
      if os.path.isfile('sumresults_virt.dat'):
        os.remove('sumresults_virt.dat')
        subprocess.Popen('rm *all.dat >& /dev/null',shell=True)
    else:
      if os.path.isfile('sumresults.dat'): 
        os.remove('sumresults.dat')
        subprocess.Popen('rm *all.dat >& /dev/null',shell=True)
    print ' '
    os.chdir(path)
    print 'Running....'
    if sumfile=='sumresults_virt.dat':
      subprocess.Popen('./run_madevent_virt '+cores+' '+listfile,shell=True).wait()
    else:
      subprocess.Popen('./run_madevent '+cores+' '+listfile,shell=True).wait()
# Second, SGE version
  elif arch==0:
    print 'Sorry, not yet implemented'

def getnrruns(path):
  plotfile=file('plotlist.txt')
  firstplot=plotfile.readline().split('\n')[0]
  nr=0
  while os.path.isfile(path+'/'+firstplot+'.dat'+str(nr+1)):
    nr +=1
  if not os.path.isfile(path+'/'+firstplot+'.dat1'):
    nr=0
  return nr

def replacerun(path,arch):
  os.chdir(path)
  print 'Enter the process where you want to replace a run (P1_xx_yy): '
  proc=raw_input()
  runpath=path+'/'+proc
  nrruns=getnrruns(runpath)
  if nrruns >1:
    print nrruns, ' found. Which one do you want to replace?'
    rep_run=raw_input()
  else:
    rep_run='1'
  print 'Points per iteration:'
  points=raw_input()
  inputfile=open('inputfile1.in',"w")
  inputfile.write(points+'\n')
  inputfile.write('10\n')
  inputfile.write('0\n')
  inputfile.write('2\n')
  inputfile.write('0\n')
  inputfile.write('0\n')
  inputfile.write('1\n')
  inputfile.write(rep_run+'\n')
  print 'Should a random seed be used (y/n)?'
  seed=raw_input()
  if seed=='y':
    r1=random.random()
    r1int=int(r1*10000)
    r2=random.random()
    r2int=int(r2*10000)
    inputfile.write(str(r1int)+' '+str(r2int)+'\n')
  else:
    print 'Enter the seed (2 numbers between 0 and 9999)'
    seednumbers=raw_input()
    inputfile.write(seednumbers+'\n')
  inputfile.close()
#Remove entry in sumresults.dat
  print 'Remove entry in sumresults.dat'
  sumfile=file('sumresults.dat')
  sumfilenew=open('sumresultstemp.dat',"w")
  while True:
    line=sumfile.readline()
    if len(line)==0:
      break
    if line.find(proc) <0:
      sumfilenew.write(line)
  sumfilenew.close()
# copy the files
  subprocess.Popen("mv sumresultstemp.dat sumresults.dat",shell=True)
  com='mv inputfile1.in ' +proc
  subprocess.Popen(com,shell=True)
# start the run
  if arch==1:
    os.chdir(path+'/'+proc)
    print 'Running...'
    subprocess.Popen('./madevent <inputfile1.in >madevent.out'+rep_run,shell=True).wait()
# Updating plots
    os.chdir(path)
    print 'Updating plots...'
    subprocess.Popen('./updateplots.py',shell=True).wait()
    subprocess.Popen('./sumhisto.py',shell=True).wait()
  elif arch==0:
    print 'Sorry, not implemented yet.'
    sys.exit()




def addrun(path,arch):
  os.chdir(path)
  print 'Enter the process where you want to add runs (P1_xx_yy): '
  proc=raw_input()
  runpath=path+'/'+proc
  nrruns=getnrruns(runpath)
  if nrruns==0:
    print 'Error: There is no run available a new run could be added to.'
    sys.exit()
  else:
    print 'Found ',nrruns, 'existing runs.'	
  print 'Points per iteration:'
  points=raw_input()
  print 'How many runs do you want to add?'
  nadd=raw_input()
  nadd=int(nadd)
  for j in range(1, nadd+1):
    inputfile=open('inputfilenew'+str(j)+'.in',"w")
    inputfile.write(points+'\n')
    inputfile.write('10\n')
    inputfile.write('0\n')
    inputfile.write('2\n')
    inputfile.write('0\n')
    inputfile.write('0\n')
    print 'Should the integration channel picked randomly (y/n)?'
    pick=raw_input()
    if pick=='y':
      channel=getchannel(runpath)
    else:
      print 'Enter number of channel'
      channel=raw_input()
    inputfile.write(channel+'\n')
    nrunsnew=int(nrruns)+j
    inputfile.write(str(nrunsnew)+'\n')
  
    print 'For run ', j,' should a random seed be used (y/n)?'
    seed=raw_input()
    if seed=='y':
      r1=random.random()
      r1int=int(r1*10000)
      r2=random.random()
      r2int=int(r2*10000)
      inputfile.write(str(r1int)+' '+str(r2int)+'\n')
    else:
      print 'Enter the seed (2 numbers between 0 and 9999)'
      seednumbers=raw_input()
      inputfile.write(seednumbers+'\n')
    inputfile.close()
    com='mv inputfilenew'+str(j)+'.in ' +proc
    subprocess.Popen(com,shell=True)
  print 'How many cores do you want to use?'
  cores=raw_input()
  print 'Remove entry in sumresults.dat'
  sumfile=file('sumresults.dat')
  sumfilenew=open('sumresultstemp.dat',"w")
  bestfile=open(proc+'/bestres.dat',"a")
  while True:
    line=sumfile.readline()
    if len(line)==0:
      break
    if line.find(proc) <0:
      sumfilenew.write(line)
    if line.find(proc) >0:
      bestfile.write(line)
  bestfile.close()
  sumfilenew.close()
  subprocess.Popen("mv sumresultstemp.dat sumresults.dat",shell=True)
  print 'Running...'
  subprocess.Popen('./add_runs '+str(nadd)+' '+cores+' '\
	      +str(nrruns)+' '+proc,shell=True).wait()
  



def compilesub(path,proclist):
  os.chdir(path)
  tcoll=subprocess.Popen('stat -c %Y ../../Cards/noncoll.inc',shell=True,stdout=subprocess.PIPE).communicate()[0]
  tcoll=int(tcoll.split()[0])
  tdip=subprocess.Popen('stat -c %Y ../../Cards/dipole.inc',shell=True,stdout=subprocess.PIPE).communicate()[0]
  tdip=int(tdip.split()[0])
  tjet=subprocess.Popen('stat -c %Y ../../Cards/jets.inc',shell=True,stdout=subprocess.PIPE).communicate()[0]
  tjet=int(tjet.split()[0])  
  tsubprocess=subprocess.Popen('stat -c %Y ./',shell=True,stdout=subprocess.PIPE).communicate()[0]
  tsubprocess=int(tsubprocess.split()[0])    


  tsub=max(tcoll,tdip,tjet)
  procfile=open(proclist,'r')
  while True:
    line=procfile.readline()
    if len(line)==0:
      break
    line=line.split()[0]
    ttemp=subprocess.Popen('stat -c %Y '+line,shell=True,stdout=subprocess.PIPE).communicate()[0]
    ttemp=int(ttemp.split()[0])
    if ttemp<tsub:
      tsub=ttemp
  if tsub<max(tcoll,tdip,tjet) or tsub<tsubprocess:
    print 'Compiling subprocesses...'
    os.system('./compilesub')


def get_runcardpt(runfile):
  runcard=open(runfile,'r')
  while True:
    line=runcard.readline()
    if len(line)==0:
      break
    if line.find('minimum pt for the jets')>0:
      pt=line.split('=')[0].split()[0]
      if pt.lower().find('d')>0:
	pt=pt.lower()
	pt=pt.replace('d','E')
      floatpt=float(pt)
      break
  runcard.close()
  return floatpt
      

def get_fastjetpt(fastjetfile):
  fastjetfile=open(fastjetfile,'r')
  while True:
    line=fastjetfile.readline()
    if len(line)==0:
      break
    if line.find('ptmin')>0 and line.find('=')>0:
      pt=float(line.split('=')[1].split(';')[0].split()[0])
      break
  fastjetfile.close()
  return pt
  
def set_fastjetpt(fastjetfile,pt):
  fastjetfile=open(fastjetfile,'r')
  tempfile=open('fastjetfortran.tmp','w')
  firsttime=True
  while True:
    line=fastjetfile.readline()
    if len(line)==0:
      break
    if line.find('ptmin')>0 and line.find('=')>0 and firsttime:
      firsttime=False
      line='    double ptmin='+str(pt)+';\n'
      tempfile.write(line)
    else:
      tempfile.write(line)
  fastjetfile.close()
  tempfile.close()
  shutil.move('fastjetfortran.tmp','fastjetfortran.cc')
    
def check_jetpt(path):
  os.chdir(path)
  os.system('STAMP=`date -r ../../Cards/run_card.dat`')
  pt1=get_runcardpt('../../Cards/run_card.dat')
  os.system('touch -d "$STAMP" ../../Cards/run_card.dat')
  os.system('STAMP=`date -r fastjetfortran.cc`')
  pt2=get_fastjetpt('fastjetfortran.cc')
  os.system('touch -d "$STAMP" fastjetfortran.cc')
  if pt1 != pt2:
    print 'Adapting minimal pt in fastjet...'
    set_fastjetpt('fastjetfortran.cc',pt1)
    print 'Done.'
