
*
* The histo-handlers, makes easy interface between user routine 'bino'
* and general histogram manipulator 'ghiman'.
* 
* 'histoi' : sets up histogram 'idhis' with minimum bin value 'bmin',
*            maximum binvalue 'bmax' and number of bins 'nbin'
* 'histoa' : make specific entry in histogram 'idhis' for value 'val' and 
*            weight 'wgt'
* 'histoe' : calculate error request for histogram 'idhis', pipe through
* 'histow' : output request for histogram 'idhis', pipe through
*
      subroutine histoi(idhis,bmin,bmax,nbin)
      implicit double precision (a-h,o-z)
      parameter(nhisto=100,maxbin=500)
      common /hispar/hmin,hwidth,ibin 
      dimension hmin(nhisto),hwidth(nhisto),ibin(nhisto)
*
* histogram initialization
*
      call ghiman(0,idhis,nbin,0d0,0d0)
      hmin(idhis)=bmin
      ibin(idhis)=nbin
      hwidth(idhis)=(bmax-bmin)/nbin
*
c      print*, 'in histoi'
c      print*, idhis, hmin(idhis),ibin(idhis),hwidth(idhis)
      return
      end
*
      subroutine histoa(idhis,val,wgt)
      implicit double precision (a-h,o-z)
      parameter(nhisto=100,maxbin=500)
      common /hispar/hmin,hwidth,ibin 
      dimension hmin(nhisto),hwidth(nhisto),ibin(nhisto)
*
* histogram entry
*
      if(val.lt.hmin(idhis))return
      if(idhis.le.100)then 				! NG 05/09/05
        iloc=1+int((val-hmin(idhis))/hwidth(idhis))
        call ghiman(1,idhis,iloc,wgt,wgt*val)
      endif
*
      return
      end
*
      subroutine histoe(istat,idhis)
      implicit double precision (a-h,o-z)
      parameter(nhisto=100,maxbin=500)
      common /hispar/hmin,hwidth,ibin 
      dimension hmin(nhisto),hwidth(nhisto),ibin(nhisto)
      double precision bin(nhisto,4,maxbin),xbin(nhisto,4),itbin(nhisto,4,maxbin,100)
      common/bins/ bin,xbin,itbin
*
* event errors request, pipe through with correct 'ghiman' call
*
*      write(100,*)idhis,hmin(idhis),hwidth(idhis),ibin(idhis)
      call ghiman(istat,idhis,ibin(idhis),0d0,0d0)
*
      return
      end
*
      subroutine histow(idhis)
      implicit double precision (a-h,o-z)
      parameter(nhisto=100,maxbin=500)
      common /hispar/hmin,hwidth,ibin 
      dimension hmin(nhisto),hwidth(nhisto),ibin(nhisto)
*
* output request, pipe through with correct 'ghiman' call
*
c      print*, idhis, hmin(idhis),hwidth(idhis)
      call ghiman(4,idhis,ibin(idhis),hmin(idhis),hwidth(idhis))

*
      return
      end

      subroutine histow1(idhis)
      implicit double precision (a-h,o-z)
      parameter(nhisto=100,maxbin=500)
      common /hispar/hmin,hwidth,ibin 
      dimension hmin(nhisto),hwidth(nhisto),ibin(nhisto)
*
* output request, pipe through with correct 'ghiman' call
*
      call ghiman(5,idhis,ibin(idhis),hmin(idhis),hwidth(idhis))
*
      return
      end

      subroutine histowf(idhis,lun)
      implicit double precision (a-h,o-z)
      parameter(nhisto=100,maxbin=500)
      common /hispar/hmin,hwidth,ibin 
      dimension hmin(nhisto),hwidth(nhisto),ibin(nhisto)

*
* output request, pipe through with correct 'ghiman' call
*
**  write to file, logical unit 'lun'
      call ghiman(lun,idhis,ibin(idhis),hmin(idhis),hwidth(idhis))
*
      return
      end

      subroutine histow12(idhis)
      implicit double precision (a-h,o-z)
      parameter(nhisto=100,maxbin=500)
      common /hispar/hmin,hwidth,ibin 
      dimension hmin(nhisto),hwidth(nhisto),ibin(nhisto)
*
* output request, pipe through with correct 'ghiman' call
*
      call ghiman(12,idhis,ibin(idhis),hmin(idhis),hwidth(idhis))
*
      return
      end
*
*
* General histogram manipulator, has no knowledge about specific histograms.
*
* Maximum number of histograms is given by the nhisto parameter.
* Maximum number of bins       is given by the maxbin parameter.
*
* istat = 0 : set histogram 'idhis' to value 'entry1' from bin 1 to bin 'iloc'
*             and resets sweep counter 'itmx' to zero.
* istat = 1 : add in histogram 'idhis' weight 'entry1' in  bin location 'iloc'.
* istat = 2 : accumulate event errors in histogram 'idhis' from bin 1 to bin
*             'iloc' for this sweep and increases sweepcounter 'itmx' by 1.
* istat = 3 : calculate standard deviation of the 'itmx' sweeps per bin in 
*             histogram 'idhis' from bin 1 to bin 'iloc' as monte carlo error
*             estimate.
* istat = 4 : write final output to screen in histogram 'idhis' from bin 1 to 
*             bin 'iloc' with offset 'entry1' and binwidth 'entry2'
*            (format: 
*         from bin_number = 1 to 'iloc'  
*            write 'entry1'+'entry2'*(bin_number - 0.5), bin_value, bin_error
*         endfrom)
* istat = 5 : write final output to screen in histogram 'idhis' from bin 1 to 
*             bin 'iloc' with offset 'entry1' and binwidth 'entry2'
*            (format: 
*         from bin_number = 1 to 'iloc'  
*            write 'entry1'+'entry2'*(bin_number - 1), bin_value, bin_error
*         endfrom)
*
      subroutine ghiman(istat,idhis,iloc,entry1,entry2)
      implicit double precision (a-h,o-z)
      parameter(nhisto=100,maxbin=500)
      common /runinfo/itmax1,itmax2,nshota,nshotb,nshotc,nshotd,nshote
      dimension bin(nhisto,4,maxbin),xbin(nhisto,4), testbin(maxbin)
      double precision itbin(nhisto,4,maxbin,100)
      common/bins/ bin,xbin,itbin

      integer Ntot,Nnonzero
      real*8 checkxsec
      common /nmc/ Ntot,Nnonzero,checkxsec,itmax,ncall
*

      if ((idhis.lt.1).or.(idhis.gt.nhisto)) return
      if ((iloc .lt.1).or.(iloc .gt.maxbin)) return
*
*       init histograms
*
      itmax2=10d0
      if (istat.eq.0) then
         do i=1,iloc
            do j=1,4
               bin(idhis,j,i)=entry1
               do k=1,itmax2
                itbin(idhis,j,i,k)=entry1
               enddo
            enddo
         enddo
         itmx=0
      endif
*
* write event into histogram
*
      if (istat.eq.1) then
         if ((iloc.ge.1).and.(iloc.le.maxbin)) then
            bin(idhis,1,iloc)=bin(idhis,1,iloc)+entry1
c            if(idhis.eq.7) then
c             print*, iloc, bin(idhis,1,iloc)
c            endif
            bin(idhis,4,iloc)=bin(idhis,4,iloc)+1d0
            xbin(idhis,1)=xbin(idhis,1)+entry2
            xbin(idhis,4)=xbin(idhis,4)+1d0
         endif
      endif
*
* accumulate event errors
*
      if (istat.eq.2) then
c         do i=1,iloc
c          bin(idhis,2,i)=0d0
c         enddo
c       if(idhis.eq.7) then
c        print*, 'accumulate'
c       endif
         do i=1,iloc
c        if(idhis.eq.3) then
c        print*, i, bin(idhis,2,i), bin(idhis,1,i),bin(idhis,1,i)**2
c        endif
            bin(idhis,2,i)=bin(idhis,2,i)+bin(idhis,1,i)**2
c        if(idhis.eq.3) then
c        print*, i, bin(idhis,2,i), bin(idhis,1,i),bin(idhis,1,i)**2
c        endif
            bin(idhis,3,i)=bin(idhis,3,i)+bin(idhis,1,i)
c         if(idhis.eq.7) then
c            print*, bin(idhis,1,i),bin(idhis,2,i), bin(idhis,3,i)
c         endif
            bin(idhis,1,i)=0d0
            xbin(idhis,2)=xbin(idhis,2)+xbin(idhis,1)**2
            xbin(idhis,3)=xbin(idhis,3)+xbin(idhis,1)
            xbin(idhis,1)=0d0
         enddo
c            print*,'drin', idhis,xbin(2,2)
      endif
*
* calculate event errors
*
      if (istat.eq.3) then
c        do i=1,iloc
c        if(idhis.eq.4) then
c        endif
c        if((bin(idhis,2,i)/itmax2-(bin(idhis,3,i)/itmax2)**2).gt.0d0) then
c          bin(idhis,2,i)=
c     .  sqrt((bin(idhis,2,i)/itmax2-(bin(idhis,3,i)/itmax2)**2)
c     .        /float(itmax2-1))
c         else
c         if(idhis.eq.7) then
c           print*, 'bin2', idhis,i, bin(idhis,2,i), bin(idhis,3,i)
c         endif
c           bin(idhis,2,i)=0d0
c         endif
c        enddo
c       if(idhis.eq.7 ) then
c        print*, 'ghiman'
c        print*, itbin(7,2,1,1), itbin(7,3,1,1)
c        print*, itbin(7,2,1,2), itbin(7,3,1,2)
c        print*, itbin(7,2,1,3), itbin(7,3,1,3)
c       endif
        do i=1,iloc
        sumitbin=0d0
        sumitbin2=0d0
         do j=1,itmax2
          sumitbin2=sumitbin2+itbin(idhis,3,i,j)**2
          sumitbin=sumitbin+itbin(idhis,3,i,j)
         enddo
c        if(idhis.eq.7) then
c         print*, i,bin(idhis,3,i)
c         print*, i, itbin(idhis,2,i,1),itbin(idhis,2,i,2),itbin(idhis,2,i,3)
c         print*, i, itbin(idhis,3,i,1),itbin(idhis,3,i,2),itbin(idhis,3,i,3)
c         print*, bin(idhis,3,i),sqrt((sumitbin2/itmax2-(sumitbin/itmax2)**2)/float(itmax2-1))
c        endif
          bin(idhis,2,i)= 
     .  sqrt((sumitbin2/itmax2-(sumitbin/itmax2)**2)
     .        /float(itmax2-1))
        enddo

          xbin(idhis,2)=
     .  sqrt((xbin(idhis,2)/itmax2-(xbin(idhis,3)/itmax2)**2)
     .        /float(itmax2-1))
      endif
*
* output distributions
*
      if (istat.eq.4) then
c           print*,'bei 4', i,idhis,xbin(2,2)
         sum=0d0
         sum2=0d0
         do i=1,iloc
            y=bin(idhis,3,i)/itmax2 
            y2=bin(idhis,2,i)
	    sum=sum+y
	    sum2=sum2+y2**2
            nn=bin(idhis,4,i)
            if(idhis.le.100)then			! NG 05/09/05
              x=entry1+entry2*(dfloat(i)-.5d0)
            write(6,101) x,y/entry2,y2/entry2 
            endif
         enddo
         write(6,102)sum,sqrt(sum2)
         write(6,103)xbin(idhis,3)/itmax2,xbin(idhis,2)
      endif
c 101     format(f9.4,1pe12.4,1pe12.4)
 101     format(f11.5,1pe20.11,1pe20.11)
 102     format(' sum ',1pe12.4,1pe12.4)
 103     format(' <y> ',1pe12.4,1pe12.4)

      if (istat.ge.11) then
         sum=0d0
         sum2=0d0
c            if(idhis.eq.3) then
c             do i=1,iloc
c              print*, bin(idhis,2,i)
c             enddo
c            endif
         do i=1,iloc
c            if(idhis.eq.4) then
c             print*,i, bin(idhis,2,i)
c            endif
            y=bin(idhis,3,i)/itmax2*ncall*itmax**2/Ntot
            y2=bin(idhis,2,i)
	    sum=sum+y
	    sum2=sum2+y2**2
            nn=bin(idhis,4,i)
            if(idhis.le.100)then			! NG 05/09/05
              x=entry1+entry2*(dfloat(i)-.5d0)
            write(istat,101) x,y/entry2,y2/entry2
c            if(idhis.eq.7) then
c             print*,i, bin(idhis,3,i), x,entry2, y/entry2
c            endif
            endif
         enddo
c         write(11,102)sum,sqrt(sum2)
c         write(11,103)xbin(idhis,3)/itmax2,xbin(idhis,2)
      endif
      if (istat.eq.5) then
         sum=0d0
         sum2=0d0
         do i=1,iloc
            y=bin(idhis,3,i)/itmax2 
            y2=bin(idhis,2,i)
	    sum=sum+y
	    sum2=sum2+y2**2
            nn=bin(idhis,4,i)
            x=entry1+entry2*(dfloat(i)-1d0)
            write(6,101) x,y/entry2,y2/entry2 
         enddo
         write(6,102)sum,sqrt(sum2)
         write(6,103)xbin(idhis,3)/itmax2,xbin(idhis,2)
      endif
*     
      return
      end
*
