      DOUBLE PRECISION FUNCTION DSIG(PP,WGT)
      use ugaau_matrix, only: samplitude,ir_subtraction,initgolem
      use ugaau_config, only: reduction_interoperation


C ****************************************************
C Generated by MadGraph II                                              
C     RETURNS DIFFERENTIAL CROSS SECTION
C     Input:
C             pp    4 momentum of external particles
C             wgt   weight from Monte Carlo
C     Output:
C             Amplitude squared and summed
C ****************************************************
      IMPLICIT NONE
C  
C CONSTANTS
C  
      include "genps.inc"
      include "nexternal.inc"
      DOUBLE PRECISION       CONV
      PARAMETER (CONV=389379.66*1000)  !CONV TO PICOBARNS
      REAL*8     PI
      PARAMETER (PI=3.141592654d0)
C  
C ARGUMENTS 
C  
      DOUBLE PRECISION PP(0:3,NEXTERNAL), WGT
C  
C LOCAL VARIABLES 
C  
      INTEGER I, ICROSS,ITYPE,LP,j
      DOUBLE PRECISION P1(0:3,NEXTERNAL), vecs(5,4), virtamps(0:3), irp(2:3),born
      double precision virtamps_ug(0:3), irp_ug(2:3),vecs_ug(5,4),alpha_s
      DOUBLE PRECISION u1,ub1,d1,db1,c1,cb1,s1,sb1,b1,bb1
      DOUBLE PRECISION u2,ub2,d2,db2,c2,cb2,s2,sb2,b2,bb2
      DOUBLE PRECISION g1,g2
      DOUBLE PRECISION a1,a2
      DOUBLE PRECISION XPQ(-7:7)
      DOUBLE PRECISION DSIGUU, pgolem(nexternal,4)
C  
C EXTERNAL FUNCTIONS
C  
      LOGICAL PASSCUTS
      DOUBLE PRECISION ALPHAS2,REWGT,PDG2PDF, rap,pt,sumdot,r2
C  
C GLOBAL VARIABLES
C  
      INTEGER              IPROC
      DOUBLE PRECISION PD(0:MAXPROC)
      COMMON /SubProc/ PD, IPROC
      include "coupl.inc"
      include "run.inc"
      integer badpoint
      common/points/ badpoint
C  
C DATA
C  
      DATA u1,ub1,d1,db1,c1,cb1,s1,sb1,b1,bb1/10*1d0/
      DATA u2,ub2,d2,db2,c2,cb2,s2,sb2,b2,bb2/10*1d0/
      DATA a1,g1/2*1d0/
      DATA a2,g2/2*1d0/
      DATA IPROC,ICROSS/1,1/
C ----------
C BEGIN CODE
C ----------
      DSIG = 0D0
      dsiguu=0d0
      do i=0,3
        virtamps(i)=0d0
      enddo
      IF (PASSCUTS(PP)) THEN
         IF (ABS(LPP(1)) .GE. 1) THEN
            LP=SIGN(1,LPP(1))
             u1= PDG2PDF(ABS(LPP(1)), 2*LP,XBK(1),DSQRT(Q2FACT(1)))
             d1= PDG2PDF(ABS(LPP(1)), 1*LP,XBK(1),DSQRT(Q2FACT(1)))                              
             s1= PDG2PDF(ABS(LPP(1)), 3*LP,XBK(1),DSQRT(Q2FACT(1)))               
             c1= PDG2PDF(ABS(LPP(1)), 4*LP,XBK(1),DSQRT(Q2FACT(1)))               
             b1= PDG2PDF(ABS(LPP(1)), 5*LP,XBK(1),DSQRT(Q2FACT(1)))               
             g1= PDG2PDF(ABS(LPP(1)), 0*LP,XBK(1),DSQRT(Q2FACT(1)))
             ub1= PDG2PDF(ABS(LPP(1)), -2*LP,XBK(1),DSQRT(Q2FACT(1)))
             db1= PDG2PDF(ABS(LPP(1)), -1*LP,XBK(1),DSQRT(Q2FACT(1)))                              
             sb1= PDG2PDF(ABS(LPP(1)), -3*LP,XBK(1),DSQRT(Q2FACT(1)))               
             cb1= PDG2PDF(ABS(LPP(1)), -4*LP,XBK(1),DSQRT(Q2FACT(1)))               
             bb1= PDG2PDF(ABS(LPP(1)), -5*LP,XBK(1),DSQRT(Q2FACT(1)))               
         ENDIF
         IF (ABS(LPP(2)) .GE. 1) THEN
            LP=SIGN(1,LPP(2))
            db2= PDG2PDF(ABS(LPP(2)),-1*LP,XBK(2),DSQRT(Q2FACT(2)))               
            ub2= PDG2PDF(ABS(LPP(2)),-2*LP,XBK(2),DSQRT(Q2FACT(2)))               
            sb2= PDG2PDF(ABS(LPP(2)),-3*LP,XBK(2),DSQRT(Q2FACT(2)))               
            cb2= PDG2PDF(ABS(LPP(2)),-4*LP,XBK(2),DSQRT(Q2FACT(2)))               
            bb2= PDG2PDF(ABS(LPP(2)),-5*LP,XBK(2),DSQRT(Q2FACT(2)))               
            g2= PDG2PDF(ABS(LPP(2)),0*LP,XBK(2),DSQRT(Q2FACT(2)))               
            d2= PDG2PDF(ABS(LPP(2)),1*LP,XBK(2),DSQRT(Q2FACT(2)))               
            u2= PDG2PDF(ABS(LPP(2)),2*LP,XBK(2),DSQRT(Q2FACT(2)))               
            s2= PDG2PDF(ABS(LPP(2)),3*LP,XBK(2),DSQRT(Q2FACT(2)))               
            c2= PDG2PDF(ABS(LPP(2)),4*LP,XBK(2),DSQRT(Q2FACT(2)))               
            b2= PDG2PDF(ABS(LPP(2)),5*LP,XBK(2),DSQRT(Q2FACT(2)))               
         ENDIF
c         PD(0) = 0d0
c         IPROC = 0
c         IPROC=IPROC+1      ! u u~ -> a a g                              
c         PD(IPROC)=PD(IPROC-1) + u1 * ub2                                
c         IPROC=IPROC+1      ! c c~ -> a a g                              
c         PD(IPROC)=PD(IPROC-1) + c1 * cb2 
      
          CALL SMATRIX(PP,born)        

        alpha_s=real(gg(1))**2/4d0/pi
 

c   q qx -> a a g

        if (reduction_interoperation.eq.1) then
          reduction_interoperation=0
        endif


        vecs(1,:)=PP(:,1)
        vecs(2,:)=-PP(:,5)
        vecs(3,:)=PP(:,3)
        vecs(4,:)=PP(:,4)
        vecs(5,:)=-PP(:,2)

        call avh_olo_mu_set(dsqrt(q2fact(1)))
        call samplitude(vecs, q2fact(1), virtamps)
        call ir_subtraction(vecs, q2fact(1), irp)


        if ( abs(virtamps(3)-irp(3))/virtamps(0).gt.1d-5 .or. abs(virtamps(2)-irp(2))/virtamps(0).gt.1d-3
     &    .or. alpha_s/2d0/pi*abs(virtamps(1)/virtamps(0)).gt. 100d0 ) then

           reduction_interoperation=1
	   call samplitude(vecs, q2fact(1), virtamps)
	   call ir_subtraction(vecs, q2fact(1), irp)
           if( abs((virtamps(3)-irp(3))/virtamps(0)).gt.1d-5 .or.abs((virtamps(2)-irp(2))/virtamps(0)).gt.1d-3
     &       .or. alpha_s/2d0/pi*abs(virtamps(1)/virtamps(0)).gt.100d0) then
c             print*, 'Golem95 failed as well, discarding point '
c             print*, vecs(1,:)
c             print*, vecs(2,:)
c             print*, vecs(3,:)
c             print*, vecs(4,:)
c             print*, vecs(5,:)
c             print*, 'Process: q qx -> a a g'
c             print*, 'virtuals:'
c	     print*, virtamps(0), virtamps(1)/virtamps(0), virtamps(2)/virtamps(0), virtamps(3)/virtamps(0)
c	     print*, 'ir_subtraction'
c	     print*, irp(2)/virtamps(0), irp(3)/virtamps(0)
c             print*, 'cancellation'
c             print*, '1/epssq: ',(virtamps(3)-irp(3))/virtamps(0), '1/eps: ',(virtamps(2)-irp(2))/virtamps(0)
c             print*, 'K-factor: ', alpha_s/2d0/pi*virtamps(1)/virtamps(0)
c             print*, ' '
	     virtamps(0)=0d0
             virtamps(1)=0d0
             virtamps(2)=0d0
             virtamps(3)=0d0
             badpoint=badpoint+1
           endif
        endif
        virtamps(0)=virtamps(0)*gg(1)**2*gwwa**4*8d0/3d0/2d0
        virtamps(1)=virtamps(1)*gg(1)**2*gwwa**4*gg(1)**2/8d0/pi**2*8d0/3d0/2d0
        virtamps(2)=virtamps(2)*gg(1)**2*gwwa**4*gg(1)**2/8d0/pi**2*8d0/3d0/2d0
        virtamps(3)=virtamps(3)*gg(1)**2*gwwa**4*gg(1)**2/8d0/pi**2*8d0/3d0/2d0


c        dsiguu= dsiguu +( (u1*ub2+c1*cb2 +1d0/16d0*(d1*db2+s1*sb2+b1*bb2)) +
c     &          (ub1*u2+cb1*c2 +1d0/16d0*(db1*d2+sb1*s2+bb1*b2)) )*(virtamps(1)- pi**2/12d0*virtamps(3))
        dsiguu= dsiguu +( (u1*ub2+c1*cb2 ) + (ub1*u2+cb1*c2 ) )*(virtamps(1)- pi**2/12d0*virtamps(3))





c  q g -> a a q
        if (reduction_interoperation.eq.1) then
          reduction_interoperation=0
        endif


        vecs(1,:)=PP(:,1)
        vecs(2,:)=PP(:,2)
        vecs(3,:)=PP(:,3)
        vecs(4,:)=PP(:,4)
        vecs(5,:)=PP(:,5)

        call avh_olo_mu_set(dsqrt(q2fact(1)))
        call samplitude(vecs, q2fact(1), virtamps)
        call ir_subtraction(vecs, q2fact(1), irp)

        if ( abs(virtamps(3)-irp(3))/virtamps(0).gt.1d-5 .or. abs(virtamps(2)-irp(2))/virtamps(0).gt.1d-3
     &    .or. alpha_s/2d0/pi*abs(virtamps(1)/virtamps(0)).gt. 100d0 ) then


           reduction_interoperation=1
           call avh_olo_mu_set(dsqrt(q2fact(1)))
	   call samplitude(vecs, q2fact(1), virtamps)
           call ir_subtraction(vecs, q2fact(1), irp)
           if( abs((virtamps(3)-irp(3))/virtamps(0)).gt.1d-5 .or.abs((virtamps(2)-irp(2))/virtamps(0)).gt.1d-3
     &       .or. alpha_s/2d0/pi*abs(virtamps(1)/virtamps(0)).gt.100d0) then
c             print*, 'Golem95 failed as well, discarding point'
c             print*, vecs(1,:)
c             print*, vecs(2,:)
c             print*, vecs(3,:)
c             print*, vecs(4,:)
c             print*, vecs(5,:)
c             print*, 'Process: q g -> a a q'
c             print*, 'virtuals:'
c	     print*, virtamps(0), virtamps(1)/virtamps(0), virtamps(2)/virtamps(0), virtamps(3)/virtamps(0)
c	     print*, 'ir_subtraction'
c	     print*, irp(2)/virtamps(0), irp(3)/virtamps(0)
c             print*, 'cancellation'
c             print*, '1/epssq: ',(virtamps(3)-irp(3))/virtamps(0), '1/eps: ',(virtamps(2)-irp(2))/virtamps(0)
c             print*, 'K-factor: ', alpha_s/2d0/pi*virtamps(1)/virtamps(0)
c             print*, ' '
	     virtamps(0)=0d0
             virtamps(1)=0d0
             virtamps(2)=0d0
             virtamps(3)=0d0
c             call exitgolem_u()
             badpoint=badpoint+1
           endif
        endif


        virtamps(0)=virtamps(0)*gg(1)**2*gwwa**4/2d0
        virtamps(1)=virtamps(1)*gg(1)**2*gwwa**4*gg(1)**2/8d0/pi**2/2d0
        virtamps(2)=virtamps(2)*gg(1)**2*gwwa**4*gg(1)**2/8d0/pi**2/2d0
        virtamps(3)=virtamps(3)*gg(1)**2*gwwa**4*gg(1)**2/8d0/pi**2/2d0
c        irp(2)=irp(2)*gg(1)**2*gwwa**4*gg(1)**2/8d0/pi**2
c        irp(3)=irp(3)*gg(1)**2*gwwa**4*gg(1)**2/8d0/pi**2

c        dsiguu= dsiguu + ( (u1*g2+c1*g2 +1d0/16d0*(d1*g2+s1*g2+b1*g2)) +
c     &          (0d0*g1*u2+0d0*g1*c2 +0d0*1d0/16d0*(g1*d2+g1*s2+g1*b2)) )*(virtamps(1)- pi**2/12d0*virtamps(3))

c   qx g -> a a qx
c        dsiguu= dsiguu + ( (ub1*g2+cb1*g2 +1d0/16d0*(db1*g2+sb1*g2+bb1*g2)) + 
c     &           (0d0*g1*ub2+0d0*g1*cb2 +0d0*1d0/16d0*(g1*db2+g1*sb2+g1*bb2)) )*(virtamps(1)- pi**2/12d0*virtamps(3))


        dsiguu= dsiguu +  (u1*g2+c1*g2 ) *(virtamps(1)- pi**2/12d0*virtamps(3))

c   qx g -> a a qx
        dsiguu= dsiguu + (ub1*g2+cb1*g2 )*(virtamps(1)- pi**2/12d0*virtamps(3))



c  g q -> a a q        
        if (reduction_interoperation.eq.1) then
          reduction_interoperation=0
        endif

       vecs(1,:)=PP(:,2)                               
       vecs(2,:)=PP(:,1)
       vecs(3,:)=PP(:,3)
       vecs(4,:)=PP(:,4)
       vecs(5,:)=PP(:,5)


       call samplitude(vecs, q2fact(1), virtamps)
       call ir_subtraction(vecs, q2fact(1), irp)

        if ( abs(virtamps(3)-irp(3))/virtamps(0).gt.1d-5 .or. abs(virtamps(2)-irp(2))/virtamps(0).gt.1d-3
     &    .or. alpha_s/2d0/pi*abs(virtamps(1)/virtamps(0)).gt. 100d0 ) then

           reduction_interoperation=1
	   call samplitude(vecs, q2fact(1), virtamps)
	   call ir_subtraction(vecs, q2fact(1), irp)
           if( abs((virtamps(3)-irp(3))/virtamps(0)).gt.1d-5 .or.abs((virtamps(2)-irp(2))/virtamps(0)).gt.1d-3
     &       .or. alpha_s/2d0/pi*abs(virtamps(1)/virtamps(0)).gt.100d0) then
c             print*, 'Golem95 failed as well, discarding point'
c             print*, vecs(1,:)
c             print*, vecs(2,:)
c             print*, vecs(3,:)
c             print*, vecs(4,:)
c             print*, vecs(5,:)
c             print*, 'Process: g q -> a a q'
c             print*, 'virtuals:'
c	     print*, virtamps(0), virtamps(1)/virtamps(0), virtamps(2)/virtamps(0), virtamps(3)/virtamps(0)
c	     print*, 'ir_subtraction'
c	     print*, irp(2)/virtamps(0), irp(3)/virtamps(0)
c             print*, 'cancellation'
c             print*, '1/epssq: ',(virtamps(3)-irp(3))/virtamps(0), '1/eps: ',(virtamps(2)-irp(2))/virtamps(0)
c             print*, 'K-factor: ', alpha_s/2d0/pi*virtamps(1)/virtamps(0)
c             print*, ' '
	     virtamps(0)=0d0
             virtamps(1)=0d0
             virtamps(2)=0d0
             virtamps(3)=0d0
             badpoint=badpoint+1
           endif
        endif


       virtamps(0)=virtamps(0)*gg(1)**2*gwwa**4/2d0
       virtamps(1)=virtamps(1)*gg(1)**2*gwwa**4*gg(1)**2/8d0/pi**2/2d0
       virtamps(2)=virtamps(2)*gg(1)**2*gwwa**4*gg(1)**2/8d0/pi**2/2d0
       virtamps(3)=virtamps(3)*gg(1)**2*gwwa**4*gg(1)**2/8d0/pi**2/2d0
c       irp(2)=irp(2)*gg(1)**2*gwwa**4*gg(1)**2/8d0/pi**2
c       irp(3)=irp(3)*gg(1)**2*gwwa**4*gg(1)**2/8d0/pi**2



c       dsiguu= dsiguu + (g1*u2+g1*c2 +1d0/16d0*(g1*d2+g1*s2+g1*b2))*(virtamps(1)- pi**2/12d0*virtamps(3))
c  g qx -> a a qx 
c       dsiguu= dsiguu + (g1*ub2+g1*cb2 +1d0/16d0*(g1*db2+g1*sb2+g1*bb2))*(virtamps(1)- pi**2/12d0*virtamps(3))

       dsiguu= dsiguu + (g1*u2+g1*c2 )*(virtamps(1)- pi**2/12d0*virtamps(3))
c  g qx -> a a qx 
       dsiguu= dsiguu + (g1*ub2+g1*cb2 )*(virtamps(1)- pi**2/12d0*virtamps(3))




         If (abs(dsiguu) .lt. 1d99) then
             dsig =  conv * dsiguu
c             print*, dsig
         else
             write(*,*) "Error in matrix element"
c             print*, 'dsiguu', dsiguu
c             print*, PP(:,1)
c             print*, PP(:,2)
c             print*, PP(:,3)
c             print*, PP(:,4)
c             print*, PP(:,5)
c             print*, 'pt', pt(pp(0,3)),pt(pp(0,4)),pt(pp(0,5))
c             print*, 'rap', rap(pp(0,3)),rap(pp(0,4)),rap(pp(0,5))
c             print*, 'Mgg', dsqrt(Sumdot(pp(0,3),pp(0,4),1d0))
c             print*, 'R34', dsqrt(r2(pp(0,3),pp(0,4)))
c             print*, 'R35', dsqrt(r2(pp(0,3),pp(0,5)))
c             print*, 'R45', dsqrt(r2(pp(0,4),pp(0,5)))
c             print*, 'virtamps(0)', virtamps(0)
c             print*, 'virtamps(1)', virtamps(1)
c             print*, 'virtamps(2)', virtamps(2)
c             print*, 'virtamps(3)', virtamps(3)
c             print*, 'IR, epssq', virtamps(3)/irp(3)
c             print*, 'IR, eps', virtamps(2)/irp(2)
c             print*, 'k-factor', virtamps(1)/virtamps(0)
c             print*, ' '
             dsiguu=0d0
             dsig = 0d0
         endif
c         call unwgt(pp,pd(iproc)*conv*dsiguu*wgt)
         call write_me_hist(pp,dsig*wgt)
      ENDIF
      END
