module     dgaad_abbrevd15h0
   use dgaad_config, only: ki
   use dgaad_globalsh0
   implicit none
   private
   complex(ki), dimension(26), public :: abb15
   complex(ki), public :: R2d15
   public :: init_abbrev
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
contains
   subroutine     init_abbrev()
      use dgaad_config, only: deltaOS, &
     &    logfile, debug_nlo_diagrams
      use dgaad_kinematics
      use dgaad_model
      use dgaad_color, only: TR
      use dgaad_globalsl1, only: epspow
      implicit none
      abb15(1)=1.0_ki/(-es23-es12+es45)
      abb15(2)=NC**(-1)
      abb15(3)=es45**(-1)
      abb15(4)=1.0_ki/(es34-es51-es12)
      abb15(5)=NC-abb15(2)
      abb15(6)=abb15(1)**2*i_*TR
      abb15(7)=-abb15(6)*abb15(5)
      abb15(8)=spbe3k1*c1
      abb15(9)=-abb15(7)*abb15(8)*spae4k5
      abb15(10)=spae2k4*spbk4e4
      abb15(11)=abb15(9)*abb15(10)
      abb15(8)=abb15(6)*abb15(8)*spae2k5
      abb15(12)=-spae4k5*abb15(5)
      abb15(13)=abb15(8)*abb15(12)
      abb15(14)=abb15(13)*spbk5e4
      abb15(11)=abb15(11)-abb15(14)
      abb15(11)=spbk3e2*abb15(3)*abb15(11)
      abb15(14)=spae3k3*abb15(11)
      abb15(8)=abb15(8)*abb15(4)
      abb15(15)=-abb15(8)*abb15(5)
      abb15(16)=spbk2e2*spak2e4
      abb15(17)=abb15(15)*abb15(16)
      abb15(8)=-abb15(8)*abb15(12)
      abb15(12)=abb15(8)*spbk5e2
      abb15(12)=abb15(17)-abb15(12)
      abb15(12)=abb15(12)*spbe4k3
      abb15(17)=-spae3k3*abb15(12)
      abb15(14)=abb15(14)-abb15(17)
      abb15(18)=abb15(9)*spak1e3
      abb15(19)=spbe2k1*abb15(3)
      abb15(20)=abb15(19)*abb15(10)
      abb15(21)=abb15(18)*abb15(20)
      abb15(16)=abb15(16)*spbe4k1
      abb15(15)=abb15(16)*abb15(15)
      abb15(22)=spbk5e2*spbe4k1
      abb15(8)=abb15(22)*abb15(8)
      abb15(8)=abb15(15)-abb15(8)
      abb15(15)=-spak1e3*abb15(8)
      abb15(23)=abb15(13)*spak1e3
      abb15(19)=abb15(19)*spbk5e4
      abb15(24)=abb15(23)*abb15(19)
      abb15(21)=-abb15(24)+abb15(21)+abb15(15)
      abb15(24)=abb15(14)-abb15(21)
      abb15(25)=es12+es23
      abb15(24)=-abb15(24)*abb15(25)
      abb15(15)=abb15(17)+abb15(15)
      abb15(15)=-es45*abb15(15)
      abb15(13)=abb15(13)*spae3k3
      abb15(17)=-spbk5e4*abb15(13)
      abb15(9)=abb15(9)*spae3k3
      abb15(26)=abb15(10)*abb15(9)
      abb15(17)=abb15(17)+abb15(26)
      abb15(17)=spbk3e2*abb15(17)
      abb15(26)=spbk5e4*spbe2k1
      abb15(23)=abb15(23)*abb15(26)
      abb15(10)=abb15(10)*spbe2k1
      abb15(18)=-abb15(18)*abb15(10)
      abb15(15)=abb15(15)+abb15(17)+abb15(23)+abb15(18)+abb15(24)
      abb15(15)=1.0_ki/9.0_ki*abb15(15)
      abb15(17)=spae2k5*c1
      abb15(7)=abb15(16)*abb15(7)*abb15(17)*abb15(4)
      abb15(6)=abb15(6)*spae4k5
      abb15(16)=abb15(5)*abb15(6)*abb15(17)
      abb15(17)=-abb15(22)*abb15(4)*abb15(16)
      abb15(7)=abb15(7)+abb15(17)
      abb15(17)=-abb15(16)*abb15(19)
      abb15(5)=-abb15(5)*abb15(6)*c1
      abb15(6)=abb15(5)*abb15(20)
      abb15(6)=abb15(17)+abb15(6)+abb15(7)
      abb15(17)=-abb15(6)*abb15(25)
      abb15(7)=es45*abb15(7)
      abb15(16)=-abb15(16)*abb15(26)
      abb15(5)=abb15(5)*abb15(10)
      abb15(5)=abb15(7)+abb15(16)+abb15(5)+abb15(17)
      abb15(5)=4.0_ki/9.0_ki*abb15(5)
      abb15(7)=-2.0_ki*abb15(21)+abb15(14)
      abb15(7)=2.0_ki/9.0_ki*abb15(7)
      abb15(10)=abb15(21)-2.0_ki*abb15(14)
      abb15(10)=2.0_ki/9.0_ki*abb15(10)
      abb15(6)=spbk3e3*abb15(6)
      abb15(11)=abb15(11)+abb15(12)
      abb15(6)=abb15(6)+abb15(11)
      abb15(6)=2.0_ki/9.0_ki*spak1k3*abb15(6)
      abb15(11)=-1.0_ki/9.0_ki*spak1e3*abb15(11)
      abb15(8)=spae3k3*abb15(8)
      abb15(9)=-abb15(20)*abb15(9)
      abb15(12)=abb15(19)*abb15(13)
      abb15(8)=abb15(9)+abb15(12)+abb15(8)
      abb15(8)=1.0_ki/9.0_ki*abb15(8)
      R2d15=0.0_ki*(0.0_ki)
      rat2 = rat2 + R2d15
      if (debug_nlo_diagrams) then
          write (logfile,*) "<result name='r2' index='15' value='", &
          & R2d15, "'/>"
      end if
   end subroutine
end module dgaad_abbrevd15h0
