module     dgaad_abbrevd59h0
   use dgaad_config, only: ki
   use dgaad_globalsh0
   implicit none
   private
   complex(ki), dimension(32), public :: abb59
   complex(ki), public :: R2d59
   public :: init_abbrev
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
contains
   subroutine     init_abbrev()
      use dgaad_config, only: deltaOS, &
     &    logfile, debug_nlo_diagrams
      use dgaad_kinematics
      use dgaad_model
      use dgaad_color, only: TR
      use dgaad_globalsl1, only: epspow
      implicit none
      abb59(1)=1.0_ki/(es34-es51-es12)
      abb59(2)=NC**(-1)
      abb59(3)=NC-abb59(2)
      abb59(4)=abb59(1)*i_*TR*c1*spae2k5
      abb59(5)=-abb59(3)*abb59(4)*spbk5e2
      abb59(6)=abb59(5)*spae3k5
      abb59(3)=-abb59(3)*abb59(4)*spbk2e2
      abb59(4)=abb59(3)*spak2e3
      abb59(4)=abb59(6)+abb59(4)
      abb59(6)=spbe4e3*abb59(4)
      abb59(7)=spbk3k1*spak3e4
      abb59(8)=-spbk4k1*spae4k4
      abb59(7)=abb59(8)+abb59(7)
      abb59(7)=abb59(6)*abb59(7)
      abb59(8)=abb59(4)*spbk3e3
      abb59(9)=-spbe4k1*spak3e4*abb59(8)
      abb59(7)=abb59(9)+abb59(7)
      abb59(7)=1.0_ki/9.0_ki*abb59(7)
      abb59(9)=2.0_ki/9.0_ki*abb59(4)
      abb59(9)=spbe3k1*abb59(9)
      abb59(10)=2.0_ki/9.0_ki*spak3e4
      abb59(10)=abb59(10)*spbk3k1
      abb59(11)=abb59(5)*abb59(10)
      abb59(12)=spae3e4*spbe3k1
      abb59(13)=2.0_ki/9.0_ki*abb59(12)
      abb59(14)=-abb59(5)*abb59(13)
      abb59(12)=1.0_ki/9.0_ki*abb59(12)
      abb59(15)=-abb59(5)*abb59(12)
      abb59(10)=-abb59(3)*abb59(10)
      abb59(13)=abb59(3)*abb59(13)
      abb59(12)=abb59(3)*abb59(12)
      abb59(16)=-spak4k5*abb59(5)
      abb59(17)=-spak2k4*abb59(3)
      abb59(16)=abb59(17)+abb59(16)
      abb59(16)=spbk4e4*abb59(16)
      abb59(17)=abb59(5)*spak3k5
      abb59(18)=abb59(3)*spak2k3
      abb59(17)=abb59(17)+abb59(18)
      abb59(18)=spbe4k3*abb59(17)
      abb59(16)=2.0_ki*abb59(18)+abb59(16)
      abb59(16)=2.0_ki/9.0_ki*abb59(16)
      abb59(18)=-2.0_ki/9.0_ki*abb59(6)
      abb59(6)=-1.0_ki/9.0_ki*abb59(6)
      abb59(19)=spbe4k3*spae4k4
      abb59(20)=abb59(19)*spbk4e3
      abb59(20)=1.0_ki/9.0_ki*abb59(20)
      abb59(21)=abb59(17)*abb59(20)
      abb59(22)=2.0_ki/9.0_ki*spbk3e3
      abb59(17)=-abb59(17)*abb59(22)
      abb59(22)=abb59(5)*spae4k5
      abb59(23)=abb59(3)*spak2e4
      abb59(22)=abb59(22)+abb59(23)
      abb59(23)=abb59(22)*spbe4e3
      abb59(24)=2.0_ki/9.0_ki*abb59(23)
      abb59(23)=1.0_ki/9.0_ki*abb59(23)
      abb59(25)=spae3k3*spbe3k1
      abb59(19)=abb59(25)*abb59(19)
      abb59(19)=1.0_ki/9.0_ki*abb59(19)
      abb59(26)=-abb59(5)*abb59(19)
      abb59(27)=2.0_ki/9.0_ki*spbe4k1
      abb59(28)=abb59(27)*spae4k4
      abb59(29)=abb59(5)*abb59(28)
      abb59(25)=2.0_ki/9.0_ki*abb59(25)
      abb59(30)=abb59(5)*abb59(25)
      abb59(27)=abb59(27)*spak3e4
      abb59(31)=-abb59(5)*abb59(27)
      abb59(5)=4.0_ki/9.0_ki*abb59(5)
      abb59(32)=2.0_ki/9.0_ki*spbk4e4*abb59(22)
      abb59(4)=-abb59(4)*abb59(20)
      abb59(8)=2.0_ki/9.0_ki*abb59(8)
      abb59(20)=-4.0_ki/9.0_ki*spbe4k3*abb59(22)
      abb59(19)=abb59(3)*abb59(19)
      abb59(22)=-abb59(3)*abb59(28)
      abb59(25)=-abb59(3)*abb59(25)
      abb59(27)=abb59(3)*abb59(27)
      abb59(3)=-4.0_ki/9.0_ki*abb59(3)
      R2d59=0.0_ki*(0.0_ki)
      rat2 = rat2 + R2d59
      if (debug_nlo_diagrams) then
          write (logfile,*) "<result name='r2' index='59' value='", &
          & R2d59, "'/>"
      end if
   end subroutine
end module dgaad_abbrevd59h0
