module     dgaad_abbrevd60h0
   use dgaad_config, only: ki
   use dgaad_globalsh0
   implicit none
   private
   complex(ki), dimension(31), public :: abb60
   complex(ki), public :: R2d60
   public :: init_abbrev
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
contains
   subroutine     init_abbrev()
      use dgaad_config, only: deltaOS, &
     &    logfile, debug_nlo_diagrams
      use dgaad_kinematics
      use dgaad_model
      use dgaad_color, only: TR
      use dgaad_globalsl1, only: epspow
      implicit none
      abb60(1)=1.0_ki/(es34-es51-es12)
      abb60(2)=NC**(-1)
      abb60(3)=NC-abb60(2)
      abb60(4)=abb60(1)*i_*TR*c1*spae2k5
      abb60(5)=-abb60(3)*abb60(4)*spbk5e2
      abb60(6)=abb60(5)*spae4k5
      abb60(3)=-abb60(3)*abb60(4)*spbk2e2
      abb60(4)=abb60(3)*spak2e4
      abb60(4)=abb60(6)+abb60(4)
      abb60(6)=spbe4e3*abb60(4)
      abb60(7)=spbk4k1*spae3k4
      abb60(8)=spbk3k1*spae3k3
      abb60(7)=abb60(8)+abb60(7)
      abb60(7)=abb60(6)*abb60(7)
      abb60(8)=abb60(4)*spbk4e4
      abb60(9)=spbe3k1*spae3k4*abb60(8)
      abb60(7)=abb60(9)+abb60(7)
      abb60(7)=1.0_ki/9.0_ki*abb60(7)
      abb60(9)=2.0_ki/9.0_ki*abb60(4)
      abb60(9)=spbe4k1*abb60(9)
      abb60(10)=2.0_ki/9.0_ki*spae3k4
      abb60(10)=abb60(10)*spbk4k1
      abb60(11)=-abb60(5)*abb60(10)
      abb60(12)=spae3e4*spbe4k1
      abb60(13)=2.0_ki/9.0_ki*abb60(12)
      abb60(14)=abb60(5)*abb60(13)
      abb60(12)=1.0_ki/9.0_ki*abb60(12)
      abb60(15)=abb60(5)*abb60(12)
      abb60(10)=abb60(3)*abb60(10)
      abb60(13)=-abb60(3)*abb60(13)
      abb60(12)=-abb60(3)*abb60(12)
      abb60(16)=abb60(5)*spak4k5
      abb60(17)=abb60(3)*spak2k4
      abb60(16)=abb60(16)+abb60(17)
      abb60(17)=spae3k3*spbk4e3
      abb60(18)=abb60(17)*spbe4k3
      abb60(18)=1.0_ki/9.0_ki*abb60(18)
      abb60(19)=abb60(16)*abb60(18)
      abb60(20)=2.0_ki/9.0_ki*spbk4e4
      abb60(20)=-abb60(16)*abb60(20)
      abb60(21)=abb60(5)*spae3k5
      abb60(22)=abb60(3)*spak2e3
      abb60(21)=abb60(21)+abb60(22)
      abb60(22)=abb60(21)*spbe4e3
      abb60(23)=-2.0_ki/9.0_ki*abb60(22)
      abb60(22)=-1.0_ki/9.0_ki*abb60(22)
      abb60(24)=-spak3k5*abb60(5)
      abb60(25)=-spak2k3*abb60(3)
      abb60(24)=abb60(25)+abb60(24)
      abb60(24)=spbk3e3*abb60(24)
      abb60(16)=-spbk4e3*abb60(16)
      abb60(16)=2.0_ki*abb60(16)+abb60(24)
      abb60(16)=2.0_ki/9.0_ki*abb60(16)
      abb60(24)=2.0_ki/9.0_ki*abb60(6)
      abb60(6)=1.0_ki/9.0_ki*abb60(6)
      abb60(25)=2.0_ki/9.0_ki*spbe3k1
      abb60(26)=abb60(25)*spae3k4
      abb60(27)=abb60(5)*abb60(26)
      abb60(28)=spae4k4*spbe4k1
      abb60(29)=2.0_ki/9.0_ki*abb60(28)
      abb60(30)=abb60(5)*abb60(29)
      abb60(17)=abb60(28)*abb60(17)
      abb60(17)=1.0_ki/9.0_ki*abb60(17)
      abb60(28)=abb60(5)*abb60(17)
      abb60(25)=abb60(25)*spae3k3
      abb60(31)=abb60(5)*abb60(25)
      abb60(5)=4.0_ki/9.0_ki*abb60(5)
      abb60(4)=-abb60(4)*abb60(18)
      abb60(18)=4.0_ki/9.0_ki*spbk4e3*abb60(21)
      abb60(8)=2.0_ki/9.0_ki*abb60(8)
      abb60(21)=2.0_ki/9.0_ki*spbk3e3*abb60(21)
      abb60(26)=-abb60(3)*abb60(26)
      abb60(29)=-abb60(3)*abb60(29)
      abb60(17)=-abb60(3)*abb60(17)
      abb60(25)=-abb60(3)*abb60(25)
      abb60(3)=-4.0_ki/9.0_ki*abb60(3)
      R2d60=0.0_ki*(0.0_ki)
      rat2 = rat2 + R2d60
      if (debug_nlo_diagrams) then
          write (logfile,*) "<result name='r2' index='60' value='", &
          & R2d60, "'/>"
      end if
   end subroutine
end module dgaad_abbrevd60h0
