module     dgaad_abbrevd62h0
   use dgaad_config, only: ki
   use dgaad_globalsh0
   implicit none
   private
   complex(ki), dimension(38), public :: abb62
   complex(ki), public :: R2d62
   public :: init_abbrev
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
contains
   subroutine     init_abbrev()
      use dgaad_config, only: deltaOS, &
     &    logfile, debug_nlo_diagrams
      use dgaad_kinematics
      use dgaad_model
      use dgaad_color, only: TR
      use dgaad_globalsl1, only: epspow
      implicit none
      abb62(1)=1.0_ki/(-es34+es12-es45)
      abb62(2)=NC**(-1)
      abb62(3)=-spbk2k1*spak2e4
      abb62(4)=-spbk4k1*spae4k4
      abb62(3)=abb62(4)+abb62(3)
      abb62(4)=i_*TR*c1*spae3k5*abb62(2)*abb62(1)
      abb62(5)=abb62(4)*spbk3e3
      abb62(6)=abb62(5)*spae2k3
      abb62(4)=abb62(4)*spbk5e3
      abb62(7)=abb62(4)*spae2k5
      abb62(6)=abb62(6)+abb62(7)
      abb62(7)=spbe4e2*abb62(6)
      abb62(3)=abb62(7)*abb62(3)
      abb62(8)=spbk2e2*spak2e4
      abb62(9)=abb62(8)*abb62(6)
      abb62(10)=spbe4k1*abb62(9)
      abb62(3)=abb62(10)+abb62(3)
      abb62(3)=1.0_ki/9.0_ki*abb62(3)
      abb62(10)=2.0_ki/9.0_ki*abb62(6)
      abb62(11)=spbe2k1*abb62(10)
      abb62(12)=2.0_ki/9.0_ki*spbk2k1
      abb62(13)=abb62(4)*spak2e4
      abb62(14)=-abb62(13)*abb62(12)
      abb62(15)=abb62(4)*spbe2k1
      abb62(16)=abb62(15)*spae2e4
      abb62(17)=2.0_ki/9.0_ki*abb62(16)
      abb62(16)=-1.0_ki/9.0_ki*abb62(16)
      abb62(18)=abb62(5)*spak2e4
      abb62(12)=-abb62(18)*abb62(12)
      abb62(19)=abb62(5)*spbe2k1
      abb62(20)=abb62(19)*spae2e4
      abb62(21)=2.0_ki/9.0_ki*abb62(20)
      abb62(20)=-1.0_ki/9.0_ki*abb62(20)
      abb62(22)=abb62(4)*spbe4k2
      abb62(23)=abb62(22)*spak2k5
      abb62(24)=abb62(5)*spbe4k2
      abb62(25)=abb62(24)*spak2k3
      abb62(23)=abb62(23)+abb62(25)
      abb62(25)=-spak4k5*abb62(4)
      abb62(26)=spak3k4*abb62(5)
      abb62(25)=abb62(26)+abb62(25)
      abb62(25)=spbk4e4*abb62(25)
      abb62(25)=-2.0_ki*abb62(23)+abb62(25)
      abb62(25)=2.0_ki/9.0_ki*abb62(25)
      abb62(26)=2.0_ki/9.0_ki*abb62(7)
      abb62(7)=-1.0_ki/9.0_ki*abb62(7)
      abb62(27)=spbk4e2*spae4k4
      abb62(8)=abb62(27)+abb62(8)
      abb62(8)=-1.0_ki/9.0_ki*abb62(8)*abb62(23)
      abb62(23)=spak2k5*abb62(4)
      abb62(28)=spak2k3*abb62(5)
      abb62(23)=abb62(23)+abb62(28)
      abb62(28)=2.0_ki/9.0_ki*spbk2e2
      abb62(23)=abb62(23)*abb62(28)
      abb62(28)=abb62(5)*spak3e4
      abb62(29)=abb62(4)*spae4k5
      abb62(28)=abb62(28)-abb62(29)
      abb62(29)=-spbe4e2*abb62(28)
      abb62(30)=-2.0_ki/9.0_ki*abb62(29)
      abb62(29)=1.0_ki/9.0_ki*abb62(29)
      abb62(31)=spae2k2*spbe2k1
      abb62(31)=1.0_ki/9.0_ki*abb62(31)
      abb62(32)=abb62(31)*abb62(22)
      abb62(33)=spae4k4*abb62(32)
      abb62(34)=2.0_ki/9.0_ki*spbe4k1
      abb62(35)=abb62(34)*spae4k4
      abb62(36)=abb62(4)*abb62(35)
      abb62(32)=spak2e4*abb62(32)
      abb62(37)=2.0_ki/9.0_ki*spae2k2
      abb62(15)=-abb62(15)*abb62(37)
      abb62(13)=abb62(13)*abb62(34)
      abb62(4)=4.0_ki/9.0_ki*abb62(4)
      abb62(28)=-2.0_ki/9.0_ki*spbk4e4*abb62(28)
      abb62(31)=abb62(31)*abb62(24)
      abb62(38)=spae4k4*abb62(31)
      abb62(35)=abb62(5)*abb62(35)
      abb62(31)=spak2e4*abb62(31)
      abb62(19)=-abb62(19)*abb62(37)
      abb62(18)=abb62(18)*abb62(34)
      abb62(5)=4.0_ki/9.0_ki*abb62(5)
      abb62(6)=abb62(6)*abb62(27)
      abb62(6)=abb62(6)+abb62(9)
      abb62(6)=1.0_ki/9.0_ki*spbe4k2*abb62(6)
      abb62(9)=-spbk2e2*abb62(10)
      abb62(10)=spae4k5*abb62(22)
      abb62(22)=-spak3e4*abb62(24)
      abb62(10)=abb62(10)+abb62(22)
      abb62(10)=4.0_ki/9.0_ki*abb62(10)
      R2d62=0.0_ki*(0.0_ki)
      rat2 = rat2 + R2d62
      if (debug_nlo_diagrams) then
          write (logfile,*) "<result name='r2' index='62' value='", &
          & R2d62, "'/>"
      end if
   end subroutine
end module dgaad_abbrevd62h0
