module     dgaad_abbrevd66h0
   use dgaad_config, only: ki
   use dgaad_globalsh0
   implicit none
   private
   complex(ki), dimension(38), public :: abb66
   complex(ki), public :: R2d66
   public :: init_abbrev
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
contains
   subroutine     init_abbrev()
      use dgaad_config, only: deltaOS, &
     &    logfile, debug_nlo_diagrams
      use dgaad_kinematics
      use dgaad_model
      use dgaad_color, only: TR
      use dgaad_globalsl1, only: epspow
      implicit none
      abb66(1)=NC**(-1)
      abb66(2)=es45**(-1)
      abb66(3)=spbk3k1*spae2k3
      abb66(4)=-spbk2k1*spae2k2
      abb66(3)=abb66(4)+abb66(3)
      abb66(4)=i_*TR*c1*spae4k5*abb66(2)*abb66(1)
      abb66(5)=abb66(4)*spbk4e4
      abb66(6)=abb66(5)*spae3k4
      abb66(4)=abb66(4)*spbk5e4
      abb66(7)=abb66(4)*spae3k5
      abb66(6)=abb66(6)+abb66(7)
      abb66(7)=spbe3e2*abb66(6)
      abb66(3)=abb66(7)*abb66(3)
      abb66(8)=spbk3e3*spae2k3
      abb66(9)=abb66(8)*abb66(6)
      abb66(10)=spbe2k1*abb66(9)
      abb66(3)=abb66(10)+abb66(3)
      abb66(3)=1.0_ki/9.0_ki*abb66(3)
      abb66(10)=2.0_ki/9.0_ki*abb66(6)
      abb66(11)=spbe3k1*abb66(10)
      abb66(12)=2.0_ki/9.0_ki*spbk3k1
      abb66(13)=abb66(4)*spae2k3
      abb66(14)=-abb66(13)*abb66(12)
      abb66(15)=abb66(4)*spbe3k1
      abb66(16)=abb66(15)*spae2e3
      abb66(17)=2.0_ki/9.0_ki*abb66(16)
      abb66(16)=1.0_ki/9.0_ki*abb66(16)
      abb66(18)=abb66(5)*spae2k3
      abb66(12)=-abb66(18)*abb66(12)
      abb66(19)=abb66(5)*spbe3k1
      abb66(20)=abb66(19)*spae2e3
      abb66(21)=2.0_ki/9.0_ki*abb66(20)
      abb66(20)=1.0_ki/9.0_ki*abb66(20)
      abb66(22)=abb66(4)*spbk3e2
      abb66(23)=abb66(22)*spak3k5
      abb66(24)=abb66(5)*spbk3e2
      abb66(25)=abb66(24)*spak3k4
      abb66(23)=abb66(23)+abb66(25)
      abb66(25)=spbe3k2*spae2k2
      abb66(8)=abb66(25)+abb66(8)
      abb66(8)=-1.0_ki/9.0_ki*abb66(8)*abb66(23)
      abb66(26)=-spak3k5*abb66(4)
      abb66(27)=-spak3k4*abb66(5)
      abb66(26)=abb66(26)+abb66(27)
      abb66(27)=2.0_ki/9.0_ki*spbk3e3
      abb66(26)=abb66(26)*abb66(27)
      abb66(27)=abb66(5)*spae2k4
      abb66(28)=abb66(4)*spae2k5
      abb66(27)=abb66(27)+abb66(28)
      abb66(28)=spbe3e2*abb66(27)
      abb66(29)=-2.0_ki/9.0_ki*abb66(28)
      abb66(28)=-1.0_ki/9.0_ki*abb66(28)
      abb66(30)=spak2k5*abb66(4)
      abb66(31)=spak2k4*abb66(5)
      abb66(30)=abb66(31)+abb66(30)
      abb66(30)=spbk2e2*abb66(30)
      abb66(23)=-2.0_ki*abb66(23)+abb66(30)
      abb66(23)=2.0_ki/9.0_ki*abb66(23)
      abb66(30)=2.0_ki/9.0_ki*abb66(7)
      abb66(7)=1.0_ki/9.0_ki*abb66(7)
      abb66(31)=spae3k3*spbe3k1
      abb66(31)=1.0_ki/9.0_ki*abb66(31)
      abb66(32)=abb66(31)*abb66(22)
      abb66(33)=spae2k3*abb66(32)
      abb66(34)=2.0_ki/9.0_ki*spbe2k1
      abb66(13)=abb66(13)*abb66(34)
      abb66(35)=2.0_ki/9.0_ki*spae3k3
      abb66(15)=abb66(15)*abb66(35)
      abb66(32)=-spae2k2*abb66(32)
      abb66(36)=abb66(34)*spae2k2
      abb66(37)=-abb66(4)*abb66(36)
      abb66(4)=4.0_ki/9.0_ki*abb66(4)
      abb66(31)=abb66(31)*abb66(24)
      abb66(38)=spae2k3*abb66(31)
      abb66(18)=abb66(18)*abb66(34)
      abb66(19)=abb66(19)*abb66(35)
      abb66(31)=-spae2k2*abb66(31)
      abb66(34)=-abb66(5)*abb66(36)
      abb66(5)=4.0_ki/9.0_ki*abb66(5)
      abb66(6)=abb66(6)*abb66(25)
      abb66(6)=abb66(6)+abb66(9)
      abb66(6)=1.0_ki/9.0_ki*spbk3e2*abb66(6)
      abb66(9)=spae2k5*abb66(22)
      abb66(22)=spae2k4*abb66(24)
      abb66(9)=abb66(9)+abb66(22)
      abb66(9)=4.0_ki/9.0_ki*abb66(9)
      abb66(10)=spbk3e3*abb66(10)
      abb66(22)=-2.0_ki/9.0_ki*spbk2e2*abb66(27)
      R2d66=0.0_ki*(0.0_ki)
      rat2 = rat2 + R2d66
      if (debug_nlo_diagrams) then
          write (logfile,*) "<result name='r2' index='66' value='", &
          & R2d66, "'/>"
      end if
   end subroutine
end module dgaad_abbrevd66h0
