module     dgaad_abbrevd6h0
   use dgaad_config, only: ki
   use dgaad_globalsh0
   implicit none
   private
   complex(ki), dimension(17), public :: abb6
   complex(ki), public :: R2d6
   public :: init_abbrev
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
contains
   subroutine     init_abbrev()
      use dgaad_config, only: deltaOS, &
     &    logfile, debug_nlo_diagrams
      use dgaad_kinematics
      use dgaad_model
      use dgaad_color, only: TR
      use dgaad_globalsl1, only: epspow
      implicit none
      abb6(1)=1.0_ki/(es23-es51-es45)
      abb6(2)=1.0_ki/(es34-es51-es12)
      abb6(3)=NC**(-1)
      abb6(4)=NC-abb6(3)
      abb6(5)=i_*TR*c1*spae2k5*abb6(2)*abb6(1)
      abb6(6)=-abb6(5)*abb6(4)
      abb6(7)=-spbk5e2*abb6(6)
      abb6(8)=spak3k5*spbk3e3
      abb6(9)=abb6(7)*abb6(8)
      abb6(6)=-spbk2e2*abb6(6)
      abb6(10)=spak2k3*spbk3e3
      abb6(11)=abb6(6)*abb6(10)
      abb6(9)=abb6(9)+abb6(11)
      abb6(9)=abb6(9)*spae3k4
      abb6(11)=spae3k5*spbk3e3
      abb6(12)=abb6(7)*abb6(11)
      abb6(13)=spak2e3*spbk3e3
      abb6(14)=abb6(6)*abb6(13)
      abb6(12)=abb6(12)+abb6(14)
      abb6(12)=abb6(12)*spak3k4
      abb6(9)=abb6(9)-abb6(12)
      abb6(12)=-2.0_ki/9.0_ki*spbk4k1*abb6(9)
      abb6(7)=abb6(7)*spak4k5
      abb6(6)=abb6(6)*spak2k4
      abb6(6)=abb6(7)+abb6(6)
      abb6(7)=-8.0_ki/9.0_ki*spbk4k1*abb6(6)
      abb6(5)=abb6(5)*spbe4k1
      abb6(14)=-abb6(4)*abb6(5)*spbk5e2
      abb6(8)=abb6(14)*abb6(8)
      abb6(4)=-abb6(4)*abb6(5)*spbk2e2
      abb6(5)=abb6(4)*abb6(10)
      abb6(5)=abb6(8)+abb6(5)
      abb6(8)=abb6(5)*spae3e4
      abb6(10)=abb6(14)*abb6(11)
      abb6(11)=abb6(4)*abb6(13)
      abb6(10)=abb6(10)+abb6(11)
      abb6(11)=abb6(10)*spak3e4
      abb6(8)=abb6(8)-abb6(11)
      abb6(8)=2.0_ki/9.0_ki*abb6(8)
      abb6(11)=abb6(14)*spae4k5
      abb6(13)=abb6(4)*spak2e4
      abb6(11)=abb6(11)+abb6(13)
      abb6(11)=8.0_ki/9.0_ki*abb6(11)
      abb6(13)=abb6(14)*spae3k5
      abb6(15)=abb6(4)*spak2e3
      abb6(13)=abb6(13)+abb6(15)
      abb6(15)=spbk4e3*spae4k4
      abb6(16)=spbe3k1*spak1e4
      abb6(15)=abb6(15)-abb6(16)
      abb6(13)=abb6(15)*abb6(13)
      abb6(13)=1.0_ki/9.0_ki*abb6(13)
      abb6(9)=spbk4e4*abb6(9)
      abb6(5)=spak1e3*abb6(5)
      abb6(10)=-spak1k3*abb6(10)
      abb6(5)=abb6(10)+abb6(5)+abb6(9)
      abb6(5)=1.0_ki/9.0_ki*abb6(5)
      abb6(6)=spbk4e4*abb6(6)
      abb6(9)=-spak1k5*abb6(14)
      abb6(10)=spak1k2*abb6(4)
      abb6(6)=abb6(10)+abb6(9)+abb6(6)
      abb6(6)=4.0_ki/9.0_ki*abb6(6)
      abb6(9)=2.0_ki/9.0_ki*spae4k4
      abb6(10)=abb6(14)*abb6(9)
      abb6(16)=1.0_ki/9.0_ki*spae3k3
      abb6(15)=abb6(15)*abb6(16)
      abb6(16)=abb6(14)*abb6(15)
      abb6(17)=2.0_ki/9.0_ki*spak1e4
      abb6(14)=abb6(14)*abb6(17)
      abb6(9)=-abb6(4)*abb6(9)
      abb6(15)=-abb6(4)*abb6(15)
      abb6(4)=-abb6(4)*abb6(17)
      R2d6=0.0_ki*(0.0_ki)
      rat2 = rat2 + R2d6
      if (debug_nlo_diagrams) then
          write (logfile,*) "<result name='r2' index='6' value='", &
          & R2d6, "'/>"
      end if
   end subroutine
end module dgaad_abbrevd6h0
