module     dgaad_abbrevd9h0
   use dgaad_config, only: ki
   use dgaad_globalsh0
   implicit none
   private
   complex(ki), dimension(28), public :: abb9
   complex(ki), public :: R2d9
   public :: init_abbrev
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
contains
   subroutine     init_abbrev()
      use dgaad_config, only: deltaOS, &
     &    logfile, debug_nlo_diagrams
      use dgaad_kinematics
      use dgaad_model
      use dgaad_color, only: TR
      use dgaad_globalsl1, only: epspow
      implicit none
      abb9(1)=1.0_ki/(-es34+es12-es45)
      abb9(2)=NC**(-1)
      abb9(3)=es12**(-1)
      abb9(4)=1.0_ki/(es23-es51-es45)
      abb9(5)=i_*TR*c1*spae3k5
      abb9(6)=abb9(1)**2
      abb9(7)=abb9(5)*abb9(6)
      abb9(8)=abb9(4)*abb9(7)
      abb9(9)=NC-abb9(2)
      abb9(10)=-abb9(9)*abb9(8)*spbe4k1
      abb9(11)=-spbk5e3*abb9(10)
      abb9(12)=-spbe2k1*abb9(11)
      abb9(13)=spae2k5*spak1e4
      abb9(14)=abb9(12)*abb9(13)
      abb9(15)=spbk4e2*spae4k4
      abb9(16)=abb9(15)*spae2k5
      abb9(17)=abb9(16)*abb9(11)
      abb9(14)=abb9(14)+abb9(17)
      abb9(17)=abb9(9)*spbe2k1*abb9(7)
      abb9(18)=spbk5e3*abb9(17)
      abb9(19)=spbe4k2*spae2k2
      abb9(20)=abb9(19)*abb9(3)
      abb9(21)=abb9(20)*spae4k5
      abb9(22)=abb9(21)*abb9(18)
      abb9(22)=abb9(14)+abb9(22)
      abb9(10)=-spbk3e3*abb9(10)
      abb9(23)=-spbe2k1*abb9(10)
      abb9(24)=abb9(23)*spak1e4
      abb9(25)=abb9(10)*abb9(15)
      abb9(24)=abb9(24)+abb9(25)
      abb9(24)=abb9(24)*spae2k3
      abb9(17)=spbk3e3*abb9(17)
      abb9(20)=abb9(20)*spak3e4
      abb9(25)=abb9(20)*abb9(17)
      abb9(25)=abb9(24)-abb9(25)
      abb9(26)=abb9(22)+abb9(25)
      abb9(27)=-es45-es34
      abb9(26)=abb9(26)*abb9(27)
      abb9(14)=abb9(24)+abb9(14)
      abb9(14)=es12*abb9(14)
      abb9(24)=abb9(18)*spae4k5
      abb9(27)=-abb9(17)*spak3e4
      abb9(24)=abb9(24)+abb9(27)
      abb9(19)=abb9(19)*abb9(24)
      abb9(14)=abb9(14)+abb9(26)+abb9(19)
      abb9(14)=1.0_ki/9.0_ki*abb9(14)
      abb9(19)=spbk5k2*abb9(17)
      abb9(24)=-spbk3k2*abb9(18)
      abb9(19)=abb9(24)+abb9(19)
      abb9(24)=abb9(3)*spak3k5
      abb9(19)=abb9(19)*spae2k2*abb9(24)
      abb9(8)=-abb9(8)*abb9(9)
      abb9(9)=-spbk3e2*spbk5e3*abb9(8)
      abb9(8)=-spbk5e2*spbk3e3*abb9(8)
      abb9(8)=abb9(9)-abb9(8)
      abb9(8)=spae2k4*spak3k5*abb9(8)
      abb9(9)=-spbk4k1*abb9(8)
      abb9(9)=abb9(9)+abb9(19)
      abb9(9)=4.0_ki/9.0_ki*abb9(9)
      abb9(5)=abb9(5)*abb9(6)*abb9(2)
      abb9(6)=NC*abb9(7)
      abb9(5)=abb9(5)-abb9(6)
      abb9(6)=abb9(24)*spbe4k3
      abb9(7)=-abb9(6)*spbk5e3*abb9(5)
      abb9(19)=abb9(24)*spbk5e4
      abb9(5)=-abb9(19)*spbk3e3*abb9(5)
      abb9(5)=abb9(7)+abb9(5)
      abb9(5)=abb9(5)*spak2e4
      abb9(7)=spbk2k1*abb9(5)
      abb9(24)=-spbk5k4*spae4k4
      abb9(26)=-spbk5k1*spak1e4
      abb9(24)=abb9(26)+abb9(24)
      abb9(26)=abb9(10)*spak3k5
      abb9(24)=abb9(26)*abb9(24)
      abb9(27)=-spbk4k3*spae4k4
      abb9(28)=spbk3k1*spak1e4
      abb9(27)=abb9(28)+abb9(27)
      abb9(28)=abb9(11)*spak3k5
      abb9(27)=abb9(28)*abb9(27)
      abb9(7)=abb9(7)+abb9(27)+abb9(24)
      abb9(7)=4.0_ki/9.0_ki*abb9(7)
      abb9(24)=abb9(22)+2.0_ki*abb9(25)
      abb9(24)=2.0_ki/9.0_ki*abb9(24)
      abb9(26)=abb9(26)*spbk5e2
      abb9(27)=abb9(28)*spbk3e2
      abb9(26)=abb9(26)-abb9(27)
      abb9(27)=4.0_ki/9.0_ki*spae2e4
      abb9(28)=-abb9(26)*abb9(27)
      abb9(22)=abb9(25)+2.0_ki*abb9(22)
      abb9(22)=2.0_ki/9.0_ki*abb9(22)
      abb9(6)=abb9(6)*abb9(18)
      abb9(19)=abb9(19)*abb9(17)
      abb9(6)=abb9(6)+abb9(19)
      abb9(19)=-abb9(6)*abb9(27)
      abb9(25)=abb9(26)-abb9(6)
      abb9(25)=abb9(25)*abb9(27)
      abb9(8)=spbk4e4*abb9(8)
      abb9(26)=spak1e2*abb9(26)
      abb9(8)=abb9(8)+abb9(26)
      abb9(8)=2.0_ki/9.0_ki*abb9(8)
      abb9(5)=-spbk2e2*abb9(5)
      abb9(6)=spak1e4*abb9(6)
      abb9(5)=abb9(5)+abb9(6)
      abb9(5)=2.0_ki/9.0_ki*abb9(5)
      abb9(6)=-spak1e4*abb9(12)
      abb9(11)=-abb9(11)*abb9(15)
      abb9(6)=abb9(6)+abb9(11)
      abb9(6)=spae2k3*abb9(6)
      abb9(11)=abb9(18)*abb9(20)
      abb9(6)=abb9(6)+abb9(11)
      abb9(6)=1.0_ki/9.0_ki*abb9(6)
      abb9(11)=-abb9(23)*abb9(13)
      abb9(10)=-abb9(10)*abb9(16)
      abb9(12)=-abb9(17)*abb9(21)
      abb9(10)=abb9(12)+abb9(11)+abb9(10)
      abb9(10)=1.0_ki/9.0_ki*abb9(10)
      R2d9=0.0_ki*(0.0_ki)
      rat2 = rat2 + R2d9
      if (debug_nlo_diagrams) then
          write (logfile,*) "<result name='r2' index='9' value='", &
          & R2d9, "'/>"
      end if
   end subroutine
end module dgaad_abbrevd9h0
