module     dgaad_d4h0l1
   ! file: /.th/pcl340/scratch/gosam/greiner/dg_aad/helicity0d4h0l1.f90
   ! generator: buildfortran.py
   use dgaad_config, only: ki
   use dgaad_util, only: cond
   implicit none
   private
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ function brack_1:
   pure function brack_1(Q,mu2) result(brack)
      use dgaad_model
      use dgaad_kinematics
      use dgaad_color
      use dgaad_abbrevd4h0
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      complex(ki), intent(in) :: mu2
      complex(ki) :: brack
      complex(ki) :: acc4(24)
      complex(ki) :: Qspvae3k1
      complex(ki) :: Qspe3
      complex(ki) :: Qspvak5k3
      complex(ki) :: Qspvak5k1
      complex(ki) :: Qspvak4k3
      complex(ki) :: Qspvak4k1
      complex(ki) :: Qspe2
      complex(ki) :: Qspk3
      complex(ki) :: Qspk1
      complex(ki) :: QspQ
      complex(ki) :: Qspvak5k2
      complex(ki) :: Qspvak4k2
      complex(ki) :: Qspk2
      Qspvae3k1 = dotproduct(Q,spvae3k1)
      Qspe3 = dotproduct(Q,e3)
      Qspvak5k3 = dotproduct(Q,spvak5k3)
      Qspvak5k1 = dotproduct(Q,spvak5k1)
      Qspvak4k3 = dotproduct(Q,spvak4k3)
      Qspvak4k1 = dotproduct(Q,spvak4k1)
      Qspe2 = dotproduct(Q,e2)
      Qspk3 = dotproduct(Q,k3)
      Qspk1 = dotproduct(Q,k1)
      QspQ = dotproduct(Q,Q)
      Qspvak5k2 = dotproduct(Q,spvak5k2)
      Qspvak4k2 = dotproduct(Q,spvak4k2)
      Qspk2 = dotproduct(Q,k2)
      acc4(1)=abb4(4)
      acc4(2)=abb4(5)
      acc4(3)=abb4(6)
      acc4(4)=abb4(7)
      acc4(5)=abb4(8)
      acc4(6)=abb4(9)
      acc4(7)=abb4(10)
      acc4(8)=abb4(11)
      acc4(9)=abb4(12)
      acc4(10)=abb4(13)
      acc4(11)=abb4(14)
      acc4(12)=abb4(15)
      acc4(13)=abb4(17)
      acc4(14)=abb4(19)
      acc4(15)=abb4(29)
      acc4(16)=abb4(33)
      acc4(17)=acc4(4)*Qspvae3k1
      acc4(18)=acc4(16)*Qspe3
      acc4(19)=Qspvak5k3*acc4(9)
      acc4(20)=Qspvak5k1*acc4(5)
      acc4(21)=Qspvak4k3*acc4(13)
      acc4(22)=Qspvak4k1*acc4(10)
      acc4(17)=acc4(22)+acc4(21)+acc4(20)+acc4(19)+acc4(18)+acc4(14)+acc4(17)
      acc4(17)=Qspe2*acc4(17)
      acc4(18)=-Qspk3+Qspk1
      acc4(19)=acc4(15)*Qspe2
      acc4(19)=acc4(19)-acc4(7)
      acc4(18)=acc4(19)*acc4(18)
      acc4(19)=mu2-QspQ
      acc4(19)=acc4(8)*acc4(19)
      acc4(20)=acc4(1)*Qspe3
      acc4(21)=acc4(3)*Qspvae3k1
      acc4(22)=Qspvak5k2*acc4(12)
      acc4(23)=Qspvak4k2*acc4(2)
      acc4(24)=Qspk2*acc4(11)
      brack=acc4(6)+acc4(17)+acc4(18)+acc4(19)+acc4(20)+acc4(21)+acc4(22)+acc4(&
      &23)+acc4(24)
   end  function brack_1
!---#] function brack_1:
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use dgaad_groups, only: &
!           & sign => diagram4_sign, shift => diagram4_shift
      use dgaad_globalsl1, only: epspow
      use dgaad_kinematics
      use dgaad_abbrevd4h0
      implicit none
      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d4
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(0:3) :: qshift
      qshift = -k2
      Q(1)  =cmplx(real(-Q_ext(4)  -qshift(0),  ki_sam),aimag(-Q_ext(4)),  ki)
      Q(2:4)=cmplx(real(-Q_ext(1:3)-qshift(1:3),ki_sam),aimag(-Q_ext(1:3)),ki)
      mu2    = cmplx(real(mu2_ext, ki), aimag(mu2_ext), ki)
      d4 = 0.0_ki
      d4 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d4, ki), aimag(d4), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use dgaad_globalsl1, only: epspow
      use dgaad_kinematics
      use dgaad_abbrevd4h0
      implicit none
      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d4
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(4) :: qshift
      qshift = -k2
      Q(:)  =cmplx(real(-Q_ext(:)  -qshift(:),  ki_gol), 0.0_ki_gol, ki)
      mu2  = cmplx(real(mu2_ext, ki), 0.0_ki, ki)
      d4 = 0.0_ki
      d4 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d4, ki), aimag(d4), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module dgaad_d4h0l1
