module     dgaad_d80h0l1
   ! file: /.th/pcl340/scratch/gosam/greiner/dg_aad/helicity0d80h0l1.f90
   ! generator: buildfortran.py
   use dgaad_config, only: ki
   use dgaad_util, only: cond
   implicit none
   private
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ function brack_1:
   pure function brack_1(Q,mu2) result(brack)
      use dgaad_model
      use dgaad_kinematics
      use dgaad_color
      use dgaad_abbrevd80h0
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      complex(ki), intent(in) :: mu2
      complex(ki) :: brack
      complex(ki) :: acc80(35)
      complex(ki) :: Qspvae3k1
      complex(ki) :: Qspvae4k1
      complex(ki) :: Qspk1
      complex(ki) :: Qspk2
      complex(ki) :: Qspe4
      complex(ki) :: Qspe3
      complex(ki) :: Qspk5
      complex(ki) :: Qspk4
      complex(ki) :: Qspk3
      complex(ki) :: Qspvak5k2
      complex(ki) :: Qspe2
      complex(ki) :: QspQ
      complex(ki) :: Qspvak5e2
      Qspvae3k1 = dotproduct(Q,spvae3k1)
      Qspvae4k1 = dotproduct(Q,spvae4k1)
      Qspk1 = dotproduct(Q,k1)
      Qspk2 = dotproduct(Q,k2)
      Qspe4 = dotproduct(Q,e4)
      Qspe3 = dotproduct(Q,e3)
      Qspk5 = dotproduct(Q,k5)
      Qspk4 = dotproduct(Q,k4)
      Qspk3 = dotproduct(Q,k3)
      Qspvak5k2 = dotproduct(Q,spvak5k2)
      Qspe2 = dotproduct(Q,e2)
      QspQ = dotproduct(Q,Q)
      Qspvak5e2 = dotproduct(Q,spvak5e2)
      acc80(1)=abb80(5)
      acc80(2)=abb80(6)
      acc80(3)=abb80(7)
      acc80(4)=abb80(8)
      acc80(5)=abb80(9)
      acc80(6)=abb80(10)
      acc80(7)=abb80(11)
      acc80(8)=abb80(12)
      acc80(9)=abb80(13)
      acc80(10)=abb80(14)
      acc80(11)=abb80(15)
      acc80(12)=abb80(16)
      acc80(13)=abb80(20)
      acc80(14)=abb80(27)
      acc80(15)=abb80(28)
      acc80(16)=abb80(30)
      acc80(17)=abb80(33)
      acc80(18)=abb80(40)
      acc80(19)=abb80(51)
      acc80(20)=abb80(56)
      acc80(21)=abb80(59)
      acc80(22)=abb80(61)
      acc80(23)=abb80(64)
      acc80(24)=acc80(1)*Qspvae3k1
      acc80(25)=acc80(5)*Qspvae4k1
      acc80(26)=acc80(9)*Qspk1
      acc80(27)=acc80(15)*Qspk2
      acc80(28)=acc80(16)*Qspe4
      acc80(29)=acc80(18)*Qspe3
      acc80(30)=acc80(19)*Qspk5
      acc80(31)=acc80(21)*Qspk4
      acc80(32)=acc80(23)*Qspk3
      acc80(33)=Qspvak5k2*acc80(10)
      acc80(24)=acc80(33)+acc80(32)+acc80(31)+acc80(30)+acc80(29)+acc80(28)+acc&
      &80(27)+acc80(13)+acc80(26)+acc80(25)+acc80(24)
      acc80(24)=Qspe2*acc80(24)
      acc80(25)=mu2-QspQ
      acc80(25)=acc80(3)*acc80(25)
      acc80(26)=acc80(4)*Qspvae4k1
      acc80(27)=acc80(6)*Qspk2
      acc80(28)=acc80(7)*Qspk1
      acc80(29)=acc80(8)*Qspk5
      acc80(30)=acc80(11)*Qspvae3k1
      acc80(31)=acc80(14)*Qspe4
      acc80(32)=acc80(17)*Qspe3
      acc80(33)=acc80(20)*Qspk4
      acc80(34)=acc80(22)*Qspk3
      acc80(35)=Qspvak5e2*acc80(2)
      brack=acc80(12)+acc80(24)+acc80(25)+acc80(26)+acc80(27)+acc80(28)+acc80(2&
      &9)+acc80(30)+acc80(31)+acc80(32)+acc80(33)+acc80(34)+acc80(35)
   end  function brack_1
!---#] function brack_1:
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use dgaad_groups, only: &
!           & sign => diagram80_sign, shift => diagram80_shift
      use dgaad_globalsl1, only: epspow
      use dgaad_kinematics
      use dgaad_abbrevd80h0
      implicit none
      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d80
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      Q(1)  =cmplx(real(+Q_ext(4),  ki_sam),aimag(+Q_ext(4)),  ki)
      Q(2:4)=cmplx(real(+Q_ext(1:3),ki_sam),aimag(+Q_ext(1:3)),ki)
      mu2    = cmplx(real(mu2_ext, ki), aimag(mu2_ext), ki)
      d80 = 0.0_ki
      d80 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d80, ki), aimag(d80), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use dgaad_globalsl1, only: epspow
      use dgaad_kinematics
      use dgaad_abbrevd80h0
      implicit none
      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d80
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      Q(:)  =cmplx(real(+Q_ext(:),  ki_gol), 0.0_ki_gol, ki)
      mu2  = cmplx(real(mu2_ext, ki), 0.0_ki, ki)
      d80 = 0.0_ki
      d80 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d80, ki), aimag(d80), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module dgaad_d80h0l1
