module     dgaad_diagramsh0l0
   ! file: /.th/pcl340/scratch/gosam/greiner/dg_aad/helicity0diagramsl0.f90 
   ! generator: buildfortranborn.py 
   use dgaad_color, only: numcs
   use dgaad_config, only: ki

   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   complex(ki), dimension(numcs), parameter :: zero_col = 0.0_ki
   public :: amplitude

contains
!---#[ function amplitude:
   function amplitude()
      use dgaad_model
      use dgaad_kinematics
      use dgaad_color
      use dgaad_config, only: debug_lo_diagrams, &
        & use_sorted_sum
      use dgaad_accu, only: sorted_sum
      use dgaad_util, only: inspect_lo_diagram
      implicit none
      complex(ki), dimension(numcs) :: amplitude
      complex(ki), dimension(18) :: abb
!      complex(ki), dimension(2,numcs) :: diagrams
      integer :: i

      amplitude(:) = 0.0_ki


      abb(1)=es45**(-1)
      abb(2)=es12**(-1)
      abb(3)=1.0_ki/(-es34+es12-es45)
      abb(4)=1.0_ki/(-es23-es12+es45)
      abb(5)=1.0_ki/(es34-es51-es12)
      abb(6)=1.0_ki/(es23-es51-es45)
      abb(7)=-spae4k5*spbk5e3
      abb(8)=spak3e4*spbk3e3
      abb(7)=abb(8)+abb(7)
      abb(7)=spbe4k2*abb(3)*abb(7)
      abb(8)=spae4k5*spbe3k2*abb(1)
      abb(9)=-spbk5e4*abb(8)
      abb(7)=abb(9)+abb(7)
      abb(7)=abb(7)*spae3k5*i_
      abb(9)=spbk4e4*i_
      abb(8)=-spae3k4*abb(9)*abb(8)
      abb(7)=abb(8)+abb(7)
      abb(7)=spae2k2*abb(2)*abb(7)
      abb(8)=abb(6)*spbe4k1
      abb(10)=abb(3)*spae3k5
      abb(11)=spae2k5*i_
      abb(12)=spbk5e3*abb(10)*abb(8)*abb(11)
      abb(13)=spak1e4*abb(12)
      abb(9)=spae2k4*abb(9)
      abb(14)=spbk5e4*abb(11)
      abb(9)=abb(9)+abb(14)
      abb(14)=abb(4)*spae4k5
      abb(9)=abb(14)*abb(1)*spbe3k1*abb(9)
      abb(15)=spak1e3*abb(9)
      abb(7)=abb(13)+abb(7)+abb(15)
      abb(7)=spbe2k1*abb(7)
      abb(13)=spbk4e2*spae4k4
      abb(15)=spak1e4*spbe2k1
      abb(15)=abb(15)-abb(13)
      abb(10)=spae2k3*abb(10)*spbk3e3*abb(15)*i_
      abb(15)=spbk4e3*spae4k4
      abb(16)=spak1e4*spbe3k1
      abb(16)=abb(16)-abb(15)
      abb(11)=abb(11)*abb(5)
      abb(17)=abb(11)*spbk2e2
      abb(16)=spak2e3*abb(17)*abb(16)
      abb(10)=abb(16)+abb(10)
      abb(10)=abb(8)*abb(10)
      abb(16)=spak1e3*spbe4k1
      abb(18)=spbe4k3*spae3k3
      abb(16)=abb(16)+abb(18)
      abb(14)=abb(14)*abb(16)
      abb(8)=abb(8)*spae3k5
      abb(18)=spak1e4*abb(8)
      abb(14)=abb(18)+abb(14)
      abb(14)=spbe3k1*abb(14)
      abb(8)=-abb(8)*abb(15)
      abb(8)=abb(8)+abb(14)
      abb(8)=abb(11)*spbk5e2*abb(8)
      abb(11)=-abb(13)*abb(12)
      abb(12)=spak2e4*abb(17)*abb(16)*abb(4)*spbe3k1
      abb(9)=-spbk3e2*spae3k3*abb(9)
      abb(7)=abb(9)+abb(12)+abb(11)+abb(7)+abb(8)+abb(10)
      abb(7)=1.0_ki/9.0_ki*abb(7)

      amplitude=c1*abb(7)

      if (debug_lo_diagrams) then
         write(*,*) "Using Born optimization, debug_lo_diagrams not implemented."
      end if

!      if (use_sorted_sum) then
!         do i=1,numcs
!            amplitude(i) = sorted_sum(diagrams(i))
!         end do
!      else
!         do i=1,numcs
!            amplitude(i) = sum(diagrams(i))
!         end do
!      end if
   end function     amplitude
!---#] function amplitude:
end module dgaad_diagramsh0l0
