module     dgaad_abbrevd4h8
   use dgaad_config, only: ki
   use dgaad_globalsh8
   implicit none
   private
   complex(ki), dimension(35), public :: abb4
   complex(ki), public :: R2d4
   public :: init_abbrev
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
contains
   subroutine     init_abbrev()
      use dgaad_config, only: deltaOS, &
     &    logfile, debug_nlo_diagrams
      use dgaad_kinematics
      use dgaad_model
      use dgaad_color, only: TR
      use dgaad_globalsl1, only: epspow
      implicit none
      abb4(1)=1.0_ki/(-es23-es12+es45)
      abb4(2)=es45**(-1)
      abb4(3)=NC**(-1)
      abb4(4)=abb4(1)*i_*TR*c1*spbk5e4
      abb4(5)=abb4(2)*abb4(4)
      abb4(6)=abb4(5)*NC*spak1e3
      abb4(7)=abb4(6)*spae4k5
      abb4(8)=abb4(7)*spae2k3
      abb4(9)=spbk3e3*abb4(8)
      abb4(10)=abb4(7)*spak1e2
      abb4(11)=-spbe3k1*abb4(10)
      abb4(9)=abb4(9)+abb4(11)
      abb4(9)=spbk5k2*abb4(9)
      abb4(6)=abb4(6)*spae4k4
      abb4(11)=abb4(6)*spae2k3
      abb4(12)=spbk3e3*abb4(11)
      abb4(13)=abb4(6)*spak1e2
      abb4(14)=-spbe3k1*abb4(13)
      abb4(12)=abb4(12)+abb4(14)
      abb4(12)=spbk4k2*abb4(12)
      abb4(9)=abb4(9)+abb4(12)
      abb4(9)=spbk3e2*abb4(9)
      abb4(12)=abb4(6)*spbk4e2
      abb4(14)=abb4(7)*spbk5e2
      abb4(12)=abb4(12)+abb4(14)
      abb4(14)=spak1e2*abb4(12)
      abb4(15)=spbk2k1*spbk3e3*abb4(14)
      abb4(9)=1.0_ki/2.0_ki*abb4(9)+abb4(15)
      abb4(9)=spak2k3*abb4(9)
      abb4(12)=spae2k3*abb4(12)
      abb4(15)=spbk3k2*spbe3k1*abb4(12)
      abb4(16)=-spbk5k2*abb4(8)
      abb4(17)=-spbk4k2*abb4(11)
      abb4(16)=abb4(16)+abb4(17)
      abb4(16)=spbe2k1*spbk3e3*abb4(16)
      abb4(15)=abb4(15)+1.0_ki/2.0_ki*abb4(16)
      abb4(15)=spak1k2*abb4(15)
      abb4(16)=abb4(12)*spbk3e3
      abb4(17)=es23*abb4(16)
      abb4(14)=abb4(14)*spbe3k1
      abb4(18)=-es12*abb4(14)
      abb4(9)=abb4(18)+abb4(17)+abb4(15)+abb4(9)
      abb4(9)=1.0_ki/9.0_ki*abb4(9)
      abb4(15)=spbk5k3*spae2k3
      abb4(17)=spbk5k1*spak1e2
      abb4(15)=abb4(15)+abb4(17)
      abb4(17)=abb4(5)*spae4k5
      abb4(18)=abb4(17)*NC
      abb4(19)=-abb4(18)*abb4(15)
      abb4(20)=spbk4k3*spae2k3
      abb4(21)=spbk4k1*spak1e2
      abb4(20)=abb4(20)+abb4(21)
      abb4(5)=abb4(5)*spae4k4
      abb4(21)=abb4(5)*NC
      abb4(22)=-abb4(21)*abb4(20)
      abb4(23)=abb4(17)*abb4(3)
      abb4(24)=-abb4(18)-2.0_ki*abb4(23)
      abb4(25)=spbk5k2*spae2k2
      abb4(24)=abb4(24)*abb4(25)
      abb4(26)=abb4(5)*abb4(3)
      abb4(27)=-abb4(21)-2.0_ki*abb4(26)
      abb4(28)=spbk4k2*spae2k2
      abb4(27)=abb4(27)*abb4(28)
      abb4(19)=abb4(27)+abb4(24)+abb4(22)+abb4(19)
      abb4(19)=abb4(19)*spbk3e2
      abb4(22)=abb4(26)-abb4(21)
      abb4(24)=spbk4e2*spae2k2
      abb4(22)=abb4(22)*abb4(24)
      abb4(27)=abb4(23)-abb4(18)
      abb4(29)=spbk5e2*spae2k2
      abb4(27)=abb4(27)*abb4(29)
      abb4(22)=abb4(22)+abb4(27)
      abb4(22)=abb4(22)*spbk3k2
      abb4(19)=2.0_ki*abb4(22)+abb4(19)
      abb4(19)=spak1k3*abb4(19)
      abb4(27)=spbk4e2*spak1e2
      abb4(30)=abb4(27)*abb4(21)
      abb4(31)=spbk5e2*spak1e2
      abb4(32)=abb4(31)*abb4(18)
      abb4(30)=abb4(30)+abb4(32)
      abb4(32)=es12+es23
      abb4(32)=abb4(30)*abb4(32)
      abb4(33)=spbk5e2*spae4k5
      abb4(34)=spbk4e2*spae4k4
      abb4(33)=-abb4(33)-abb4(34)
      abb4(4)=spak1e2*abb4(33)*NC*abb4(4)
      abb4(4)=abb4(32)+abb4(4)+abb4(19)
      abb4(4)=1.0_ki/9.0_ki*abb4(4)
      abb4(19)=-spak2k3*spbk3e3
      abb4(32)=spak1k2*spbe3k1
      abb4(19)=abb4(32)+abb4(19)
      abb4(32)=abb4(6)*spbk4k2
      abb4(33)=abb4(7)*spbk5k2
      abb4(32)=abb4(32)+abb4(33)
      abb4(19)=abb4(32)*abb4(19)
      abb4(32)=-spbk4k3*spbe3k1
      abb4(33)=-spbk4k1*spbk3e3
      abb4(32)=abb4(33)+abb4(32)
      abb4(32)=abb4(6)*abb4(32)
      abb4(33)=-spbk5k3*spbe3k1
      abb4(34)=-spbk5k1*spbk3e3
      abb4(33)=abb4(34)+abb4(33)
      abb4(33)=abb4(7)*abb4(33)
      abb4(32)=abb4(33)+abb4(32)
      abb4(32)=spak1k3*abb4(32)
      abb4(19)=abb4(32)+abb4(19)
      abb4(19)=1.0_ki/9.0_ki*abb4(19)
      abb4(32)=abb4(26)+abb4(21)
      abb4(32)=abb4(32)*spbk4k3
      abb4(33)=abb4(23)+abb4(18)
      abb4(33)=abb4(33)*spbk5k3
      abb4(32)=abb4(32)+abb4(33)
      abb4(33)=8.0_ki/9.0_ki*spak1k3*abb4(32)
      abb4(8)=abb4(8)*spbk5k3
      abb4(11)=abb4(11)*spbk4k3
      abb4(8)=abb4(8)+abb4(11)
      abb4(11)=abb4(3)*spak1e3
      abb4(17)=abb4(11)*abb4(17)
      abb4(34)=abb4(7)+2.0_ki*abb4(17)
      abb4(34)=abb4(34)*abb4(25)
      abb4(5)=abb4(11)*abb4(5)
      abb4(11)=abb4(6)+2.0_ki*abb4(5)
      abb4(11)=abb4(11)*abb4(28)
      abb4(10)=abb4(10)*spbk5k1
      abb4(13)=abb4(13)*spbk4k1
      abb4(10)=abb4(11)+abb4(34)+abb4(10)+abb4(13)+abb4(8)
      abb4(10)=abb4(10)*spbe3e2
      abb4(11)=abb4(5)-abb4(6)
      abb4(13)=abb4(24)*abb4(11)
      abb4(24)=abb4(17)-abb4(7)
      abb4(29)=abb4(29)*abb4(24)
      abb4(13)=abb4(13)+abb4(29)
      abb4(29)=abb4(13)*spbe3k2
      abb4(14)=abb4(16)-abb4(14)
      abb4(16)=abb4(29)-abb4(14)
      abb4(10)=abb4(10)-2.0_ki*abb4(16)
      abb4(10)=1.0_ki/9.0_ki*abb4(10)
      abb4(16)=abb4(5)+abb4(6)
      abb4(29)=abb4(16)*spbk4e3
      abb4(34)=abb4(17)+abb4(7)
      abb4(35)=abb4(34)*spbk5e3
      abb4(29)=abb4(29)+abb4(35)
      abb4(29)=8.0_ki/9.0_ki*abb4(29)
      abb4(14)=2.0_ki/9.0_ki*abb4(14)
      abb4(27)=abb4(11)*abb4(27)
      abb4(31)=abb4(24)*abb4(31)
      abb4(27)=abb4(27)+abb4(31)
      abb4(27)=abb4(27)*spbe3k1
      abb4(11)=abb4(11)*spbk4e2
      abb4(24)=abb4(24)*spbk5e2
      abb4(11)=abb4(11)+abb4(24)
      abb4(11)=spbk3e3*spae2k3*abb4(11)
      abb4(11)=abb4(27)-abb4(11)
      abb4(11)=1.0_ki/9.0_ki*abb4(11)
      abb4(21)=1.0_ki/2.0_ki*abb4(21)
      abb4(20)=abb4(21)*abb4(20)
      abb4(18)=1.0_ki/2.0_ki*abb4(18)
      abb4(15)=abb4(18)*abb4(15)
      abb4(18)=abb4(18)+abb4(23)
      abb4(18)=abb4(18)*abb4(25)
      abb4(21)=abb4(21)+abb4(26)
      abb4(21)=abb4(21)*abb4(28)
      abb4(15)=abb4(18)+abb4(21)+abb4(15)+abb4(20)
      abb4(15)=abb4(15)*spbk3e2
      abb4(15)=-abb4(22)+abb4(15)
      abb4(15)=spae3k3*abb4(15)
      abb4(7)=-1.0_ki/2.0_ki*abb4(7)-abb4(17)
      abb4(7)=abb4(7)*abb4(25)
      abb4(6)=-1.0_ki/2.0_ki*abb4(6)-abb4(5)
      abb4(6)=abb4(6)*abb4(28)
      abb4(6)=abb4(7)+abb4(6)-1.0_ki/2.0_ki*abb4(8)
      abb4(6)=spbe2k1*abb4(6)
      abb4(7)=spbk2k1*abb4(13)
      abb4(8)=-spae3k3*abb4(30)
      abb4(8)=abb4(8)+abb4(12)
      abb4(8)=spbk3k1*abb4(8)
      abb4(6)=1.0_ki/2.0_ki*abb4(8)+abb4(7)+abb4(6)+abb4(15)
      abb4(6)=1.0_ki/9.0_ki*abb4(6)
      abb4(7)=-spae3k3*abb4(32)
      abb4(8)=-spbk5k1*abb4(34)
      abb4(12)=-spbk4k1*abb4(16)
      abb4(7)=abb4(12)+abb4(8)+abb4(7)
      abb4(7)=4.0_ki/9.0_ki*abb4(7)
      abb4(8)=2.0_ki/9.0_ki*abb4(34)
      abb4(12)=spbk3e3*abb4(8)
      abb4(13)=2.0_ki/9.0_ki*abb4(16)
      abb4(15)=spbk3e3*abb4(13)
      abb4(16)=spbk3e3*spae2k3
      abb4(18)=spbe3k1*spak1e2
      abb4(16)=abb4(16)-abb4(18)
      abb4(18)=1.0_ki/9.0_ki*spbk2e2
      abb4(16)=abb4(16)*abb4(18)
      abb4(17)=-abb4(17)*abb4(16)
      abb4(5)=-abb4(5)*abb4(16)
      abb4(8)=spbe3k1*abb4(8)
      abb4(13)=spbe3k1*abb4(13)
      R2d4=0.0_ki*(0.0_ki)
      rat2 = rat2 + R2d4
      if (debug_nlo_diagrams) then
          write (logfile,*) "<result name='r2' index='4' value='", &
          & R2d4, "'/>"
      end if
   end subroutine
end module dgaad_abbrevd4h8
