module     dgaad_d15h8l1
   ! file: /.th/pcl340/scratch/gosam/greiner/dg_aad/helicity8d15h8l1.f90
   ! generator: buildfortran.py
   use dgaad_config, only: ki
   use dgaad_util, only: cond
   implicit none
   private
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ function brack_1:
   pure function brack_1(Q,mu2) result(brack)
      use dgaad_model
      use dgaad_kinematics
      use dgaad_color
      use dgaad_abbrevd15h8
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      complex(ki), intent(in) :: mu2
      complex(ki) :: brack
      complex(ki) :: acc15(13)
      complex(ki) :: Qspvak1e3
      complex(ki) :: Qspvak3k1
      complex(ki) :: Qspvak1k3
      complex(ki) :: Qspe3
      complex(ki) :: Qspk3
      complex(ki) :: Qspk1
      Qspvak1e3 = dotproduct(Q,spvak1e3)
      Qspvak3k1 = dotproduct(Q,spvak3k1)
      Qspvak1k3 = dotproduct(Q,spvak1k3)
      Qspe3 = dotproduct(Q,e3)
      Qspk3 = dotproduct(Q,k3)
      Qspk1 = dotproduct(Q,k1)
      acc15(1)=abb15(5)
      acc15(2)=abb15(6)
      acc15(3)=abb15(7)
      acc15(4)=abb15(8)
      acc15(5)=abb15(9)
      acc15(6)=abb15(10)
      acc15(7)=abb15(15)
      acc15(8)=Qspvak1e3*acc15(2)
      acc15(9)=Qspvak3k1*acc15(4)
      acc15(10)=Qspvak1k3*acc15(5)
      acc15(11)=Qspe3*acc15(1)
      acc15(12)=Qspk3*acc15(3)
      acc15(13)=Qspk1*acc15(6)
      brack=acc15(7)+acc15(8)+acc15(9)+acc15(10)+acc15(11)+acc15(12)+acc15(13)
   end  function brack_1
!---#] function brack_1:
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use dgaad_groups, only: &
!           & sign => diagram15_sign, shift => diagram15_shift
      use dgaad_globalsl1, only: epspow
      use dgaad_kinematics
      use dgaad_abbrevd15h8
      implicit none
      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d15
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(0:3) :: qshift
      qshift = -k5-k4
      Q(1)  =cmplx(real(-Q_ext(4)  -qshift(0),  ki_sam),aimag(-Q_ext(4)),  ki)
      Q(2:4)=cmplx(real(-Q_ext(1:3)-qshift(1:3),ki_sam),aimag(-Q_ext(1:3)),ki)
      mu2    = cmplx(real(mu2_ext, ki), aimag(mu2_ext), ki)
      d15 = 0.0_ki
      d15 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d15, ki), aimag(d15), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use dgaad_globalsl1, only: epspow
      use dgaad_kinematics
      use dgaad_abbrevd15h8
      implicit none
      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d15
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(4) :: qshift
      qshift = -k5-k4
      Q(:)  =cmplx(real(-Q_ext(:)  -qshift(:),  ki_gol), 0.0_ki_gol, ki)
      mu2  = cmplx(real(mu2_ext, ki), 0.0_ki, ki)
      d15 = 0.0_ki
      d15 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d15, ki), aimag(d15), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module dgaad_d15h8l1
