module     dgaad_d2h8l1
   ! file: /.th/pcl340/scratch/gosam/greiner/dg_aad/helicity8d2h8l1.f90
   ! generator: buildfortran.py
   use dgaad_config, only: ki
   use dgaad_util, only: cond
   implicit none
   private
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ function brack_1:
   pure function brack_1(Q,mu2) result(brack)
      use dgaad_model
      use dgaad_kinematics
      use dgaad_color
      use dgaad_abbrevd2h8
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      complex(ki), intent(in) :: mu2
      complex(ki) :: brack
      complex(ki) :: acc2(18)
      complex(ki) :: Qspvak2k4
      complex(ki) :: Qspvak2k5
      complex(ki) :: Qspe2
      complex(ki) :: Qspvak1e2
      complex(ki) :: Qspk2
      complex(ki) :: Qspk1
      complex(ki) :: Qspe3
      complex(ki) :: Qspvak3k5
      complex(ki) :: Qspvak3k4
      complex(ki) :: QspQ
      Qspvak2k4 = dotproduct(Q,spvak2k4)
      Qspvak2k5 = dotproduct(Q,spvak2k5)
      Qspe2 = dotproduct(Q,e2)
      Qspvak1e2 = dotproduct(Q,spvak1e2)
      Qspk2 = dotproduct(Q,k2)
      Qspk1 = dotproduct(Q,k1)
      Qspe3 = dotproduct(Q,e3)
      Qspvak3k5 = dotproduct(Q,spvak3k5)
      Qspvak3k4 = dotproduct(Q,spvak3k4)
      QspQ = dotproduct(Q,Q)
      acc2(1)=abb2(4)
      acc2(2)=abb2(5)
      acc2(3)=abb2(6)
      acc2(4)=abb2(7)
      acc2(5)=abb2(8)
      acc2(6)=abb2(9)
      acc2(7)=abb2(10)
      acc2(8)=abb2(11)
      acc2(9)=abb2(12)
      acc2(10)=abb2(13)
      acc2(11)=abb2(15)
      acc2(12)=acc2(8)*Qspvak2k4
      acc2(13)=acc2(7)*Qspvak2k5
      acc2(14)=Qspe2*acc2(6)
      acc2(15)=Qspvak1e2*acc2(1)
      acc2(16)=Qspk2+Qspk1
      acc2(17)=-acc2(10)*acc2(16)
      acc2(12)=acc2(17)+acc2(15)+acc2(14)+acc2(12)+acc2(13)
      acc2(12)=Qspe3*acc2(12)
      acc2(13)=acc2(5)*Qspvak3k5
      acc2(14)=acc2(2)*Qspvak3k4
      acc2(15)=Qspe2*acc2(4)
      acc2(17)=Qspvak1e2*acc2(3)
      acc2(18)=mu2-QspQ
      acc2(18)=acc2(11)*acc2(18)
      acc2(16)=acc2(9)*acc2(16)
      brack=acc2(12)+acc2(13)+acc2(14)+acc2(15)+acc2(16)+acc2(17)+acc2(18)
   end  function brack_1
!---#] function brack_1:
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use dgaad_groups, only: &
!           & sign => diagram2_sign, shift => diagram2_shift
      use dgaad_globalsl1, only: epspow
      use dgaad_kinematics
      use dgaad_abbrevd2h8
      implicit none
      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d2
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(0:3) :: qshift
      qshift = k3+k5+k4
      Q(1)  =cmplx(real(+Q_ext(4)  -qshift(0),  ki_sam),aimag(+Q_ext(4)),  ki)
      Q(2:4)=cmplx(real(+Q_ext(1:3)-qshift(1:3),ki_sam),aimag(+Q_ext(1:3)),ki)
      mu2    = cmplx(real(mu2_ext, ki), aimag(mu2_ext), ki)
      d2 = 0.0_ki
      d2 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d2, ki), aimag(d2), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use dgaad_globalsl1, only: epspow
      use dgaad_kinematics
      use dgaad_abbrevd2h8
      implicit none
      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d2
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(4) :: qshift
      qshift = k3+k5+k4
      Q(:)  =cmplx(real(+Q_ext(:)  -qshift(:),  ki_gol), 0.0_ki_gol, ki)
      mu2  = cmplx(real(mu2_ext, ki), 0.0_ki, ki)
      d2 = 0.0_ki
      d2 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d2, ki), aimag(d2), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module dgaad_d2h8l1
