module     ugaau_abbrevd1h0
   use ugaau_config, only: ki
   use ugaau_globalsh0
   implicit none
   private
   complex(ki), dimension(17), public :: abb1
   complex(ki), public :: R2d1
   public :: init_abbrev
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
contains
   subroutine     init_abbrev()
      use ugaau_config, only: deltaOS, &
     &    logfile, debug_nlo_diagrams
      use ugaau_kinematics
      use ugaau_model
      use ugaau_color, only: TR
      use ugaau_globalsl1, only: epspow
      implicit none
      abb1(1)=1.0_ki/(-es34+es12-es45)
      abb1(2)=NC**(-1)
      abb1(3)=es12**(-1)
      abb1(4)=NC-abb1(2)
      abb1(5)=i_*TR*c1*spae3k5*abb1(3)*abb1(1)
      abb1(6)=abb1(4)*abb1(5)*spbk4e4
      abb1(7)=spbk3e3*abb1(6)
      abb1(8)=abb1(7)*spak3k4
      abb1(6)=spbk5e3*abb1(6)
      abb1(9)=abb1(6)*spak4k5
      abb1(8)=abb1(8)-abb1(9)
      abb1(8)=abb1(8)*spak2e4
      abb1(7)=abb1(7)*spak3e4
      abb1(6)=abb1(6)*spae4k5
      abb1(6)=abb1(7)-abb1(6)
      abb1(6)=abb1(6)*spak2k4
      abb1(6)=abb1(8)-abb1(6)
      abb1(7)=8.0_ki/9.0_ki*spbk2k1*abb1(6)
      abb1(8)=-abb1(5)*abb1(4)
      abb1(9)=-spak2k5*spbk5e3*abb1(8)
      abb1(8)=-spak2k3*spbk3e3*abb1(8)
      abb1(8)=abb1(9)+abb1(8)
      abb1(9)=32.0_ki/9.0_ki*spbk2k1*abb1(8)
      abb1(4)=-abb1(4)*abb1(5)*spbe2k1
      abb1(5)=-spbk5e3*abb1(4)
      abb1(10)=-spbk4e4*abb1(5)
      abb1(11)=abb1(10)*spae4k5
      abb1(4)=-spbk3e3*abb1(4)
      abb1(12)=-spbk4e4*abb1(4)
      abb1(13)=abb1(12)*spak3e4
      abb1(11)=abb1(11)-abb1(13)
      abb1(13)=abb1(11)*spae2k4
      abb1(10)=abb1(10)*spak4k5
      abb1(12)=abb1(12)*spak3k4
      abb1(10)=abb1(10)-abb1(12)
      abb1(12)=abb1(10)*spae2e4
      abb1(12)=abb1(13)-abb1(12)
      abb1(12)=8.0_ki/9.0_ki*abb1(12)
      abb1(13)=abb1(5)*spae2k5
      abb1(14)=abb1(4)*spae2k3
      abb1(13)=abb1(13)+abb1(14)
      abb1(13)=32.0_ki/9.0_ki*abb1(13)
      abb1(14)=abb1(4)*spae2k2
      abb1(15)=abb1(14)*spak3e4
      abb1(16)=abb1(5)*spae2k2
      abb1(17)=abb1(16)*spae4k5
      abb1(15)=abb1(15)-abb1(17)
      abb1(17)=4.0_ki/9.0_ki*spbe4k2
      abb1(15)=abb1(15)*abb1(17)
      abb1(6)=-spbk2e2*abb1(6)
      abb1(10)=spak1e4*abb1(10)
      abb1(11)=-spak1k4*abb1(11)
      abb1(6)=abb1(11)+abb1(10)+abb1(6)
      abb1(6)=4.0_ki/9.0_ki*abb1(6)
      abb1(8)=-spbk2e2*abb1(8)
      abb1(5)=spak1k5*abb1(5)
      abb1(4)=spak1k3*abb1(4)
      abb1(4)=abb1(4)+abb1(5)+abb1(8)
      abb1(4)=16.0_ki/9.0_ki*abb1(4)
      abb1(5)=abb1(17)*spae4k4
      abb1(8)=-abb1(16)*abb1(5)
      abb1(10)=8.0_ki/9.0_ki*abb1(16)
      abb1(5)=-abb1(14)*abb1(5)
      abb1(11)=8.0_ki/9.0_ki*abb1(14)
      R2d1=0.0_ki*(0.0_ki)
      rat2 = rat2 + R2d1
      if (debug_nlo_diagrams) then
          write (logfile,*) "<result name='r2' index='1' value='", &
          & R2d1, "'/>"
      end if
   end subroutine
end module ugaau_abbrevd1h0
