module     ugaau_abbrevd3h0
   use ugaau_config, only: ki
   use ugaau_globalsh0
   implicit none
   private
   complex(ki), dimension(17), public :: abb3
   complex(ki), public :: R2d3
   public :: init_abbrev
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
contains
   subroutine     init_abbrev()
      use ugaau_config, only: deltaOS, &
     &    logfile, debug_nlo_diagrams
      use ugaau_kinematics
      use ugaau_model
      use ugaau_color, only: TR
      use ugaau_globalsl1, only: epspow
      implicit none
      abb3(1)=1.0_ki/(-es23-es12+es45)
      abb3(2)=1.0_ki/(es34-es51-es12)
      abb3(3)=NC**(-1)
      abb3(4)=NC-abb3(3)
      abb3(5)=i_*TR*c1*spae2k5*abb3(2)*abb3(1)
      abb3(6)=-abb3(5)*abb3(4)
      abb3(7)=-spbk5e2*abb3(6)
      abb3(8)=spak4k5*spbk4e4
      abb3(9)=abb3(7)*abb3(8)
      abb3(6)=-spbk2e2*abb3(6)
      abb3(10)=spak2k4*spbk4e4
      abb3(11)=abb3(6)*abb3(10)
      abb3(9)=abb3(9)+abb3(11)
      abb3(9)=abb3(9)*spak3e4
      abb3(11)=spae4k5*spbk4e4
      abb3(12)=abb3(7)*abb3(11)
      abb3(13)=spak2e4*spbk4e4
      abb3(14)=abb3(6)*abb3(13)
      abb3(12)=abb3(12)+abb3(14)
      abb3(12)=abb3(12)*spak3k4
      abb3(9)=abb3(9)-abb3(12)
      abb3(12)=8.0_ki/9.0_ki*spbk3k1*abb3(9)
      abb3(7)=abb3(7)*spak3k5
      abb3(6)=abb3(6)*spak2k3
      abb3(6)=abb3(7)+abb3(6)
      abb3(7)=-32.0_ki/9.0_ki*spbk3k1*abb3(6)
      abb3(5)=abb3(5)*spbe3k1
      abb3(14)=-abb3(4)*abb3(5)*spbk5e2
      abb3(8)=abb3(14)*abb3(8)
      abb3(4)=-abb3(4)*abb3(5)*spbk2e2
      abb3(5)=abb3(4)*abb3(10)
      abb3(5)=abb3(8)+abb3(5)
      abb3(8)=abb3(5)*spae3e4
      abb3(10)=abb3(14)*abb3(11)
      abb3(11)=abb3(4)*abb3(13)
      abb3(10)=abb3(10)+abb3(11)
      abb3(11)=abb3(10)*spae3k4
      abb3(8)=abb3(8)-abb3(11)
      abb3(8)=8.0_ki/9.0_ki*abb3(8)
      abb3(11)=abb3(14)*spae3k5
      abb3(13)=abb3(4)*spak2e3
      abb3(11)=abb3(11)+abb3(13)
      abb3(11)=32.0_ki/9.0_ki*abb3(11)
      abb3(13)=abb3(14)*spae4k5
      abb3(15)=abb3(4)*spak2e4
      abb3(13)=abb3(13)+abb3(15)
      abb3(15)=spbe4k3*spae3k3
      abb3(16)=spbe4k1*spak1e3
      abb3(15)=abb3(15)+abb3(16)
      abb3(13)=abb3(15)*abb3(13)
      abb3(13)=4.0_ki/9.0_ki*abb3(13)
      abb3(9)=-spbk3e3*abb3(9)
      abb3(5)=spak1e4*abb3(5)
      abb3(10)=-spak1k4*abb3(10)
      abb3(5)=abb3(10)+abb3(5)+abb3(9)
      abb3(5)=4.0_ki/9.0_ki*abb3(5)
      abb3(6)=spbk3e3*abb3(6)
      abb3(9)=-spak1k5*abb3(14)
      abb3(10)=spak1k2*abb3(4)
      abb3(6)=abb3(10)+abb3(9)+abb3(6)
      abb3(6)=16.0_ki/9.0_ki*abb3(6)
      abb3(9)=4.0_ki/9.0_ki*spae4k4
      abb3(9)=abb3(15)*abb3(9)
      abb3(10)=-abb3(14)*abb3(9)
      abb3(15)=8.0_ki/9.0_ki*spae3k3
      abb3(16)=abb3(14)*abb3(15)
      abb3(17)=8.0_ki/9.0_ki*spak1e3
      abb3(14)=abb3(14)*abb3(17)
      abb3(9)=abb3(4)*abb3(9)
      abb3(15)=-abb3(4)*abb3(15)
      abb3(4)=-abb3(4)*abb3(17)
      R2d3=0.0_ki*(0.0_ki)
      rat2 = rat2 + R2d3
      if (debug_nlo_diagrams) then
          write (logfile,*) "<result name='r2' index='3' value='", &
          & R2d3, "'/>"
      end if
   end subroutine
end module ugaau_abbrevd3h0
