module     ugaau_abbrevd4h0
   use ugaau_config, only: ki
   use ugaau_globalsh0
   implicit none
   private
   complex(ki), dimension(32), public :: abb4
   complex(ki), public :: R2d4
   public :: init_abbrev
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
contains
   subroutine     init_abbrev()
      use ugaau_config, only: deltaOS, &
     &    logfile, debug_nlo_diagrams
      use ugaau_kinematics
      use ugaau_model
      use ugaau_color, only: TR
      use ugaau_globalsl1, only: epspow
      implicit none
      abb4(1)=1.0_ki/(-es23-es12+es45)
      abb4(2)=es45**(-1)
      abb4(3)=NC**(-1)
      abb4(4)=abb4(1)*i_*TR*c1*spae4k5
      abb4(5)=abb4(2)*abb4(4)
      abb4(6)=abb4(5)*NC*spbe3k1
      abb4(7)=abb4(6)*spbk4e4
      abb4(8)=abb4(7)*spae2k4
      abb4(6)=abb4(6)*spbk5e4
      abb4(9)=abb4(6)*spae2k5
      abb4(8)=abb4(8)+abb4(9)
      abb4(9)=spbk3e2*abb4(8)
      abb4(10)=abb4(9)*spae3k3
      abb4(11)=es23*abb4(10)
      abb4(8)=spbe2k1*abb4(8)
      abb4(12)=abb4(8)*spak1e3
      abb4(13)=es12*abb4(12)
      abb4(11)=abb4(11)-abb4(13)
      abb4(13)=abb4(6)*spbk3e2
      abb4(14)=spae3k3*abb4(13)
      abb4(15)=abb4(6)*spbe2k1
      abb4(16)=-spak1e3*abb4(15)
      abb4(14)=abb4(14)+abb4(16)
      abb4(14)=spak2k5*abb4(14)
      abb4(16)=abb4(7)*spbk3e2
      abb4(17)=spae3k3*abb4(16)
      abb4(18)=abb4(7)*spbe2k1
      abb4(19)=-spak1e3*abb4(18)
      abb4(17)=abb4(17)+abb4(19)
      abb4(17)=spak2k4*abb4(17)
      abb4(14)=abb4(14)+abb4(17)
      abb4(14)=spae2k3*abb4(14)
      abb4(8)=spak1k2*spae3k3*abb4(8)
      abb4(8)=2.0_ki*abb4(8)+abb4(14)
      abb4(8)=spbk3k2*abb4(8)
      abb4(14)=2.0_ki*spak2k3
      abb4(17)=spak1e3*abb4(9)*abb4(14)
      abb4(19)=-spak2k5*abb4(13)
      abb4(20)=-spak2k4*abb4(16)
      abb4(19)=abb4(19)+abb4(20)
      abb4(19)=spak1e2*spae3k3*abb4(19)
      abb4(17)=abb4(17)+abb4(19)
      abb4(17)=spbk2k1*abb4(17)
      abb4(8)=abb4(17)+abb4(8)+2.0_ki*abb4(11)
      abb4(8)=2.0_ki/9.0_ki*abb4(8)
      abb4(11)=abb4(5)*spbk5e4
      abb4(17)=abb4(11)*abb4(3)
      abb4(19)=abb4(11)*NC
      abb4(20)=abb4(19)+2.0_ki*abb4(17)
      abb4(21)=spak2k5*spbk2e2
      abb4(20)=abb4(20)*abb4(21)
      abb4(5)=abb4(5)*spbk4e4
      abb4(22)=abb4(5)*abb4(3)
      abb4(23)=abb4(5)*NC
      abb4(24)=abb4(23)+2.0_ki*abb4(22)
      abb4(25)=spak2k4*spbk2e2
      abb4(24)=abb4(24)*abb4(25)
      abb4(26)=spak3k5*spbk3e2
      abb4(27)=spak1k5*spbe2k1
      abb4(26)=abb4(26)+abb4(27)
      abb4(26)=abb4(26)*abb4(19)
      abb4(27)=spak3k4*spbk3e2
      abb4(28)=spak1k4*spbe2k1
      abb4(27)=abb4(27)+abb4(28)
      abb4(27)=abb4(27)*abb4(23)
      abb4(20)=abb4(20)+abb4(24)+abb4(26)+abb4(27)
      abb4(20)=abb4(20)*spae2k3
      abb4(24)=abb4(22)-abb4(23)
      abb4(26)=spae2k4*spbk2e2
      abb4(24)=abb4(24)*abb4(26)
      abb4(27)=abb4(17)-abb4(19)
      abb4(28)=spae2k5*spbk2e2
      abb4(27)=abb4(27)*abb4(28)
      abb4(24)=abb4(24)+abb4(27)
      abb4(14)=abb4(24)*abb4(14)
      abb4(14)=abb4(20)-abb4(14)
      abb4(20)=-spbk3k1*abb4(14)
      abb4(24)=spae2k4*spbe2k1
      abb4(27)=abb4(24)*abb4(23)
      abb4(29)=spae2k5*spbe2k1
      abb4(30)=abb4(29)*abb4(19)
      abb4(27)=abb4(27)+abb4(30)
      abb4(30)=es12+es23
      abb4(30)=abb4(27)*abb4(30)
      abb4(31)=spae2k5*spbk5e4
      abb4(32)=spae2k4*spbk4e4
      abb4(31)=-abb4(31)-abb4(32)
      abb4(4)=spbe2k1*abb4(31)*NC*abb4(4)
      abb4(4)=abb4(30)+abb4(4)+abb4(20)
      abb4(4)=4.0_ki/9.0_ki*abb4(4)
      abb4(20)=-spbk3k2*spae3k3
      abb4(30)=spbk2k1*spak1e3
      abb4(20)=abb4(30)+abb4(20)
      abb4(30)=abb4(7)*spak2k4
      abb4(31)=abb4(6)*spak2k5
      abb4(30)=abb4(30)+abb4(31)
      abb4(20)=abb4(30)*abb4(20)
      abb4(30)=-spak3k4*spak1e3
      abb4(31)=-spak1k4*spae3k3
      abb4(30)=abb4(31)+abb4(30)
      abb4(30)=abb4(7)*abb4(30)
      abb4(31)=-spak3k5*spak1e3
      abb4(32)=-spak1k5*spae3k3
      abb4(31)=abb4(32)+abb4(31)
      abb4(31)=abb4(6)*abb4(31)
      abb4(30)=abb4(31)+abb4(30)
      abb4(30)=spbk3k1*abb4(30)
      abb4(20)=abb4(30)+abb4(20)
      abb4(20)=4.0_ki/9.0_ki*abb4(20)
      abb4(22)=abb4(22)+abb4(23)
      abb4(22)=abb4(22)*spak3k4
      abb4(17)=abb4(17)+abb4(19)
      abb4(17)=abb4(17)*spak3k5
      abb4(17)=abb4(22)+abb4(17)
      abb4(19)=32.0_ki/9.0_ki*spbk3k1*abb4(17)
      abb4(22)=abb4(3)*spbe3k1
      abb4(11)=abb4(22)*abb4(11)
      abb4(23)=abb4(6)+2.0_ki*abb4(11)
      abb4(21)=abb4(23)*abb4(21)
      abb4(5)=abb4(22)*abb4(5)
      abb4(22)=abb4(7)+2.0_ki*abb4(5)
      abb4(22)=abb4(22)*abb4(25)
      abb4(13)=abb4(13)*spak3k5
      abb4(16)=abb4(16)*spak3k4
      abb4(13)=abb4(13)+abb4(16)+abb4(21)+abb4(22)
      abb4(15)=abb4(15)*spak1k5
      abb4(16)=abb4(18)*spak1k4
      abb4(15)=abb4(16)+abb4(13)+abb4(15)
      abb4(15)=abb4(15)*spae2e3
      abb4(16)=abb4(5)-abb4(7)
      abb4(18)=abb4(26)*abb4(16)
      abb4(21)=abb4(11)-abb4(6)
      abb4(22)=abb4(28)*abb4(21)
      abb4(18)=abb4(18)+abb4(22)
      abb4(18)=2.0_ki*abb4(18)
      abb4(22)=abb4(18)*spak2e3
      abb4(10)=abb4(10)-abb4(12)
      abb4(12)=abb4(15)-abb4(22)+2.0_ki*abb4(10)
      abb4(12)=4.0_ki/9.0_ki*abb4(12)
      abb4(7)=abb4(5)+abb4(7)
      abb4(15)=abb4(7)*spae3k4
      abb4(6)=abb4(11)+abb4(6)
      abb4(22)=abb4(6)*spae3k5
      abb4(15)=abb4(15)+abb4(22)
      abb4(15)=32.0_ki/9.0_ki*abb4(15)
      abb4(10)=8.0_ki/9.0_ki*abb4(10)
      abb4(22)=abb4(16)*abb4(24)
      abb4(23)=abb4(21)*abb4(29)
      abb4(22)=abb4(22)+abb4(23)
      abb4(22)=abb4(22)*spak1e3
      abb4(16)=abb4(16)*spae2k4
      abb4(21)=abb4(21)*spae2k5
      abb4(16)=abb4(16)+abb4(21)
      abb4(16)=spae3k3*spbk3e2*abb4(16)
      abb4(16)=abb4(22)-abb4(16)
      abb4(16)=4.0_ki/9.0_ki*abb4(16)
      abb4(14)=spbk3e3*abb4(14)
      abb4(13)=-spak1e2*abb4(13)
      abb4(18)=spak1k2*abb4(18)
      abb4(21)=-spbk3e3*abb4(27)
      abb4(9)=abb4(21)+abb4(9)
      abb4(9)=spak1k3*abb4(9)
      abb4(9)=abb4(9)+abb4(18)+abb4(13)+abb4(14)
      abb4(9)=2.0_ki/9.0_ki*abb4(9)
      abb4(13)=-spbk3e3*abb4(17)
      abb4(14)=-spak1k5*abb4(6)
      abb4(17)=-spak1k4*abb4(7)
      abb4(13)=abb4(17)+abb4(14)+abb4(13)
      abb4(13)=16.0_ki/9.0_ki*abb4(13)
      abb4(6)=8.0_ki/9.0_ki*abb4(6)
      abb4(14)=spae3k3*abb4(6)
      abb4(17)=spae3k3*spbk3e2
      abb4(18)=spak1e3*spbe2k1
      abb4(17)=abb4(17)-abb4(18)
      abb4(18)=4.0_ki/9.0_ki*spae2k2
      abb4(17)=abb4(17)*abb4(18)
      abb4(11)=-abb4(11)*abb4(17)
      abb4(6)=spak1e3*abb4(6)
      abb4(7)=8.0_ki/9.0_ki*abb4(7)
      abb4(18)=spae3k3*abb4(7)
      abb4(5)=-abb4(5)*abb4(17)
      abb4(7)=spak1e3*abb4(7)
      R2d4=0.0_ki*(0.0_ki)
      rat2 = rat2 + R2d4
      if (debug_nlo_diagrams) then
          write (logfile,*) "<result name='r2' index='4' value='", &
          & R2d4, "'/>"
      end if
   end subroutine
end module ugaau_abbrevd4h0
