module     ugaau_abbrevd63h0
   use ugaau_config, only: ki
   use ugaau_globalsh0
   implicit none
   private
   complex(ki), dimension(37), public :: abb63
   complex(ki), public :: R2d63
   public :: init_abbrev
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
contains
   subroutine     init_abbrev()
      use ugaau_config, only: deltaOS, &
     &    logfile, debug_nlo_diagrams
      use ugaau_kinematics
      use ugaau_model
      use ugaau_color, only: TR
      use ugaau_globalsl1, only: epspow
      implicit none
      abb63(1)=1.0_ki/(-es34+es12-es45)
      abb63(2)=NC**(-1)
      abb63(3)=spbk4k1*spae2k4
      abb63(4)=-spbk2k1*spae2k2
      abb63(3)=abb63(4)+abb63(3)
      abb63(4)=i_*TR*c1*spae3k5*abb63(2)*abb63(1)
      abb63(5)=abb63(4)*spbk3e3
      abb63(6)=abb63(5)*spak3e4
      abb63(4)=abb63(4)*spbk5e3
      abb63(7)=abb63(4)*spae4k5
      abb63(6)=abb63(6)-abb63(7)
      abb63(7)=-spbe4e2*abb63(6)
      abb63(3)=abb63(7)*abb63(3)
      abb63(8)=spbk4e4*spae2k4
      abb63(9)=-abb63(8)*abb63(6)
      abb63(10)=spbe2k1*abb63(9)
      abb63(3)=abb63(10)+abb63(3)
      abb63(3)=4.0_ki/9.0_ki*abb63(3)
      abb63(10)=8.0_ki/9.0_ki*abb63(6)
      abb63(11)=-spbe4k1*abb63(10)
      abb63(12)=8.0_ki/9.0_ki*spbk4k1
      abb63(13)=abb63(4)*spae2k4
      abb63(14)=-abb63(13)*abb63(12)
      abb63(15)=abb63(4)*spbe4k1
      abb63(16)=abb63(15)*spae2e4
      abb63(17)=8.0_ki/9.0_ki*abb63(16)
      abb63(16)=4.0_ki/9.0_ki*abb63(16)
      abb63(18)=abb63(5)*spae2k4
      abb63(12)=-abb63(18)*abb63(12)
      abb63(19)=abb63(5)*spbe4k1
      abb63(20)=abb63(19)*spae2e4
      abb63(21)=8.0_ki/9.0_ki*abb63(20)
      abb63(20)=4.0_ki/9.0_ki*abb63(20)
      abb63(22)=abb63(4)*spbk4e2
      abb63(23)=abb63(22)*spak4k5
      abb63(24)=abb63(5)*spbk4e2
      abb63(25)=abb63(24)*spak3k4
      abb63(23)=abb63(23)-abb63(25)
      abb63(25)=spbe4k2*spae2k2
      abb63(8)=abb63(25)+abb63(8)
      abb63(8)=-4.0_ki/9.0_ki*abb63(8)*abb63(23)
      abb63(26)=-spak4k5*abb63(4)
      abb63(27)=spak3k4*abb63(5)
      abb63(26)=abb63(26)+abb63(27)
      abb63(27)=8.0_ki/9.0_ki*spbk4e4
      abb63(26)=abb63(26)*abb63(27)
      abb63(27)=abb63(5)*spae2k3
      abb63(28)=abb63(4)*spae2k5
      abb63(27)=abb63(27)+abb63(28)
      abb63(28)=spbe4e2*abb63(27)
      abb63(29)=-8.0_ki/9.0_ki*abb63(28)
      abb63(28)=-4.0_ki/9.0_ki*abb63(28)
      abb63(30)=spak2k5*abb63(4)
      abb63(31)=spak2k3*abb63(5)
      abb63(30)=abb63(31)+abb63(30)
      abb63(30)=spbk2e2*abb63(30)
      abb63(23)=-2.0_ki*abb63(23)+abb63(30)
      abb63(23)=8.0_ki/9.0_ki*abb63(23)
      abb63(30)=8.0_ki/9.0_ki*abb63(7)
      abb63(7)=4.0_ki/9.0_ki*abb63(7)
      abb63(31)=spae4k4*spbe4k1
      abb63(31)=4.0_ki/9.0_ki*abb63(31)
      abb63(32)=abb63(31)*abb63(22)
      abb63(33)=spae2k4*abb63(32)
      abb63(34)=8.0_ki/9.0_ki*spbe2k1
      abb63(13)=abb63(13)*abb63(34)
      abb63(35)=8.0_ki/9.0_ki*spae4k4
      abb63(15)=abb63(15)*abb63(35)
      abb63(32)=-spae2k2*abb63(32)
      abb63(36)=abb63(34)*spae2k2
      abb63(37)=-abb63(4)*abb63(36)
      abb63(4)=16.0_ki/9.0_ki*abb63(4)
      abb63(6)=-abb63(6)*abb63(25)
      abb63(6)=abb63(6)+abb63(9)
      abb63(6)=4.0_ki/9.0_ki*spbk4e2*abb63(6)
      abb63(9)=spae2k5*abb63(22)
      abb63(22)=spae2k3*abb63(24)
      abb63(9)=abb63(9)+abb63(22)
      abb63(9)=16.0_ki/9.0_ki*abb63(9)
      abb63(10)=-spbk4e4*abb63(10)
      abb63(22)=abb63(31)*abb63(24)
      abb63(24)=spae2k4*abb63(22)
      abb63(18)=abb63(18)*abb63(34)
      abb63(19)=abb63(19)*abb63(35)
      abb63(22)=-spae2k2*abb63(22)
      abb63(25)=-abb63(5)*abb63(36)
      abb63(5)=16.0_ki/9.0_ki*abb63(5)
      abb63(27)=-8.0_ki/9.0_ki*spbk2e2*abb63(27)
      R2d63=0.0_ki*(0.0_ki)
      rat2 = rat2 + R2d63
      if (debug_nlo_diagrams) then
          write (logfile,*) "<result name='r2' index='63' value='", &
          & R2d63, "'/>"
      end if
   end subroutine
end module ugaau_abbrevd63h0
