module     ugaau_d10h0l1
   ! file: /.th/pcl340/scratch/gosam/greiner/ug_aau/helicity0d10h0l1.f90
   ! generator: buildfortran.py
   use ugaau_config, only: ki
   use ugaau_util, only: cond
   implicit none
   private
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ function brack_1:
   pure function brack_1(Q,mu2) result(brack)
      use ugaau_model
      use ugaau_kinematics
      use ugaau_color
      use ugaau_abbrevd10h0
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      complex(ki), intent(in) :: mu2
      complex(ki) :: brack
      complex(ki) :: acc10(23)
      complex(ki) :: Qspvae3k1
      complex(ki) :: Qspvae2k1
      complex(ki) :: Qspvak5k4
      complex(ki) :: Qspvak4k5
      complex(ki) :: Qspe3
      complex(ki) :: Qspe2
      complex(ki) :: Qspk5
      complex(ki) :: Qspk4
      complex(ki) :: Qspk3
      complex(ki) :: Qspk2
      complex(ki) :: Qspk1
      Qspvae3k1 = dotproduct(Q,spvae3k1)
      Qspvae2k1 = dotproduct(Q,spvae2k1)
      Qspvak5k4 = dotproduct(Q,spvak5k4)
      Qspvak4k5 = dotproduct(Q,spvak4k5)
      Qspe3 = dotproduct(Q,e3)
      Qspe2 = dotproduct(Q,e2)
      Qspk5 = dotproduct(Q,k5)
      Qspk4 = dotproduct(Q,k4)
      Qspk3 = dotproduct(Q,k3)
      Qspk2 = dotproduct(Q,k2)
      Qspk1 = dotproduct(Q,k1)
      acc10(1)=abb10(5)
      acc10(2)=abb10(6)
      acc10(3)=abb10(7)
      acc10(4)=abb10(8)
      acc10(5)=abb10(9)
      acc10(6)=abb10(10)
      acc10(7)=abb10(11)
      acc10(8)=abb10(14)
      acc10(9)=abb10(16)
      acc10(10)=abb10(19)
      acc10(11)=abb10(22)
      acc10(12)=abb10(26)
      acc10(13)=Qspvae3k1*acc10(1)
      acc10(14)=Qspvae2k1*acc10(5)
      acc10(15)=Qspvak5k4*acc10(2)
      acc10(16)=Qspvak4k5*acc10(7)
      acc10(17)=Qspe3*acc10(6)
      acc10(18)=Qspe2*acc10(12)
      acc10(19)=Qspk5*acc10(11)
      acc10(20)=Qspk4*acc10(4)
      acc10(21)=Qspk3*acc10(9)
      acc10(22)=Qspk2*acc10(10)
      acc10(23)=Qspk1*acc10(8)
      brack=acc10(3)+acc10(13)+acc10(14)+acc10(15)+acc10(16)+acc10(17)+acc10(18&
      &)+acc10(19)+acc10(20)+acc10(21)+acc10(22)+acc10(23)
   end  function brack_1
!---#] function brack_1:
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use ugaau_groups, only: &
!           & sign => diagram10_sign, shift => diagram10_shift
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd10h0
      implicit none
      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d10
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(0:3) :: qshift
      qshift = k5+k4
      Q(1)  =cmplx(real(+Q_ext(4)  -qshift(0),  ki_sam),aimag(+Q_ext(4)),  ki)
      Q(2:4)=cmplx(real(+Q_ext(1:3)-qshift(1:3),ki_sam),aimag(+Q_ext(1:3)),ki)
      mu2    = cmplx(real(mu2_ext, ki), aimag(mu2_ext), ki)
      d10 = 0.0_ki
      d10 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d10, ki), aimag(d10), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd10h0
      implicit none
      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d10
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(4) :: qshift
      qshift = k5+k4
      Q(:)  =cmplx(real(+Q_ext(:)  -qshift(:),  ki_gol), 0.0_ki_gol, ki)
      mu2  = cmplx(real(mu2_ext, ki), 0.0_ki, ki)
      d10 = 0.0_ki
      d10 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d10, ki), aimag(d10), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module ugaau_d10h0l1
