module     ugaau_d126h0l1
   ! file: /.th/pcl340/scratch/gosam/greiner/ug_aau/helicity0d126h0l1.f90
   ! generator: buildfortran.py
   use ugaau_config, only: ki
   use ugaau_util, only: cond
   implicit none
   private
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ function brack_1:
   pure function brack_1(Q,mu2) result(brack)
      use ugaau_model
      use ugaau_kinematics
      use ugaau_color
      use ugaau_abbrevd126h0
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      complex(ki), intent(in) :: mu2
      complex(ki) :: brack
      complex(ki) :: acc126(13)
      complex(ki) :: Qspk3
      complex(ki) :: Qspvae3k1
      complex(ki) :: Qspvak1k3
      complex(ki) :: Qspe3
      complex(ki) :: Qspk1
      complex(ki) :: Qspvak3k1
      complex(ki) :: QspQ
      Qspk3 = dotproduct(Q,k3)
      Qspvae3k1 = dotproduct(Q,spvae3k1)
      Qspvak1k3 = dotproduct(Q,spvak1k3)
      Qspe3 = dotproduct(Q,e3)
      Qspk1 = dotproduct(Q,k1)
      Qspvak3k1 = dotproduct(Q,spvak3k1)
      QspQ = dotproduct(Q,Q)
      acc126(1)=abb126(5)
      acc126(2)=abb126(6)
      acc126(3)=abb126(9)
      acc126(4)=abb126(11)
      acc126(5)=abb126(12)
      acc126(6)=abb126(17)
      acc126(7)=abb126(21)
      acc126(8)=acc126(6)*Qspk3
      acc126(9)=acc126(5)*Qspvae3k1
      acc126(10)=acc126(2)*Qspvak1k3
      acc126(11)=Qspe3*acc126(7)*Qspk1
      acc126(12)=Qspe3*acc126(1)
      acc126(12)=acc126(4)+acc126(12)
      acc126(12)=Qspvak3k1*acc126(12)
      acc126(13)=-mu2+QspQ
      acc126(13)=acc126(3)*acc126(13)
      brack=acc126(8)+acc126(9)+acc126(10)+acc126(11)+acc126(12)+acc126(13)
   end  function brack_1
!---#] function brack_1:
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use ugaau_groups, only: &
!           & sign => diagram126_sign, shift => diagram126_shift
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd126h0
      implicit none
      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d126
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(0:3) :: qshift
      qshift = -k3-k5-k4
      Q(1)  =cmplx(real(-Q_ext(4)  -qshift(0),  ki_sam),aimag(-Q_ext(4)),  ki)
      Q(2:4)=cmplx(real(-Q_ext(1:3)-qshift(1:3),ki_sam),aimag(-Q_ext(1:3)),ki)
      mu2    = cmplx(real(mu2_ext, ki), aimag(mu2_ext), ki)
      d126 = 0.0_ki
      d126 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d126, ki), aimag(d126), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd126h0
      implicit none
      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d126
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(4) :: qshift
      qshift = -k3-k5-k4
      Q(:)  =cmplx(real(-Q_ext(:)  -qshift(:),  ki_gol), 0.0_ki_gol, ki)
      mu2  = cmplx(real(mu2_ext, ki), 0.0_ki, ki)
      d126 = 0.0_ki
      d126 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d126, ki), aimag(d126), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module ugaau_d126h0l1
