module     ugaau_d23h0l1
   ! file: /.th/pcl340/scratch/gosam/greiner/ug_aau/helicity0d23h0l1.f90
   ! generator: buildfortran.py
   use ugaau_config, only: ki
   use ugaau_util, only: cond
   implicit none
   private
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ function brack_1:
   pure function brack_1(Q,mu2) result(brack)
      use ugaau_model
      use ugaau_kinematics
      use ugaau_color
      use ugaau_abbrevd23h0
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      complex(ki), intent(in) :: mu2
      complex(ki) :: brack
      complex(ki) :: acc23(35)
      complex(ki) :: Qspk3
      complex(ki) :: Qspk1
      complex(ki) :: Qspvak5k1
      complex(ki) :: Qspvak5k3
      complex(ki) :: Qspe3
      complex(ki) :: Qspvae3k1
      complex(ki) :: Qspe4
      complex(ki) :: Qspvak5e4
      complex(ki) :: Qspk4
      complex(ki) :: QspQ
      complex(ki) :: Qspe2
      complex(ki) :: Qspvak5e2
      complex(ki) :: Qspvak5k2
      Qspk3 = dotproduct(Q,k3)
      Qspk1 = dotproduct(Q,k1)
      Qspvak5k1 = dotproduct(Q,spvak5k1)
      Qspvak5k3 = dotproduct(Q,spvak5k3)
      Qspe3 = dotproduct(Q,e3)
      Qspvae3k1 = dotproduct(Q,spvae3k1)
      Qspe4 = dotproduct(Q,e4)
      Qspvak5e4 = dotproduct(Q,spvak5e4)
      Qspk4 = dotproduct(Q,k4)
      QspQ = dotproduct(Q,Q)
      Qspe2 = dotproduct(Q,e2)
      Qspvak5e2 = dotproduct(Q,spvak5e2)
      Qspvak5k2 = dotproduct(Q,spvak5k2)
      acc23(1)=abb23(3)
      acc23(2)=abb23(4)
      acc23(3)=abb23(5)
      acc23(4)=abb23(6)
      acc23(5)=abb23(7)
      acc23(6)=abb23(8)
      acc23(7)=abb23(9)
      acc23(8)=abb23(10)
      acc23(9)=abb23(11)
      acc23(10)=abb23(12)
      acc23(11)=abb23(13)
      acc23(12)=abb23(14)
      acc23(13)=abb23(15)
      acc23(14)=abb23(16)
      acc23(15)=abb23(17)
      acc23(16)=abb23(18)
      acc23(17)=abb23(20)
      acc23(18)=abb23(23)
      acc23(19)=abb23(25)
      acc23(20)=abb23(28)
      acc23(21)=abb23(29)
      acc23(22)=abb23(30)
      acc23(23)=abb23(32)
      acc23(24)=abb23(33)
      acc23(25)=abb23(34)
      acc23(26)=abb23(35)
      acc23(27)=abb23(36)
      acc23(28)=Qspk3-Qspk1
      acc23(29)=acc23(27)*acc23(28)
      acc23(30)=acc23(16)*Qspvak5k1
      acc23(31)=acc23(14)*Qspvak5k3
      acc23(32)=Qspe3*acc23(19)
      acc23(33)=Qspvae3k1*acc23(3)
      acc23(29)=acc23(33)+acc23(32)+acc23(31)+acc23(18)+acc23(30)+acc23(29)
      acc23(29)=Qspe4*acc23(29)
      acc23(30)=acc23(26)*acc23(28)
      acc23(31)=acc23(5)*Qspvak5e4
      acc23(32)=Qspk4*acc23(23)
      acc23(33)=Qspe3*acc23(2)
      acc23(34)=Qspvae3k1*acc23(8)
      acc23(35)=QspQ*acc23(10)
      acc23(29)=acc23(29)+acc23(35)+acc23(34)+acc23(33)+acc23(31)+acc23(32)+acc&
      &23(30)
      acc23(29)=Qspe2*acc23(29)
      acc23(30)=-acc23(20)*acc23(28)
      acc23(31)=acc23(22)*Qspvak5e2
      acc23(32)=Qspe3*acc23(9)
      acc23(33)=Qspvae3k1*acc23(12)
      acc23(30)=acc23(33)+acc23(32)+acc23(31)+acc23(1)+acc23(30)
      acc23(30)=QspQ*acc23(30)
      acc23(31)=acc23(25)*acc23(28)
      acc23(32)=Qspvak5k2*acc23(6)
      acc23(33)=Qspe3*acc23(17)
      acc23(34)=Qspvae3k1*acc23(15)
      acc23(31)=acc23(34)+acc23(33)+acc23(7)+acc23(32)+acc23(31)
      acc23(31)=Qspe4*acc23(31)
      acc23(28)=acc23(24)*acc23(28)
      acc23(32)=Qspk4*acc23(21)
      acc23(33)=Qspvak5k2*acc23(4)
      acc23(34)=Qspe3*acc23(13)
      acc23(35)=Qspvae3k1*acc23(11)
      brack=acc23(28)+acc23(29)+acc23(30)+acc23(31)+acc23(32)+acc23(33)+acc23(3&
      &4)+acc23(35)
   end  function brack_1
!---#] function brack_1:
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use ugaau_groups, only: &
!           & sign => diagram23_sign, shift => diagram23_shift
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd23h0
      implicit none
      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d23
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      Q(1)  =cmplx(real(+Q_ext(4),  ki_sam),aimag(+Q_ext(4)),  ki)
      Q(2:4)=cmplx(real(+Q_ext(1:3),ki_sam),aimag(+Q_ext(1:3)),ki)
      mu2    = cmplx(real(mu2_ext, ki), aimag(mu2_ext), ki)
      d23 = 0.0_ki
      d23 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d23, ki), aimag(d23), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd23h0
      implicit none
      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d23
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      Q(:)  =cmplx(real(+Q_ext(:),  ki_gol), 0.0_ki_gol, ki)
      mu2  = cmplx(real(mu2_ext, ki), 0.0_ki, ki)
      d23 = 0.0_ki
      d23 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d23, ki), aimag(d23), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module ugaau_d23h0l1
