module     ugaau_d2h0l1
   ! file: /.th/pcl340/scratch/gosam/greiner/ug_aau/helicity0d2h0l1.f90
   ! generator: buildfortran.py
   use ugaau_config, only: ki
   use ugaau_util, only: cond
   implicit none
   private
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ function brack_1:
   pure function brack_1(Q,mu2) result(brack)
      use ugaau_model
      use ugaau_kinematics
      use ugaau_color
      use ugaau_abbrevd2h0
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      complex(ki), intent(in) :: mu2
      complex(ki) :: brack
      complex(ki) :: acc2(18)
      complex(ki) :: Qspvae2k1
      complex(ki) :: Qspe2
      complex(ki) :: Qspvak5k2
      complex(ki) :: Qspvak4k2
      complex(ki) :: Qspe3
      complex(ki) :: Qspk2
      complex(ki) :: Qspk1
      complex(ki) :: QspQ
      complex(ki) :: Qspvak5k3
      complex(ki) :: Qspvak4k3
      Qspvae2k1 = dotproduct(Q,spvae2k1)
      Qspe2 = dotproduct(Q,e2)
      Qspvak5k2 = dotproduct(Q,spvak5k2)
      Qspvak4k2 = dotproduct(Q,spvak4k2)
      Qspe3 = dotproduct(Q,e3)
      Qspk2 = dotproduct(Q,k2)
      Qspk1 = dotproduct(Q,k1)
      QspQ = dotproduct(Q,Q)
      Qspvak5k3 = dotproduct(Q,spvak5k3)
      Qspvak4k3 = dotproduct(Q,spvak4k3)
      acc2(1)=abb2(4)
      acc2(2)=abb2(5)
      acc2(3)=abb2(6)
      acc2(4)=abb2(7)
      acc2(5)=abb2(8)
      acc2(6)=abb2(9)
      acc2(7)=abb2(10)
      acc2(8)=abb2(11)
      acc2(9)=abb2(12)
      acc2(10)=abb2(13)
      acc2(11)=abb2(15)
      acc2(12)=acc2(1)*Qspvae2k1
      acc2(13)=acc2(6)*Qspe2
      acc2(14)=Qspvak5k2*acc2(7)
      acc2(15)=Qspvak4k2*acc2(8)
      acc2(12)=acc2(15)+acc2(14)+acc2(13)+acc2(12)
      acc2(12)=Qspe3*acc2(12)
      acc2(13)=-Qspk2-Qspk1
      acc2(14)=acc2(10)*Qspe3
      acc2(14)=acc2(14)-acc2(9)
      acc2(13)=acc2(14)*acc2(13)
      acc2(14)=mu2-QspQ
      acc2(14)=acc2(11)*acc2(14)
      acc2(15)=acc2(3)*Qspvae2k1
      acc2(16)=acc2(4)*Qspe2
      acc2(17)=Qspvak5k3*acc2(5)
      acc2(18)=Qspvak4k3*acc2(2)
      brack=acc2(12)+acc2(13)+acc2(14)+acc2(15)+acc2(16)+acc2(17)+acc2(18)
   end  function brack_1
!---#] function brack_1:
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use ugaau_groups, only: &
!           & sign => diagram2_sign, shift => diagram2_shift
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd2h0
      implicit none
      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d2
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(0:3) :: qshift
      qshift = k3+k5+k4
      Q(1)  =cmplx(real(+Q_ext(4)  -qshift(0),  ki_sam),aimag(+Q_ext(4)),  ki)
      Q(2:4)=cmplx(real(+Q_ext(1:3)-qshift(1:3),ki_sam),aimag(+Q_ext(1:3)),ki)
      mu2    = cmplx(real(mu2_ext, ki), aimag(mu2_ext), ki)
      d2 = 0.0_ki
      d2 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d2, ki), aimag(d2), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd2h0
      implicit none
      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d2
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(4) :: qshift
      qshift = k3+k5+k4
      Q(:)  =cmplx(real(+Q_ext(:)  -qshift(:),  ki_gol), 0.0_ki_gol, ki)
      mu2  = cmplx(real(mu2_ext, ki), 0.0_ki, ki)
      d2 = 0.0_ki
      d2 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d2, ki), aimag(d2), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module ugaau_d2h0l1
