module     ugaau_d7h0l1
   ! file: /.th/pcl340/scratch/gosam/greiner/ug_aau/helicity0d7h0l1.f90
   ! generator: buildfortran.py
   use ugaau_config, only: ki
   use ugaau_util, only: cond
   implicit none
   private
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ function brack_1:
   pure function brack_1(Q,mu2) result(brack)
      use ugaau_model
      use ugaau_kinematics
      use ugaau_color
      use ugaau_abbrevd7h0
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      complex(ki), intent(in) :: mu2
      complex(ki) :: brack
      complex(ki) :: acc7(24)
      complex(ki) :: Qspvae4k1
      complex(ki) :: Qspe4
      complex(ki) :: Qspvak5k4
      complex(ki) :: Qspvak5k1
      complex(ki) :: Qspvak3k4
      complex(ki) :: Qspvak3k1
      complex(ki) :: Qspe2
      complex(ki) :: Qspk4
      complex(ki) :: Qspk1
      complex(ki) :: QspQ
      complex(ki) :: Qspvak5k2
      complex(ki) :: Qspvak3k2
      complex(ki) :: Qspk2
      Qspvae4k1 = dotproduct(Q,spvae4k1)
      Qspe4 = dotproduct(Q,e4)
      Qspvak5k4 = dotproduct(Q,spvak5k4)
      Qspvak5k1 = dotproduct(Q,spvak5k1)
      Qspvak3k4 = dotproduct(Q,spvak3k4)
      Qspvak3k1 = dotproduct(Q,spvak3k1)
      Qspe2 = dotproduct(Q,e2)
      Qspk4 = dotproduct(Q,k4)
      Qspk1 = dotproduct(Q,k1)
      QspQ = dotproduct(Q,Q)
      Qspvak5k2 = dotproduct(Q,spvak5k2)
      Qspvak3k2 = dotproduct(Q,spvak3k2)
      Qspk2 = dotproduct(Q,k2)
      acc7(1)=abb7(4)
      acc7(2)=abb7(5)
      acc7(3)=abb7(7)
      acc7(4)=abb7(8)
      acc7(5)=abb7(9)
      acc7(6)=abb7(10)
      acc7(7)=abb7(11)
      acc7(8)=abb7(12)
      acc7(9)=abb7(13)
      acc7(10)=abb7(14)
      acc7(11)=abb7(15)
      acc7(12)=abb7(16)
      acc7(13)=abb7(17)
      acc7(14)=abb7(18)
      acc7(15)=abb7(19)
      acc7(16)=abb7(20)
      acc7(17)=acc7(11)*Qspvae4k1
      acc7(18)=acc7(14)*Qspe4
      acc7(19)=Qspvak5k4*acc7(12)
      acc7(20)=Qspvak5k1*acc7(3)
      acc7(21)=Qspvak3k4*acc7(16)
      acc7(22)=Qspvak3k1*acc7(2)
      acc7(17)=acc7(22)+acc7(21)+acc7(20)+acc7(19)+acc7(15)+acc7(18)+acc7(17)
      acc7(17)=Qspe2*acc7(17)
      acc7(18)=Qspk4-Qspk1
      acc7(19)=acc7(10)*Qspe2
      acc7(19)=acc7(19)+acc7(5)
      acc7(18)=acc7(19)*acc7(18)
      acc7(19)=mu2-QspQ
      acc7(19)=acc7(8)*acc7(19)
      acc7(20)=acc7(7)*Qspvae4k1
      acc7(21)=acc7(13)*Qspe4
      acc7(22)=Qspvak5k2*acc7(6)
      acc7(23)=Qspvak3k2*acc7(1)
      acc7(24)=Qspk2*acc7(9)
      brack=acc7(4)+acc7(17)+acc7(18)+acc7(19)+acc7(20)+acc7(21)+acc7(22)+acc7(&
      &23)+acc7(24)
   end  function brack_1
!---#] function brack_1:
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use ugaau_groups, only: &
!           & sign => diagram7_sign, shift => diagram7_shift
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd7h0
      implicit none
      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d7
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(0:3) :: qshift
      qshift = -k2
      Q(1)  =cmplx(real(-Q_ext(4)  -qshift(0),  ki_sam),aimag(-Q_ext(4)),  ki)
      Q(2:4)=cmplx(real(-Q_ext(1:3)-qshift(1:3),ki_sam),aimag(-Q_ext(1:3)),ki)
      mu2    = cmplx(real(mu2_ext, ki), aimag(mu2_ext), ki)
      d7 = 0.0_ki
      d7 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d7, ki), aimag(d7), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd7h0
      implicit none
      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d7
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(4) :: qshift
      qshift = -k2
      Q(:)  =cmplx(real(-Q_ext(:)  -qshift(:),  ki_gol), 0.0_ki_gol, ki)
      mu2  = cmplx(real(mu2_ext, ki), 0.0_ki, ki)
      d7 = 0.0_ki
      d7 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d7, ki), aimag(d7), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module ugaau_d7h0l1
