module     ugaau_abbrevd16h8
   use ugaau_config, only: ki
   use ugaau_globalsh8
   implicit none
   private
   complex(ki), dimension(22), public :: abb16
   complex(ki), public :: R2d16
   public :: init_abbrev
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
contains
   subroutine     init_abbrev()
      use ugaau_config, only: deltaOS, &
     &    logfile, debug_nlo_diagrams
      use ugaau_kinematics
      use ugaau_model
      use ugaau_color, only: TR
      use ugaau_globalsl1, only: epspow
      implicit none
      abb16(1)=1.0_ki/(es23-es51-es45)
      abb16(2)=1.0_ki/(-es34+es12-es45)
      abb16(3)=NC**(-1)
      abb16(4)=1.0_ki/(es34-es51-es12)
      abb16(5)=abb16(1)**2*i_*TR
      abb16(6)=spak1e4*c1
      abb16(7)=abb16(5)*abb16(6)*spbk5e2
      abb16(8)=NC-abb16(3)
      abb16(9)=-abb16(4)*abb16(8)*abb16(7)
      abb16(10)=-spbk5e3*abb16(9)
      abb16(11)=spae2k5*spak1e3
      abb16(12)=abb16(10)*abb16(11)
      abb16(13)=-abb16(5)*abb16(8)
      abb16(6)=-abb16(13)*abb16(6)*abb16(2)*spbk5e3
      abb16(14)=spbk3e2*spae3k3
      abb16(15)=abb16(14)*spak1e2
      abb16(16)=abb16(15)*abb16(6)
      abb16(17)=spae2k2*spbe3k2
      abb16(18)=abb16(17)*spak1e3
      abb16(19)=abb16(18)*abb16(9)
      abb16(20)=abb16(8)*abb16(2)
      abb16(7)=abb16(7)*spbk5e3*abb16(20)
      abb16(21)=spae3k5*spak1e2
      abb16(22)=abb16(21)*abb16(7)
      abb16(12)=-abb16(16)-abb16(12)+abb16(19)-abb16(22)
      abb16(16)=-spbe4k1*abb16(12)
      abb16(10)=abb16(10)*spae2k5
      abb16(9)=abb16(9)*abb16(17)
      abb16(9)=abb16(10)-abb16(9)
      abb16(9)=abb16(9)*spae3k4
      abb16(7)=abb16(7)*spae3k5
      abb16(6)=abb16(6)*abb16(14)
      abb16(6)=abb16(7)+abb16(6)
      abb16(6)=abb16(6)*spae2k4
      abb16(6)=abb16(9)+abb16(6)
      abb16(7)=spbk4e4*abb16(6)
      abb16(9)=abb16(7)-abb16(16)
      abb16(10)=-es23+es45+es51
      abb16(9)=-4.0_ki/9.0_ki*abb16(9)*abb16(10)
      abb16(5)=abb16(5)*spbk5e3
      abb16(14)=-abb16(15)*c1*abb16(5)
      abb16(15)=spbk5e2*c1
      abb16(5)=abb16(5)*abb16(15)
      abb16(17)=-abb16(21)*abb16(5)
      abb16(14)=-abb16(17)-abb16(14)
      abb16(14)=abb16(20)*abb16(14)
      abb16(13)=abb16(18)*abb16(13)*abb16(15)*abb16(4)
      abb16(5)=abb16(11)*abb16(4)*abb16(8)*abb16(5)
      abb16(5)=-abb16(13)+abb16(5)+abb16(14)
      abb16(8)=16.0_ki/9.0_ki*abb16(5)*abb16(10)
      abb16(10)=-2.0_ki*abb16(16)+abb16(7)
      abb16(10)=8.0_ki/9.0_ki*abb16(10)
      abb16(7)=abb16(16)-2.0_ki*abb16(7)
      abb16(7)=8.0_ki/9.0_ki*abb16(7)
      abb16(5)=-spae4k4*abb16(5)
      abb16(5)=abb16(5)+abb16(6)
      abb16(5)=8.0_ki/9.0_ki*spbk4k1*abb16(5)
      abb16(11)=4.0_ki/9.0_ki*spbk4e4*abb16(12)
      abb16(6)=-4.0_ki/9.0_ki*spbe4k1*abb16(6)
      R2d16=0.0_ki*(0.0_ki)
      rat2 = rat2 + R2d16
      if (debug_nlo_diagrams) then
          write (logfile,*) "<result name='r2' index='16' value='", &
          & R2d16, "'/>"
      end if
   end subroutine
end module ugaau_abbrevd16h8
