module     ugaau_abbrevd17h8
   use ugaau_config, only: ki
   use ugaau_globalsh8
   implicit none
   private
   complex(ki), dimension(22), public :: abb17
   complex(ki), public :: R2d17
   public :: init_abbrev
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
contains
   subroutine     init_abbrev()
      use ugaau_config, only: deltaOS, &
     &    logfile, debug_nlo_diagrams
      use ugaau_kinematics
      use ugaau_model
      use ugaau_color, only: TR
      use ugaau_globalsl1, only: epspow
      implicit none
      abb17(1)=NC**(-1)
      abb17(2)=es45**(-1)
      abb17(3)=es12**(-1)
      abb17(4)=1.0_ki/(-es34+es12-es45)
      abb17(5)=abb17(2)*spak2e3
      abb17(6)=abb17(5)*spae4k5
      abb17(7)=abb17(4)*spak2e4
      abb17(8)=abb17(7)*spae3k5
      abb17(6)=abb17(6)+abb17(8)
      abb17(6)=abb17(6)*abb17(1)
      abb17(8)=abb17(7)*NC
      abb17(9)=abb17(8)*spae3k5
      abb17(10)=abb17(5)*NC
      abb17(11)=abb17(10)*spae4k5
      abb17(6)=abb17(6)-abb17(9)-abb17(11)
      abb17(9)=spak1e2*spbk2e2
      abb17(11)=abb17(9)*spbk5e3
      abb17(12)=abb17(6)*abb17(11)
      abb17(5)=abb17(1)*abb17(5)
      abb17(5)=abb17(5)-abb17(10)
      abb17(10)=spae4k4*spbk4e3
      abb17(5)=abb17(10)*abb17(5)
      abb17(13)=abb17(5)*abb17(9)
      abb17(12)=abb17(12)+abb17(13)
      abb17(12)=abb17(12)*spbk5e4
      abb17(7)=abb17(1)*abb17(7)
      abb17(7)=abb17(7)-abb17(8)
      abb17(8)=spbe4k3*spae3k3
      abb17(7)=abb17(8)*abb17(7)
      abb17(13)=abb17(7)*abb17(11)
      abb17(12)=abb17(12)-abb17(13)
      abb17(13)=i_*c1*TR
      abb17(14)=abb17(13)*abb17(3)
      abb17(15)=-4.0_ki/9.0_ki*abb17(12)*abb17(14)
      abb17(16)=abb17(2)*spak1e3
      abb17(17)=spae4k5*abb17(16)
      abb17(18)=abb17(4)*spak1e4
      abb17(19)=spae3k5*abb17(18)
      abb17(17)=abb17(17)+abb17(19)
      abb17(17)=abb17(17)*abb17(1)
      abb17(19)=NC*abb17(18)
      abb17(20)=abb17(19)*spae3k5
      abb17(21)=NC*abb17(16)
      abb17(22)=abb17(21)*spae4k5
      abb17(17)=abb17(17)-abb17(20)-abb17(22)
      abb17(20)=spbk5e3*abb17(17)
      abb17(16)=abb17(1)*abb17(16)
      abb17(16)=abb17(16)-abb17(21)
      abb17(10)=abb17(10)*abb17(16)
      abb17(16)=abb17(20)+abb17(10)
      abb17(16)=spbk5e4*abb17(16)
      abb17(18)=abb17(1)*abb17(18)
      abb17(18)=abb17(18)-abb17(19)
      abb17(8)=abb17(8)*abb17(18)
      abb17(18)=-spbk5e3*abb17(8)
      abb17(16)=abb17(18)+abb17(16)
      abb17(14)=16.0_ki/9.0_ki*abb17(16)*abb17(14)
      abb17(13)=abb17(13)*abb17(3)**2
      abb17(16)=8.0_ki/9.0_ki*abb17(13)
      abb17(18)=abb17(12)*abb17(16)
      abb17(12)=16.0_ki/9.0_ki*abb17(12)*abb17(13)
      abb17(19)=spbk2k1*spae2k2
      abb17(20)=-abb17(19)*abb17(17)
      abb17(6)=-spak1e2*spbk2k1*abb17(6)
      abb17(6)=abb17(6)+abb17(20)
      abb17(6)=spbk5e3*abb17(6)
      abb17(20)=-abb17(19)*abb17(10)
      abb17(21)=spak1e2*spbk2k1
      abb17(5)=-abb17(5)*abb17(21)
      abb17(5)=abb17(6)+abb17(5)+abb17(20)
      abb17(5)=spbk5e4*abb17(5)
      abb17(6)=abb17(19)*abb17(8)
      abb17(7)=abb17(7)*abb17(21)
      abb17(6)=abb17(7)+abb17(6)
      abb17(6)=spbk5e3*abb17(6)
      abb17(5)=abb17(6)+abb17(5)
      abb17(5)=abb17(5)*abb17(16)
      abb17(6)=-abb17(17)*abb17(11)
      abb17(7)=-abb17(10)*abb17(9)
      abb17(6)=abb17(7)+abb17(6)
      abb17(6)=spbk5e4*abb17(6)
      abb17(7)=abb17(8)*abb17(11)
      abb17(6)=abb17(7)+abb17(6)
      abb17(6)=4.0_ki/9.0_ki*abb17(6)*abb17(13)
      R2d17=0.0_ki*(0.0_ki)
      rat2 = rat2 + R2d17
      if (debug_nlo_diagrams) then
          write (logfile,*) "<result name='r2' index='17' value='", &
          & R2d17, "'/>"
      end if
   end subroutine
end module ugaau_abbrevd17h8
