module     ugaau_abbrevd3h8
   use ugaau_config, only: ki
   use ugaau_globalsh8
   implicit none
   private
   complex(ki), dimension(17), public :: abb3
   complex(ki), public :: R2d3
   public :: init_abbrev
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
contains
   subroutine     init_abbrev()
      use ugaau_config, only: deltaOS, &
     &    logfile, debug_nlo_diagrams
      use ugaau_kinematics
      use ugaau_model
      use ugaau_color, only: TR
      use ugaau_globalsl1, only: epspow
      implicit none
      abb3(1)=1.0_ki/(-es23-es12+es45)
      abb3(2)=1.0_ki/(es34-es51-es12)
      abb3(3)=NC**(-1)
      abb3(4)=NC-abb3(3)
      abb3(5)=i_*TR*c1*spbk5e2*abb3(2)*abb3(1)
      abb3(6)=-abb3(5)*abb3(4)
      abb3(7)=-spae2k5*abb3(6)
      abb3(8)=spbk5k4*spae4k4
      abb3(9)=abb3(7)*abb3(8)
      abb3(6)=-spae2k2*abb3(6)
      abb3(10)=spbk4k2*spae4k4
      abb3(11)=abb3(6)*abb3(10)
      abb3(9)=abb3(9)+abb3(11)
      abb3(9)=abb3(9)*spbe4k3
      abb3(11)=spbk5e4*spae4k4
      abb3(12)=abb3(7)*abb3(11)
      abb3(13)=spbe4k2*spae4k4
      abb3(14)=abb3(6)*abb3(13)
      abb3(12)=abb3(12)+abb3(14)
      abb3(12)=abb3(12)*spbk4k3
      abb3(9)=abb3(9)-abb3(12)
      abb3(12)=8.0_ki/9.0_ki*spak1k3*abb3(9)
      abb3(7)=abb3(7)*spbk5k3
      abb3(6)=abb3(6)*spbk3k2
      abb3(6)=abb3(7)+abb3(6)
      abb3(7)=-32.0_ki/9.0_ki*spak1k3*abb3(6)
      abb3(5)=abb3(5)*spak1e3
      abb3(14)=-abb3(4)*abb3(5)*spae2k5
      abb3(8)=abb3(14)*abb3(8)
      abb3(4)=-abb3(4)*abb3(5)*spae2k2
      abb3(5)=abb3(4)*abb3(10)
      abb3(5)=abb3(8)+abb3(5)
      abb3(8)=abb3(5)*spbe4e3
      abb3(10)=abb3(14)*abb3(11)
      abb3(11)=abb3(4)*abb3(13)
      abb3(10)=abb3(10)+abb3(11)
      abb3(11)=abb3(10)*spbk4e3
      abb3(8)=abb3(8)-abb3(11)
      abb3(8)=8.0_ki/9.0_ki*abb3(8)
      abb3(11)=abb3(14)*spbk5e3
      abb3(13)=abb3(4)*spbe3k2
      abb3(11)=abb3(11)+abb3(13)
      abb3(11)=32.0_ki/9.0_ki*abb3(11)
      abb3(13)=abb3(14)*spbk5e4
      abb3(15)=abb3(4)*spbe4k2
      abb3(13)=abb3(13)+abb3(15)
      abb3(15)=spak3e4*spbk3e3
      abb3(16)=spak1e4*spbe3k1
      abb3(15)=abb3(15)+abb3(16)
      abb3(13)=abb3(15)*abb3(13)
      abb3(13)=4.0_ki/9.0_ki*abb3(13)
      abb3(9)=-spae3k3*abb3(9)
      abb3(5)=spbe4k1*abb3(5)
      abb3(10)=-spbk4k1*abb3(10)
      abb3(5)=abb3(10)+abb3(5)+abb3(9)
      abb3(5)=4.0_ki/9.0_ki*abb3(5)
      abb3(6)=spae3k3*abb3(6)
      abb3(9)=-spbk5k1*abb3(14)
      abb3(10)=spbk2k1*abb3(4)
      abb3(6)=abb3(10)+abb3(9)+abb3(6)
      abb3(6)=16.0_ki/9.0_ki*abb3(6)
      abb3(9)=4.0_ki/9.0_ki*spbk4e4
      abb3(9)=abb3(15)*abb3(9)
      abb3(10)=-abb3(14)*abb3(9)
      abb3(9)=abb3(4)*abb3(9)
      abb3(15)=8.0_ki/9.0_ki*spbk3e3
      abb3(16)=abb3(14)*abb3(15)
      abb3(15)=-abb3(4)*abb3(15)
      abb3(17)=8.0_ki/9.0_ki*spbe3k1
      abb3(14)=abb3(14)*abb3(17)
      abb3(4)=-abb3(4)*abb3(17)
      R2d3=0.0_ki*(0.0_ki)
      rat2 = rat2 + R2d3
      if (debug_nlo_diagrams) then
          write (logfile,*) "<result name='r2' index='3' value='", &
          & R2d3, "'/>"
      end if
   end subroutine
end module ugaau_abbrevd3h8
