module     ugaau_abbrevd4h8
   use ugaau_config, only: ki
   use ugaau_globalsh8
   implicit none
   private
   complex(ki), dimension(32), public :: abb4
   complex(ki), public :: R2d4
   public :: init_abbrev
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
contains
   subroutine     init_abbrev()
      use ugaau_config, only: deltaOS, &
     &    logfile, debug_nlo_diagrams
      use ugaau_kinematics
      use ugaau_model
      use ugaau_color, only: TR
      use ugaau_globalsl1, only: epspow
      implicit none
      abb4(1)=1.0_ki/(-es23-es12+es45)
      abb4(2)=es45**(-1)
      abb4(3)=NC**(-1)
      abb4(4)=abb4(1)*i_*TR*c1*spbk5e4
      abb4(5)=abb4(2)*abb4(4)
      abb4(6)=abb4(5)*NC*spak1e3
      abb4(7)=abb4(6)*spae4k4
      abb4(8)=abb4(7)*spbk4e2
      abb4(6)=abb4(6)*spae4k5
      abb4(9)=abb4(6)*spbk5e2
      abb4(8)=abb4(8)+abb4(9)
      abb4(9)=spae2k3*abb4(8)
      abb4(10)=abb4(9)*spbk3e3
      abb4(11)=es23*abb4(10)
      abb4(8)=spak1e2*abb4(8)
      abb4(12)=abb4(8)*spbe3k1
      abb4(13)=es12*abb4(12)
      abb4(11)=abb4(11)-abb4(13)
      abb4(13)=abb4(6)*spae2k3
      abb4(14)=spbk3e3*abb4(13)
      abb4(15)=abb4(6)*spak1e2
      abb4(16)=-spbe3k1*abb4(15)
      abb4(14)=abb4(14)+abb4(16)
      abb4(14)=spbk5k2*abb4(14)
      abb4(16)=abb4(7)*spae2k3
      abb4(17)=spbk3e3*abb4(16)
      abb4(18)=abb4(7)*spak1e2
      abb4(19)=-spbe3k1*abb4(18)
      abb4(17)=abb4(17)+abb4(19)
      abb4(17)=spbk4k2*abb4(17)
      abb4(14)=abb4(14)+abb4(17)
      abb4(14)=spbk3e2*abb4(14)
      abb4(8)=spbk2k1*spbk3e3*abb4(8)
      abb4(8)=abb4(14)+2.0_ki*abb4(8)
      abb4(8)=spak2k3*abb4(8)
      abb4(14)=2.0_ki*spbk3k2
      abb4(17)=spbe3k1*abb4(9)*abb4(14)
      abb4(19)=-spbk5k2*abb4(13)
      abb4(20)=-spbk4k2*abb4(16)
      abb4(19)=abb4(19)+abb4(20)
      abb4(19)=spbe2k1*spbk3e3*abb4(19)
      abb4(17)=abb4(17)+abb4(19)
      abb4(17)=spak1k2*abb4(17)
      abb4(8)=abb4(17)+abb4(8)+2.0_ki*abb4(11)
      abb4(8)=2.0_ki/9.0_ki*abb4(8)
      abb4(11)=abb4(5)*spae4k5
      abb4(17)=abb4(11)*abb4(3)
      abb4(19)=abb4(11)*NC
      abb4(20)=abb4(19)+2.0_ki*abb4(17)
      abb4(21)=spbk5k2*spae2k2
      abb4(20)=abb4(20)*abb4(21)
      abb4(5)=abb4(5)*spae4k4
      abb4(22)=abb4(5)*abb4(3)
      abb4(23)=abb4(5)*NC
      abb4(24)=abb4(23)+2.0_ki*abb4(22)
      abb4(25)=spbk4k2*spae2k2
      abb4(24)=abb4(24)*abb4(25)
      abb4(26)=spbk5k3*spae2k3
      abb4(27)=spbk5k1*spak1e2
      abb4(26)=abb4(26)+abb4(27)
      abb4(26)=abb4(26)*abb4(19)
      abb4(27)=spbk4k3*spae2k3
      abb4(28)=spbk4k1*spak1e2
      abb4(27)=abb4(27)+abb4(28)
      abb4(27)=abb4(27)*abb4(23)
      abb4(20)=abb4(20)+abb4(24)+abb4(26)+abb4(27)
      abb4(20)=abb4(20)*spbk3e2
      abb4(24)=abb4(22)-abb4(23)
      abb4(26)=spbk4e2*spae2k2
      abb4(24)=abb4(24)*abb4(26)
      abb4(27)=abb4(17)-abb4(19)
      abb4(28)=spbk5e2*spae2k2
      abb4(27)=abb4(27)*abb4(28)
      abb4(24)=abb4(24)+abb4(27)
      abb4(14)=abb4(24)*abb4(14)
      abb4(14)=abb4(20)-abb4(14)
      abb4(20)=-spak1k3*abb4(14)
      abb4(24)=spbk4e2*spak1e2
      abb4(27)=abb4(24)*abb4(23)
      abb4(29)=spbk5e2*spak1e2
      abb4(30)=abb4(29)*abb4(19)
      abb4(27)=abb4(27)+abb4(30)
      abb4(30)=es12+es23
      abb4(30)=abb4(27)*abb4(30)
      abb4(31)=spbk5e2*spae4k5
      abb4(32)=spbk4e2*spae4k4
      abb4(31)=-abb4(31)-abb4(32)
      abb4(4)=spak1e2*abb4(31)*NC*abb4(4)
      abb4(4)=abb4(30)+abb4(4)+abb4(20)
      abb4(4)=4.0_ki/9.0_ki*abb4(4)
      abb4(20)=-spak2k3*spbk3e3
      abb4(30)=spak1k2*spbe3k1
      abb4(20)=abb4(30)+abb4(20)
      abb4(30)=abb4(7)*spbk4k2
      abb4(31)=abb4(6)*spbk5k2
      abb4(30)=abb4(30)+abb4(31)
      abb4(20)=abb4(30)*abb4(20)
      abb4(30)=-spbk4k3*spbe3k1
      abb4(31)=-spbk4k1*spbk3e3
      abb4(30)=abb4(31)+abb4(30)
      abb4(30)=abb4(7)*abb4(30)
      abb4(31)=-spbk5k3*spbe3k1
      abb4(32)=-spbk5k1*spbk3e3
      abb4(31)=abb4(32)+abb4(31)
      abb4(31)=abb4(6)*abb4(31)
      abb4(30)=abb4(31)+abb4(30)
      abb4(30)=spak1k3*abb4(30)
      abb4(20)=abb4(30)+abb4(20)
      abb4(20)=4.0_ki/9.0_ki*abb4(20)
      abb4(22)=abb4(22)+abb4(23)
      abb4(22)=abb4(22)*spbk4k3
      abb4(17)=abb4(17)+abb4(19)
      abb4(17)=abb4(17)*spbk5k3
      abb4(17)=abb4(22)+abb4(17)
      abb4(19)=32.0_ki/9.0_ki*spak1k3*abb4(17)
      abb4(22)=abb4(3)*spak1e3
      abb4(11)=abb4(22)*abb4(11)
      abb4(23)=abb4(6)+2.0_ki*abb4(11)
      abb4(21)=abb4(23)*abb4(21)
      abb4(5)=abb4(22)*abb4(5)
      abb4(22)=abb4(7)+2.0_ki*abb4(5)
      abb4(22)=abb4(22)*abb4(25)
      abb4(13)=abb4(13)*spbk5k3
      abb4(16)=abb4(16)*spbk4k3
      abb4(13)=abb4(13)+abb4(16)+abb4(21)+abb4(22)
      abb4(15)=abb4(15)*spbk5k1
      abb4(16)=abb4(18)*spbk4k1
      abb4(15)=abb4(16)+abb4(13)+abb4(15)
      abb4(15)=abb4(15)*spbe3e2
      abb4(16)=abb4(5)-abb4(7)
      abb4(18)=abb4(26)*abb4(16)
      abb4(21)=abb4(11)-abb4(6)
      abb4(22)=abb4(28)*abb4(21)
      abb4(18)=abb4(18)+abb4(22)
      abb4(18)=2.0_ki*abb4(18)
      abb4(22)=abb4(18)*spbe3k2
      abb4(10)=abb4(10)-abb4(12)
      abb4(12)=abb4(15)-abb4(22)+2.0_ki*abb4(10)
      abb4(12)=4.0_ki/9.0_ki*abb4(12)
      abb4(7)=abb4(5)+abb4(7)
      abb4(15)=abb4(7)*spbk4e3
      abb4(6)=abb4(11)+abb4(6)
      abb4(22)=abb4(6)*spbk5e3
      abb4(15)=abb4(15)+abb4(22)
      abb4(15)=32.0_ki/9.0_ki*abb4(15)
      abb4(10)=8.0_ki/9.0_ki*abb4(10)
      abb4(22)=abb4(16)*abb4(24)
      abb4(23)=abb4(21)*abb4(29)
      abb4(22)=abb4(22)+abb4(23)
      abb4(22)=abb4(22)*spbe3k1
      abb4(16)=abb4(16)*spbk4e2
      abb4(21)=abb4(21)*spbk5e2
      abb4(16)=abb4(16)+abb4(21)
      abb4(16)=spbk3e3*spae2k3*abb4(16)
      abb4(16)=abb4(22)-abb4(16)
      abb4(16)=4.0_ki/9.0_ki*abb4(16)
      abb4(14)=spae3k3*abb4(14)
      abb4(13)=-spbe2k1*abb4(13)
      abb4(18)=spbk2k1*abb4(18)
      abb4(21)=-spae3k3*abb4(27)
      abb4(9)=abb4(21)+abb4(9)
      abb4(9)=spbk3k1*abb4(9)
      abb4(9)=abb4(9)+abb4(18)+abb4(13)+abb4(14)
      abb4(9)=2.0_ki/9.0_ki*abb4(9)
      abb4(13)=-spae3k3*abb4(17)
      abb4(14)=-spbk5k1*abb4(6)
      abb4(17)=-spbk4k1*abb4(7)
      abb4(13)=abb4(17)+abb4(14)+abb4(13)
      abb4(13)=16.0_ki/9.0_ki*abb4(13)
      abb4(6)=8.0_ki/9.0_ki*abb4(6)
      abb4(14)=spbk3e3*abb4(6)
      abb4(7)=8.0_ki/9.0_ki*abb4(7)
      abb4(17)=spbk3e3*abb4(7)
      abb4(18)=spbk3e3*spae2k3
      abb4(21)=spbe3k1*spak1e2
      abb4(18)=abb4(18)-abb4(21)
      abb4(21)=4.0_ki/9.0_ki*spbk2e2
      abb4(18)=abb4(18)*abb4(21)
      abb4(11)=-abb4(11)*abb4(18)
      abb4(5)=-abb4(5)*abb4(18)
      abb4(6)=spbe3k1*abb4(6)
      abb4(7)=spbe3k1*abb4(7)
      R2d4=0.0_ki*(0.0_ki)
      rat2 = rat2 + R2d4
      if (debug_nlo_diagrams) then
          write (logfile,*) "<result name='r2' index='4' value='", &
          & R2d4, "'/>"
      end if
   end subroutine
end module ugaau_abbrevd4h8
