module     ugaau_abbrevd62h8
   use ugaau_config, only: ki
   use ugaau_globalsh8
   implicit none
   private
   complex(ki), dimension(38), public :: abb62
   complex(ki), public :: R2d62
   public :: init_abbrev
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
contains
   subroutine     init_abbrev()
      use ugaau_config, only: deltaOS, &
     &    logfile, debug_nlo_diagrams
      use ugaau_kinematics
      use ugaau_model
      use ugaau_color, only: TR
      use ugaau_globalsl1, only: epspow
      implicit none
      abb62(1)=1.0_ki/(-es34+es12-es45)
      abb62(2)=NC**(-1)
      abb62(3)=-spak1k2*spbe4k2
      abb62(4)=-spak1k4*spbk4e4
      abb62(3)=abb62(4)+abb62(3)
      abb62(4)=i_*TR*c1*spbk5e3*abb62(2)*abb62(1)
      abb62(5)=abb62(4)*spae3k3
      abb62(6)=abb62(5)*spbk3e2
      abb62(4)=abb62(4)*spae3k5
      abb62(7)=abb62(4)*spbk5e2
      abb62(6)=abb62(6)+abb62(7)
      abb62(7)=spae2e4*abb62(6)
      abb62(3)=abb62(7)*abb62(3)
      abb62(8)=spae2k2*spbe4k2
      abb62(9)=abb62(8)*abb62(6)
      abb62(10)=spak1e4*abb62(9)
      abb62(3)=abb62(10)+abb62(3)
      abb62(3)=4.0_ki/9.0_ki*abb62(3)
      abb62(10)=8.0_ki/9.0_ki*abb62(6)
      abb62(11)=spak1e2*abb62(10)
      abb62(12)=8.0_ki/9.0_ki*spak1k2
      abb62(13)=abb62(4)*spbe4k2
      abb62(14)=-abb62(13)*abb62(12)
      abb62(15)=abb62(4)*spak1e2
      abb62(16)=abb62(15)*spbe4e2
      abb62(17)=8.0_ki/9.0_ki*abb62(16)
      abb62(16)=-4.0_ki/9.0_ki*abb62(16)
      abb62(18)=abb62(5)*spbe4k2
      abb62(12)=-abb62(18)*abb62(12)
      abb62(19)=abb62(5)*spak1e2
      abb62(20)=abb62(19)*spbe4e2
      abb62(21)=8.0_ki/9.0_ki*abb62(20)
      abb62(20)=-4.0_ki/9.0_ki*abb62(20)
      abb62(22)=abb62(4)*spak2e4
      abb62(23)=abb62(22)*spbk5k2
      abb62(24)=abb62(5)*spak2e4
      abb62(25)=abb62(24)*spbk3k2
      abb62(23)=abb62(23)+abb62(25)
      abb62(25)=-spbk5k4*abb62(4)
      abb62(26)=spbk4k3*abb62(5)
      abb62(25)=abb62(26)+abb62(25)
      abb62(25)=spae4k4*abb62(25)
      abb62(25)=-2.0_ki*abb62(23)+abb62(25)
      abb62(25)=8.0_ki/9.0_ki*abb62(25)
      abb62(26)=8.0_ki/9.0_ki*abb62(7)
      abb62(7)=-4.0_ki/9.0_ki*abb62(7)
      abb62(27)=spae2k4*spbk4e4
      abb62(8)=abb62(27)+abb62(8)
      abb62(8)=-4.0_ki/9.0_ki*abb62(8)*abb62(23)
      abb62(23)=spbk5k2*abb62(4)
      abb62(28)=spbk3k2*abb62(5)
      abb62(23)=abb62(23)+abb62(28)
      abb62(28)=8.0_ki/9.0_ki*spae2k2
      abb62(23)=abb62(23)*abb62(28)
      abb62(28)=abb62(5)*spbe4k3
      abb62(29)=abb62(4)*spbk5e4
      abb62(28)=abb62(28)-abb62(29)
      abb62(29)=-spae2e4*abb62(28)
      abb62(30)=-8.0_ki/9.0_ki*abb62(29)
      abb62(29)=4.0_ki/9.0_ki*abb62(29)
      abb62(31)=spbk2e2*spak1e2
      abb62(31)=4.0_ki/9.0_ki*abb62(31)
      abb62(32)=abb62(31)*abb62(22)
      abb62(33)=spbk4e4*abb62(32)
      abb62(34)=8.0_ki/9.0_ki*spak1e4
      abb62(35)=abb62(34)*spbk4e4
      abb62(36)=abb62(4)*abb62(35)
      abb62(31)=abb62(31)*abb62(24)
      abb62(37)=spbk4e4*abb62(31)
      abb62(35)=abb62(5)*abb62(35)
      abb62(32)=spbe4k2*abb62(32)
      abb62(38)=8.0_ki/9.0_ki*spbk2e2
      abb62(15)=-abb62(15)*abb62(38)
      abb62(13)=abb62(13)*abb62(34)
      abb62(31)=spbe4k2*abb62(31)
      abb62(19)=-abb62(19)*abb62(38)
      abb62(18)=abb62(18)*abb62(34)
      abb62(4)=16.0_ki/9.0_ki*abb62(4)
      abb62(28)=-8.0_ki/9.0_ki*spae4k4*abb62(28)
      abb62(5)=16.0_ki/9.0_ki*abb62(5)
      abb62(6)=abb62(6)*abb62(27)
      abb62(6)=abb62(6)+abb62(9)
      abb62(6)=4.0_ki/9.0_ki*spak2e4*abb62(6)
      abb62(9)=-spae2k2*abb62(10)
      abb62(10)=spbk5e4*abb62(22)
      abb62(22)=-spbe4k3*abb62(24)
      abb62(10)=abb62(10)+abb62(22)
      abb62(10)=16.0_ki/9.0_ki*abb62(10)
      R2d62=0.0_ki*(0.0_ki)
      rat2 = rat2 + R2d62
      if (debug_nlo_diagrams) then
          write (logfile,*) "<result name='r2' index='62' value='", &
          & R2d62, "'/>"
      end if
   end subroutine
end module ugaau_abbrevd62h8
