module     ugaau_abbrevd68h8
   use ugaau_config, only: ki
   use ugaau_globalsh8
   implicit none
   private
   complex(ki), dimension(23), public :: abb68
   complex(ki), public :: R2d68
   public :: init_abbrev
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
contains
   subroutine     init_abbrev()
      use ugaau_config, only: deltaOS, &
     &    logfile, debug_nlo_diagrams
      use ugaau_kinematics
      use ugaau_model
      use ugaau_color, only: TR
      use ugaau_globalsl1, only: epspow
      implicit none
      abb68(1)=1.0_ki/(-es34+es12-es45)
      abb68(2)=NC**(-1)
      abb68(3)=es12**(-1)
      abb68(4)=1.0_ki/(es23-es51-es45)
      abb68(5)=NC-abb68(2)
      abb68(6)=i_*TR*c1*abb68(1)
      abb68(7)=abb68(5)*abb68(6)*spak1e4*abb68(4)
      abb68(8)=abb68(7)*spae2k4*spbk4e4
      abb68(9)=spbe4k1*spak1e2*abb68(7)
      abb68(8)=abb68(8)-abb68(9)
      abb68(9)=-spbk5e2*abb68(8)
      abb68(5)=abb68(5)*abb68(6)
      abb68(6)=-spak1e2*abb68(5)
      abb68(10)=spak2e4*spbk2e2
      abb68(11)=abb68(6)*abb68(10)*abb68(3)
      abb68(12)=spbk5e4*abb68(11)
      abb68(12)=abb68(9)+abb68(12)
      abb68(13)=es45+es34
      abb68(13)=abb68(12)*abb68(13)
      abb68(9)=-es12*abb68(9)
      abb68(10)=-abb68(10)*abb68(6)*spbk5e4
      abb68(9)=abb68(9)+abb68(10)+abb68(13)
      abb68(9)=8.0_ki/9.0_ki*abb68(9)
      abb68(10)=spbk5k3*abb68(3)
      abb68(13)=spak2k3*spbk2e2*abb68(10)*abb68(6)
      abb68(14)=-spbk4e2*spae2k3*spbk5k3*abb68(5)*abb68(4)
      abb68(15)=spak1k4*abb68(14)
      abb68(13)=abb68(13)+abb68(15)
      abb68(13)=32.0_ki/9.0_ki*abb68(13)
      abb68(15)=spak3k4*spbk4e4
      abb68(16)=-spak1k3*spbe4k1
      abb68(15)=abb68(15)+abb68(16)
      abb68(7)=-abb68(7)*spbk5k3
      abb68(15)=abb68(7)*abb68(15)
      abb68(10)=abb68(10)*spak3e4
      abb68(5)=-abb68(5)*abb68(10)*spbe4k2
      abb68(16)=-spak1k2*abb68(5)
      abb68(15)=abb68(16)+abb68(15)
      abb68(15)=32.0_ki/9.0_ki*abb68(15)
      abb68(16)=-spbe3e2*abb68(8)
      abb68(17)=spbe4e3*abb68(11)
      abb68(16)=abb68(16)-abb68(17)
      abb68(16)=abb68(16)*spae3k3*spbk5k3
      abb68(8)=-abb68(8)*spbk3e2
      abb68(11)=abb68(11)*spbe4k3
      abb68(8)=abb68(8)-abb68(11)
      abb68(11)=abb68(8)*spae3k3*spbk5e3
      abb68(17)=-abb68(11)+abb68(16)
      abb68(17)=8.0_ki/9.0_ki*abb68(17)
      abb68(18)=-16.0_ki/9.0_ki*abb68(12)
      abb68(7)=abb68(7)*spae2k3
      abb68(19)=32.0_ki/9.0_ki*spbe4e2
      abb68(20)=-abb68(7)*abb68(19)
      abb68(21)=spae3k5*abb68(12)*spbk5e3
      abb68(16)=abb68(21)+abb68(16)
      abb68(16)=8.0_ki/9.0_ki*abb68(16)
      abb68(22)=-32.0_ki/9.0_ki*abb68(12)
      abb68(6)=abb68(10)*abb68(6)
      abb68(10)=abb68(6)*abb68(19)
      abb68(23)=abb68(6)+abb68(7)
      abb68(19)=abb68(23)*abb68(19)
      abb68(11)=abb68(21)+abb68(11)
      abb68(11)=4.0_ki/9.0_ki*abb68(11)
      abb68(12)=-4.0_ki/9.0_ki*spak3k5*spbk3e3*abb68(12)
      abb68(14)=-spae4k4*abb68(14)
      abb68(7)=spbe2k1*abb68(7)
      abb68(7)=abb68(14)+abb68(7)
      abb68(7)=16.0_ki/9.0_ki*abb68(7)
      abb68(6)=-spbe4k1*abb68(6)
      abb68(5)=spae2k2*abb68(5)
      abb68(5)=abb68(6)+abb68(5)
      abb68(5)=16.0_ki/9.0_ki*abb68(5)
      abb68(6)=8.0_ki/9.0_ki*abb68(8)
      R2d68=0.0_ki*(0.0_ki)
      rat2 = rat2 + R2d68
      if (debug_nlo_diagrams) then
          write (logfile,*) "<result name='r2' index='68' value='", &
          & R2d68, "'/>"
      end if
   end subroutine
end module ugaau_abbrevd68h8
