module     ugaau_abbrevd6h8
   use ugaau_config, only: ki
   use ugaau_globalsh8
   implicit none
   private
   complex(ki), dimension(17), public :: abb6
   complex(ki), public :: R2d6
   public :: init_abbrev
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
contains
   subroutine     init_abbrev()
      use ugaau_config, only: deltaOS, &
     &    logfile, debug_nlo_diagrams
      use ugaau_kinematics
      use ugaau_model
      use ugaau_color, only: TR
      use ugaau_globalsl1, only: epspow
      implicit none
      abb6(1)=1.0_ki/(es23-es51-es45)
      abb6(2)=1.0_ki/(es34-es51-es12)
      abb6(3)=NC**(-1)
      abb6(4)=NC-abb6(3)
      abb6(5)=i_*TR*c1*spbk5e2*abb6(2)*abb6(1)
      abb6(6)=-abb6(5)*abb6(4)
      abb6(7)=-spae2k5*abb6(6)
      abb6(8)=spbk5k3*spae3k3
      abb6(9)=abb6(7)*abb6(8)
      abb6(6)=-spae2k2*abb6(6)
      abb6(10)=spbk3k2*spae3k3
      abb6(11)=abb6(6)*abb6(10)
      abb6(9)=abb6(9)+abb6(11)
      abb6(9)=abb6(9)*spbk4e3
      abb6(11)=spbk5e3*spae3k3
      abb6(12)=abb6(7)*abb6(11)
      abb6(13)=spbe3k2*spae3k3
      abb6(14)=abb6(6)*abb6(13)
      abb6(12)=abb6(12)+abb6(14)
      abb6(12)=abb6(12)*spbk4k3
      abb6(9)=abb6(9)-abb6(12)
      abb6(12)=-8.0_ki/9.0_ki*spak1k4*abb6(9)
      abb6(7)=abb6(7)*spbk5k4
      abb6(6)=abb6(6)*spbk4k2
      abb6(6)=abb6(7)+abb6(6)
      abb6(7)=-32.0_ki/9.0_ki*spak1k4*abb6(6)
      abb6(5)=abb6(5)*spak1e4
      abb6(14)=-abb6(4)*abb6(5)*spae2k5
      abb6(8)=abb6(14)*abb6(8)
      abb6(4)=-abb6(4)*abb6(5)*spae2k2
      abb6(5)=abb6(4)*abb6(10)
      abb6(5)=abb6(8)+abb6(5)
      abb6(8)=abb6(5)*spbe4e3
      abb6(10)=abb6(14)*abb6(11)
      abb6(11)=abb6(4)*abb6(13)
      abb6(10)=abb6(10)+abb6(11)
      abb6(11)=abb6(10)*spbe4k3
      abb6(8)=abb6(8)-abb6(11)
      abb6(8)=8.0_ki/9.0_ki*abb6(8)
      abb6(11)=abb6(14)*spbk5e4
      abb6(13)=abb6(4)*spbe4k2
      abb6(11)=abb6(11)+abb6(13)
      abb6(11)=32.0_ki/9.0_ki*abb6(11)
      abb6(13)=abb6(14)*spbk5e3
      abb6(15)=abb6(4)*spbe3k2
      abb6(13)=abb6(13)+abb6(15)
      abb6(15)=spae3k4*spbk4e4
      abb6(16)=spak1e3*spbe4k1
      abb6(15)=abb6(15)-abb6(16)
      abb6(13)=abb6(15)*abb6(13)
      abb6(13)=4.0_ki/9.0_ki*abb6(13)
      abb6(9)=spae4k4*abb6(9)
      abb6(5)=spbe3k1*abb6(5)
      abb6(10)=-spbk3k1*abb6(10)
      abb6(5)=abb6(10)+abb6(5)+abb6(9)
      abb6(5)=4.0_ki/9.0_ki*abb6(5)
      abb6(6)=spae4k4*abb6(6)
      abb6(9)=-spbk5k1*abb6(14)
      abb6(10)=spbk2k1*abb6(4)
      abb6(6)=abb6(10)+abb6(9)+abb6(6)
      abb6(6)=16.0_ki/9.0_ki*abb6(6)
      abb6(9)=8.0_ki/9.0_ki*spbk4e4
      abb6(10)=abb6(14)*abb6(9)
      abb6(9)=-abb6(4)*abb6(9)
      abb6(16)=4.0_ki/9.0_ki*spbk3e3
      abb6(15)=abb6(15)*abb6(16)
      abb6(16)=abb6(14)*abb6(15)
      abb6(15)=-abb6(4)*abb6(15)
      abb6(17)=8.0_ki/9.0_ki*spbe4k1
      abb6(14)=abb6(14)*abb6(17)
      abb6(4)=-abb6(4)*abb6(17)
      R2d6=0.0_ki*(0.0_ki)
      rat2 = rat2 + R2d6
      if (debug_nlo_diagrams) then
          write (logfile,*) "<result name='r2' index='6' value='", &
          & R2d6, "'/>"
      end if
   end subroutine
end module ugaau_abbrevd6h8
